

/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

		ANSI X3.4 Compliant Terminal Emulation Module
*/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include "pckeys.h"

#define 	mTTY 	  0x00
#define 	mVT52 	  0x01
#define 	mVT102 	  0x02
#define 	mANSI 	  0x03
#define		mAVATAR   0x04
#define		mTEK4107C 0x05

#define 	FALSE 	0
#define 	TRUE   	(!FALSE)

extern char 		*buff;
extern int            	VTc;
extern int		VTr;
extern int		VTa;
extern int		VTwt;
extern int		VTwb;
extern int		VideoSeg;
extern int            	PrtFlag;
extern int		fc;
extern int		termCapOpen;
extern int		NUMLOCK;
extern int		LFON;
extern unsigned int	EmuMode;
extern unsigned int 	VidCols;

extern FILE		*toCap;

extern char 		CURRPT[10];



void ProcessANSI( int c );


/*-----------------------------------------------------------------------
------------------------------------------------------------------------*/

void ProcessANSI( int c )
{

	static int		TFlag = 0;
	static int		TFlag1 = 0;
	static int		TFp[10];
	static int 		i;
	static int		j;
	static int		atr;
	static int		SVTr;
	static int		SVTc;
	static int		SVTa;
	static unsigned char	clinec[80];
	static unsigned char	clinea[80];

	c &= 0x00ff;
	switch( TFlag )  {

		case 0:                            // Is TFlag = 0?

			if ( c == ESCAPE )  {
				for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
					TFp[TFlag1] = 0;
				TFlag = 1;
				TFlag1 = 0;
				return;
			}
			switch( c )  {

				case 0:				// NULLS not needed

					break;

				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:

					ScreenCharOut( '^' );
					ScreenCharOut( c + '@' );
					break;

				case 7:

					Beep( 300 );
					break;

				case 8:

					if ( VTc > 1 )
						VTc--;
					break;

				case 9:
							     // HT ^I
					for ( j = 0; j < 8; j++ )  {
						VTc++;
					}
					break;

				case 10:

					if ( ++VTr > VTwb )  {
						VTr--;
						ScrollWindowUp( 1 );
					}
					break;

				case 11:

					ScreenCharOut( c );
					break;

				case 12:
						  // Form Feed
					EraseScreen( VTwt, 1, VTwb, 80 );
					VTc = 1;
					VTr = 1;
					if ( ++VTr > VTwb )  {
						VTr--;
						ScrollWindowUp( 1 );
					}
					break;

				case 13:

					VTc = 1;
					if ( LFON )	{
						if (++VTr > VTwb)  {
							VTr--;
							ScrollWindowUp( 1 );
						}
						if (termCapOpen)
							fputc( '\r', toCap );
					}
					break;

				case 14:	// Set G1 Set
				case 15:        // Set G0 Set

					break;

				case 16:
				case 17:
				case 18:
				case 19:
				case 20:
				case 21:
				case 22:
				case 23:
				case 25:

					ScreenCharOut( '^' );
					ScreenCharOut( c + '@' );
					break;

				case 24:	// Cancel Sequence
				case 26:	// ""      ""

					TFlag = 0;
					break;

				case 27:

					for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
						TFp[TFlag1] = 0;
					TFlag = 1;
					TFlag1 = 0;
					return;

				case 28:
				case 29:
				case 30:
				case 31:

					ScreenCharOut( '^' );
					ScreenCharOut( c + '@' );
					break;

				default:

					ScreenCharOut( c );
					break;
			}
			break;

		case 1:                            // Is TFlag = 1?

			switch( c )  {

				case 24:                // Cancel Sequence
				case 26:

					TFlag = 0;
					break;

				case 27:

					return;

				case '[':

					TFlag = 2;
					TFlag1 = 0;
					return;

				case '|':	// Horiz. Tab with Just

					break;

				case '(':
				case ')':

					TFlag = 3;
					return;

				case 0x12:

					TFlag = 0;
					break;

				case 0x0D:

					VTc = 1;
					break;

				case 'D':	// Index

					if ( ++VTr > VTwb )  {
						VTr = VTwb;
						ScrollWindowUp( 1 );
					}
					break;

				case 'E':     	// Next Line

					VTc = 1;
					if ( ++VTr > VTwb )  {
						VTr = VTwb;
						ScrollWindowUp( 1 );
					}
					break;

				case 'F':	// Start of selected area

					break;

				case 'G':     	// End of Selected area

					break;

				case 'H':	// Horiz. Tab Set

					break;

				case 'L':	// Partial Line Down

					break;

				case 'K':	// Partial Line Up

					break;

				case 'M':	// Reverse Index

					if ( --VTr < VTwt )  {
						VTr = VTwt;
						ScrollWindowDown( 1 );
					}
					break;

				case 'U':	// Message Waiting

					break;

				case 'V':	// Start of protected area

					break;

				case 'W':     	// End of Protected area

					break;

				case 'Z':

					break;

				case 'c':
				case '=':
				case '>':

					break;

				case '7':

					SVTr = VTr;
					SVTc = VTc;
					SVTa = VTa;
					break;

				case '8':

					VTr = SVTr;
					VTc = SVTc;
					VTa = SVTa;
					break;

				case '#':

					TFlag = 4;
					return;

				default:

					ScreenCharOut( ESCAPE );
					ScreenCharOut( c );
					break;
			}
			TFlag = 0;
			break;

				// Escape Sequence Detected
		case 2:                     // Is TFlag = 2?

			switch( c )  {

				case '@':	// Insert Character

					break;

				case '|':	// Reset Mode

					break;

				case '\'':     	// Horiz. Pos Absolute

					break;

				case 'A':	// Cursor Up

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					while( TFp[0]-- > 0 )
						if ( VTr > VTwt )
							VTr--;
					break;

				case 'B':	// Cursor Down

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					while( TFp[0]-- > 0 )
						if ( VTr < VTwb )
							VTr++;
					break;

				case 'C':	// Cursor Foward

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					while( TFp[0]-- > 0 )
						if ( VTc < 80 )
							VTc++;
					break;

				case 'D':	// Cursor Backward

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					while( TFp[0]-- > 0 )
						if ( VTc > 1 )
							VTc--;
					break;

				case 'E':	// Cursor Next Line

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					while( TFp[0]-- > 0 )
						if ( VTr < VTwb )
							VTr++;

					break;

				case 'F':	// Cursor Preceding Line

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					while( TFp[0]-- > 0 )
						if ( VTr > VTwt )
							VTr--;
					break;

				case 'G':	// Cursor Horizontal Absolute

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					if ( TFp[0] > 80 )
						TFp[0] = 80;
					VTc = TFp[0];
					break;

				case 'f':     // Cursor Position (x,y)
				case 'H':

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					if ( TFp[1] == 0 )
						TFp[1] = 1;
					VTr = TFp[0];
					if ( VTr > 24 )
						VTr = 24;
					VTc = TFp[1];
					if ( VTc > 80 )
						VTc = 80;

					break;

				case 'J':	// Erase in Display

					switch( TFp[0] )  {

						case 0:		// from active position through end

							EraseScreen( VTr, VTc, VTwb, 80 );
							break;

						case 1:		// from start though active position

							EraseScreen( 1, 1, VTr, VTc );
							break;

						case 2:		// All of field

							EraseScreen( VTwt, 1, VTwb, 80 );
							VTr = VTwt;
							VTc = 1;
							break;
					}
					break;

				case 'K':	// Erase in line

					switch( TFp[0] )  {

						case 0:		// from active position through end

//							EraseScreen( VTr, VTc, VTr, 80 );

							fsfill( VTr, VTc, 1, ( 80 - VTc ), ' ', VTa );
							break;

						case 1:		// from start through active position

//							EraseScreen( VTr, 1, VTr, VTc );
							fsfill( VTr, 1, 1, VTc, ' ', VTa );
							break;

						case 2:		// All of Line

//							EraseScreen( VTr, 1, VTr, 80 );
							fsfill( VTr, 1, 1, 80, ' ', VTa );
							break;

					}
					break;

				case 'L':	// Insert Line

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					ScrollWindowDown( TFp[0] );
					break;

				case 'M':	// Delete Line

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					ScrollWindowUp( TFp[0] );
					break;

				case 'N':	// Erase in Field

					break;

				case 'O':	// Erase Area

					break;

				case 'P':		// Delete n chars to left

					if ( TFp[0] == 0 )
						TFp[0] = 1;

			// Must store entire current line of chars of the screen

					for ( i = 0; i < VidCols; i++ )	{
						clinec[i] = peekb( VideoSeg,( ( ( ( VTr - 1 ) * VidCols ) + ( i ) ) << 1 ) );
						clinea[i] = peekb( VideoSeg,( ( ( ( VTr - 1 ) * VidCols ) + ( i ) ) << 1 ) + 1 );
					}

					while( TFp[0]-- > 0 )	{
						if ( --VTc > 1 )	{
							for ( i = VTc; i < VidCols; i++ )	{
								clinec[i] = clinec[i+1];
								clinea[i] = clinea[i+1];
								clinec[79] = 32;
								clinea[79] = 0;
							}
//							ScreenCharOut( ' ' );
//							VTc--;

						}
					}

					for ( i = 0; i < VidCols; i++ )	{
						pokeb( VideoSeg,( ( ( ( VTr - 1 ) * VidCols ) + ( i ) ) << 1 ), clinec[i] );
						pokeb( VideoSeg,( ( ( ( VTr - 1 ) * VidCols ) + ( i ) ) << 1 ) + 1, clinea[i] );
					}
					gotoxy( VTc, VTr );

					break;

				case 'Q':		// Select Extent Mode

					break;

				case 'R':		// Cursor Report

					sprintf( buff, "\033[%d;%dR\0", VTr, VTc );
					SerialString( buff );
					break;

				case 'S':		// Scroll Up

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					ScrollPageUp( TFp[0] );
					break;

				case 'T':     		// Scroll Down

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					ScrollPageDown( TFp[0] );
					break;

				case 'U':     		// Next Page

					break;

				case 'V':		// Preceding Page

					break;

				case 'W':     		// Cursor Tab Control

					// 0 Set HT stop at active line
					// 1 Set VT stop at active position
					// 2 Clear HT at active position
					// 3 Clear VT at active line
					// 4 Clear all HT stops in line
					// 5 Clear all HT stops in device
					// 6 Clear all VT stops in device

					break;

				case 'X':		// Erase Character

					break;

				case 'Y':		// Cursor Vertical Tab

					break;

				case 'Z':		// Cursor Backward Tabulation

					break;

				case 'a':     		// Horiz. Pos. Relative

					break;

				case 'b':     		// Repeat char or control

					break;

				case 'c':		// Device Attributes

					SerialString( "\033[?6c\0" );
					break;

				case 'd':	// Vert. Pos. Absolute
				case 'e':	// Vert. Pos. Relative
				case 'g':	// Tab Clear
				case 'h':	// Select Mode
				case 'l':	// Cursor Horiz. Tab

					break;

				case 'i':

					switch( TFp[0] ) {

				  /* p1=0  print whole screen */

						case 0:

							break;

				  /* p1=4  exit transparent printer */

						case 4:

							PrtFlag = 0;
							break;

				  /* p1=5  enter transparent printer */

						case 5:

							PrtFlag = 2;
							break;
					}
					break;

				case 'm':

					i = 0;
					do	{
						switch( TFp[i] )	{

							case 0:

								VTa = 0x07;
								break;    // Reset to Normal

							case 1:

								VTa |= 0x08;
								break;    // High Colors On

							case 4:

								VTa = 0x70;
								break;    // Set Reverse Video

							case 7:

								VTa = 0x70;
								break;    // Set Reverse Video

							case 5:

								VTa |= 0x80;
								break;  // Set Blink Bit On

							case 2:	// Faint
							case 3: // Italic
							case 6: // Rapid Blink
							case 8: // Reserved
							case 9: // Reserved
							case 10: // Primary font as designated
								 // by < font selection >
							case 11: // first alt font
							case 12:
							case 13:
							case 14:
							case 15:
							case 16:
							case 17:
							case 18:
							case 19: // ninth alt font
							case 20: // Fraktur

								break;

							default:

								if ( TFp[i] >= 40 && TFp[i] <=47 )  {
									atr = TFp[i] - 40;
									switch( atr )  {

										case 1:

											atr = 0x04;
											break;

										case 3:

											atr = 0x06;
											break;

										case 4:

											atr = 0x01;
											break;

										case 6:

											atr = 0x03;
											break;

										default:

											break;
									}
									VTa=VTa & 0x8f | ( atr << 4 );
								/*	VTa=VTa & 0x87 | ((TFp[i] & 7) << 4);  */
								}
								else
								if ( TFp[i] >= 30 && TFp[i] <= 37 )  {
									atr = TFp[i] - 30;
									switch( atr )  {

										case 1:

											atr = 0x04;
											break;

										case 3:

											atr = 0x06;
											break;

										case 4:

											atr = 0x01;
											break;

										case 6:

											atr = 0x03;
											break;

										default:

											break;
									}
									VTa = ( VTa & 0xf8 ) | atr;
								/*	VTa=VTa & 0xf8 | (TFp[i] & 7); */
								}
								break;
						}
					      //	break;
					} while( ++i <= TFlag1 );
					break;

				case 'n':	// Cursor Report Request

					switch( TFp[0] )  {

						case 0:	// Ready
						case 1: // Busy-retry later
						case 2: // Busy DTR
						case 3: // Malfunction
						case 4: // Malfunction
						case 5: // Report status via DSR or DSC

							break;

						case 6: // Report status active cursor position

							sprintf( buff, CURRPT, VTr, VTc );
							SerialString( buff );
							break;

						default:

							break;
					}
					break;

				case 'o':	// Define Area Qualification

					// 0 Accept all input
					// 1 Accept no input (protected)
					//   do not xmit (guarded)
					// 2 Accept graphics
					// 3 Accept numerics
					// 4 Accept alpha
					// 5 Right justify
					// 6 Zero-fill
					// 7 HT at start of area
					// 8 Accept no input
					// 9 Space fill-in area

					break;

				case 'q':	//

					break;

				case 'r':

					if ( TFp[0] == 0 ) TFp[0] = 1;
					if ( TFp[1] == 0 ) TFp[1] = 24;
					if ( TFp[1] <= TFp[0] )
						break;
					VTwt = TFp[0];
					VTwb = TFp[1];
					if ( VTwb > 24 )
						VTwb = 24;
					break;

				case 's':
					SVTc = VTc;
					SVTr = VTr;
					break;

				case 'u':
					VTc = SVTc;
					VTr = SVTr;
					gotoxy( VTc, VTr );
					break;

				case 'x':

				case 'y':

					break;

				case '?':

					TFlag = 5;
					return;

				case ';':

					++TFlag1;
					return;

				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':

					TFp[TFlag1] *= 10;
					TFp[TFlag1] += ( c - '0' );
					return;
			}
			TFlag = 0;
			break;

		case 3:                          // Is TFlag = 3?

			TFlag = 0;
			break;

		case 4:

			TFlag = 0;
			break;

		case 5:

			switch( c )  {

				case 'h':

					TFlag = 0;
					break;

				case 'l':

					TFlag = 0;
					break;

				case 'i':

					switch( TFp[0] )	{

				    /* p1=1  print cursor line */

						case 1:

							break;

				    /* p1=4  exit printer echo */

						case 4:

							PrtFlag = 0;
							break;

				    /* p1=5  enter printer echo */

						case 5:

							PrtFlag = 1;
							break;
					}
					break;

				case ';':

					++TFlag1;
					return;

				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':

					TFp[TFlag1] *= 10;
					TFp[TFlag1] += ( c - '0' );
					return;
			}
			TFlag = 0;
			break;
	}
}

