
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			  All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <conio.h>

#define 	mTTY 	  0x00
#define 	mVT52 	  0x01
#define 	mVT102 	  0x02
#define 	mANSI 	  0x03
#define		mAVATAR   0x04
#define		mTEK4107C 0x05

#define 	FALSE 	0
#define 	TRUE   	(!FALSE)

#define vt52Id     	"\033/Z\0"              // VT52 Mode Ident String
#define vt102Id    	"\033[?6c\0"            // VT102 Mode Ident String
#define hth19      	"\033/K\0"              // Heath-19 Mode Ident String

static int			rplen = 0;

extern char 		CURRPT[10];                // Response to ESC[?6n

extern char 		*buff;
extern int            	VTc;
extern int		VTr;
extern int		VTa;
extern int		VTwt;
extern int		VTwb;
extern int            	PrtFlag;
extern int		fc;

extern int		NUMLOCK, LFON;
extern unsigned int	EmuMode;



void ProcessAVATAR( int c );
void aRepeatProcess( int c );

/*------------------------------------------------------------------------
  AVATAR Emulation Decode Module
-------------------------------------------------------------------------*/

void ProcessAVATAR( int c )
{
	static int		TFlag = 0;
	static int		rplen = 0;
	static int		rplcnt = 0;
	static int		rpcnt = 0;
	static int 		atr;
	static int 	       	lc;
	static int		rw;
	static int		cl;
	static int		i;
	static int		j;
	static int		savch;
	static int		rws;
	static int		cls;

	static unsigned char rp[80] = "\0";

	c &= 0x00ff;

	switch( TFlag )  {

		case 0:

			switch( c )  {

				case 0:			// NULL
				case 1:			// ^A
				case 2:			// ^B
				case 3:                 // ^C
				case 4:                 // ^D
				case 5:                 // ^E
				case 6:                 // ^F

					break;

				case 7:                 // ^G

					Beep( 200 );
					break;

				case 8:			// ^H

					if ( VTc > 1 )  {
						VTc--;
					}
					break;

				case 9:                 // ^I

					break;

				case 10:                // ^J

					if ( ++VTr > VTwb )  {
						VTr--;
						ScrollWindowUp( 1 );
					}
					break;

				case 11:		// ^K

					break;

				case 12:           	// ^L

					VTa = 0x03;
//					EraseScreen( VTwt, 1, VTwb, 80 );

					fsfill( VTwt, 1, VTwb, 80, ' ', VTa );

					VTc = 1;
					VTr = VTwt;
					break;

				case 13:

					VTc = 1;         // ^M
//					if ( LFON )	{
//						if ( ++VTr > VTwb )  {
//							VTr--;
//							ScrollWindowUp( 1 );
//						}
//					}
					break;

				case 14:		// ^N
				case 15:		// ^O
				case 16:		// ^P
				case 17:		// ^Q
				case 18:		// ^R
				case 19:		// ^S
				case 20:		// ^T
				case 21:		// ^U

					break;

				case 22:		// ^V  Screen Handling

					TFlag = 1;
					return;

				case 23:		// ^W
				case 24:		// ^X

					break;

				case 25:		// ^Y Repeat bytes

					TFlag = 2;
					return;

				case 26:		// ^Z

					break;

				case 27:		// ESC

					TFlag = 8;
					return;

				case 28:		// FS
				case 29:		// GS
				case 30:		// RS
				case 31:		// US

					break;

				default:

					ScreenCharOut( c );
					break;
			}
			break;

		case 1: 				// ^V detected

			switch(c)  {

				case 0:

					break;

				case 1:       	   	// ^V^A Set Color Attr

					TFlag = 4;
					return;

				case 2:         	// ^V^B Turn on Blink

					VTa |= 0x80;
					break;

				case 3:			// ^V^C Move cur up

					if ( VTr > VTwt )  {
						VTr--;
					}
					break;

				case 4:			// ^V^D move cur down

					if ( VTr < VTwb )  {
						VTr++;
					}
					break;

				case 5:			// ^V^E move cur left

					if ( VTc > 1 )  {
						VTc--;
					}
					break;

				case 6:			// ^V^F move cur right

					if ( VTc < 80 )  {
						VTc++;
					}
					break;

				case 7:			// ^V^G clear eol

//					EraseScreen( VTr, VTc, 1, 80 - VTc );
					fsfill( VTr, VTc, 1, ( 80 - VTc ), ' ', VTa );
					break;

				case 8:			// ^V^H goto <row><col>

					TFlag = 5;
					return;

				case 9:
				case 10:
				case 11:

					break;

				case 12:


					TFlag = 14;	// ^V ^L
					return;

				case 13:		// ^V^M<a><b><c><d>

					TFlag = 10;
					return;

				case 14:		// ^V^N
				case 15:		// ^V^O
				case 16:		// ^V^P
				case 17:		// ^V^Q
				case 18:		// ^V^R
				case 19:		// ^V^S
				case 20:		// ^V^T
				case 21:		// ^V^U
				case 22:		// ^V^V
				case 23:		// ^V^W
				case 24:		// ^V^X

					break;

				case 25:		// ^V^Y ( Repeat Pattern )

					TFlag = 17;
					return;



				case 26:
				case 27:
				case 28:
				case 29:
				case 30:
				case 31:
				case ' ':		// ^V[SP] Reserved
				case '!':		// ^V!
				case '"':
				case '#':
				case '$':
				case '%':
				case '&':
				case 39:
				case '(':
				case ')':
				case '*':
				case '+':
				case ',':
				case '-':
				case '.':
				case '/':

					break;

				case '0':

					TFlag = 7;
					return;

				case '1':
				case ':':
				case '<':
				case '=':
				case '>':
				case '?':

					break;

				default:

					ScreenCharOut( '^' );
					ScreenCharOut( c );
					break;
			}
			break;

		case 2:				// character to repeat

			savch = c;
			TFlag = 3;
			return;

		case 3:				// times to repeat.

			lc = c;
			if ( savch == 0x08 )	{	// Trap backspace
				for ( i = 0; i < lc; i++ )	{
					if ( VTc > 1 )
						VTc--;
				}
			}
			else	{
				for ( i = 0; i < lc; i++ )
					ScreenCharOut( savch );
			}
			break;

		case 4:				// Change Current Attrib.

			VTa = c;
			break;

		case 5:				// setting row

			rw = c;
			TFlag = 6;
			return;

		case 6:				// setting col

			VTr = rw;
			if ( ( VTr > 24 ) || ( VTr < 1 ) )
				VTr = 1;
			VTc = c;
			if ( ( VTc > 80 ) || ( VTc < 1 ) )
				VTc = 1;
			break;

		case 7:

			fsattr( VTr, VTc, 1,( 80 - VTc ), c );
			break;

		case 8:

			switch( c )  {

				case '[':

					TFlag = 9;
					return;

				default:

					break;
			}
			break;

		case 9:

			switch( c )  {

				case 'K':

//					EraseScreen( VTr, VTc, VTwb, 80 );

					fsfill( VTr, VTc, VTwb, 80, ' ', VTc );

					break;

				default:

					break;
			}
			break;

		case 10:

			atr = c;
			TFlag = 11;
			return;

		case 11:

			fc = c;
			TFlag = 12;
			return;

		case 12:

			rw = c;
			TFlag = 13;
			return;

		case 13:

			cl = c;
			VTa = atr;

			if ( ( VTr + rw ) > 24 )
				rw = ( 24 - VTr );

			fsfill( VTr, VTc, rw, cl, fc, atr );
			break;

		case 14:       // ^V ^L <a> <b> <c>

			rws = c;
			TFlag = 15;
			return;

		case 15:

			cls = c;
			TFlag = 16;
			return;

		case 16:

			VTa = c;
//			EraseScreen( VTr, VTc, rws, cls );

			if ((VTr + rws) > 24 )

				rws = ( 24 - VTr );

			fsfill( VTr, VTc, rws, cls, ' ', VTa );

			break;

		case 17:


			rplen = c;

			rplcnt = rplen;

			i = 0;

			TFlag = 18;

			return;

		case 18:

			if ( rplcnt-- > 0 )	{

				rp[i++] = c;

				return;
			}

			else	{

				rpcnt = c;

				for ( i = 0; i < rpcnt; i++ )	{

					for ( j = 0; j < rplen; j++ )	{

						aRepeatProcess( rp[ j ] );

					}
				}


			}
			break;

		default:

			break;
	}
	TFlag = 0;
}



void aRepeatProcess( int c )
{
	static int		rFlag = 0;
	static int 		atr;
	static int 	       	lc;
	static int		rw;
	static int		cl;
	static int		i;
	static int		savch;
	static int		rws;
	static int		cls;

	c &= 0x00ff;

	switch( rFlag )  {

		case 0:

			switch( c )  {

				case 0:			// NULL
				case 1:			// ^A
				case 2:			// ^B
				case 3:                 // ^C
				case 4:                 // ^D
				case 5:                 // ^E
				case 6:                 // ^F

					break;

				case 7:                 // ^G

					Beep( 200 );
					break;

				case 8:			// ^H

					if ( VTc > 1 )  {
						VTc--;
					}
					break;

				case 9:                 // ^I

					break;

				case 10:                // ^J

					if ( ++VTr > VTwb )  {
						VTr--;
						ScrollWindowUp( 1 );
					}
					break;

				case 11:		// ^K

					break;

				case 12:           	// ^L

					VTa = 0x03;
//					EraseScreen( VTwt, 1, VTwb, 80 );

					fsfill( VTwt, 1, VTwb, 80, ' ', VTa );

					VTc = 1;
					VTr = VTwt;
					break;

				case 13:

					VTc = 1;         // ^M
//					if ( LFON )	{
//						if ( ++VTr > VTwb )  {
//							VTr--;
//							ScrollWindowUp( 1 );
//						}
//					}
					break;

				case 14:		// ^N
				case 15:		// ^O
				case 16:		// ^P
				case 17:		// ^Q
				case 18:		// ^R
				case 19:		// ^S
				case 20:		// ^T
				case 21:		// ^U

					break;

				case 22:		// ^V  Screen Handling

					rFlag = 1;
					return;

				case 23:		// ^W
				case 24:		// ^X

					break;

				case 25:		// ^Y Repeat bytes

					rFlag = 2;
					return;

				case 26:		// ^Z

					break;

				case 27:		// ESC

					rFlag = 8;
					return;

				case 28:		// FS
				case 29:		// GS
				case 30:		// RS
				case 31:		// US

					break;

				default:

					ScreenCharOut( c );
					break;
			}
			break;

		case 1: 				// ^V detected

			switch(c)  {

				case 0:

					break;

				case 1:       	   	// ^V^A Set Color Attr

					rFlag = 4;
					return;

				case 2:         	// ^V^B Turn on Blink

					VTa |= 0x80;
					break;

				case 3:			// ^V^C Move cur up

					if ( VTr > VTwt )  {
						VTr--;
					}
					break;

				case 4:			// ^V^D move cur down

					if ( VTr < VTwb )  {
						VTr++;
					}
					break;

				case 5:			// ^V^E move cur left

					if ( VTc > 1 )  {
						VTc--;
					}
					break;

				case 6:			// ^V^F move cur right

					if ( VTc < 80 )  {
						VTc++;
					}
					break;

				case 7:			// ^V^G clear eol

//					EraseScreen( VTr, VTc, 1, 80 - VTc );
					fsfill( VTr, VTc, 1, ( 80 - VTc ), ' ', VTa );
					break;

				case 8:			// ^V^H goto <row><col>

					rFlag = 5;
					return;

				case 9:
				case 10:
				case 11:

					break;

				case 12:


					rFlag = 14;	// ^V ^L
					return;

				case 13:		// ^V^M<a><b><c><d>

					rFlag = 10;
					return;

				case 14:		// ^V^N
				case 15:		// ^V^O
				case 16:		// ^V^P
				case 17:		// ^V^Q
				case 18:		// ^V^R
				case 19:		// ^V^S
				case 20:		// ^V^T
				case 21:		// ^V^U
				case 22:		// ^V^V
				case 23:		// ^V^W
				case 24:		// ^V^X

					break;

				case 25:		// ^V^Y ( Repeat Pattern )

					break;



				case 26:
				case 27:
				case 28:
				case 29:
				case 30:
				case 31:
				case ' ':		// ^V[SP] Reserved
				case '!':		// ^V!
				case '"':
				case '#':
				case '$':
				case '%':
				case '&':
				case 39:
				case '(':
				case ')':
				case '*':
				case '+':
				case ',':
				case '-':
				case '.':
				case '/':

					break;

				case '0':

					rFlag = 7;
					return;

				case '1':
				case ':':
				case '<':
				case '=':
				case '>':
				case '?':

					break;

				default:

					ScreenCharOut( '^' );
					ScreenCharOut( c );
					break;
			}
			break;

		case 2:				// character to repeat

			savch = c;
			rFlag = 3;
			return;

		case 3:				// times to repeat.

			lc = c;
			if ( savch == 0x08 )	{	// Trap backspace
				for ( i = 0; i < lc; i++ )	{
					if ( VTc > 1 )
						VTc--;
				}
			}
			else	{
				for ( i = 0; i < lc; i++ )
					ScreenCharOut( savch );
			}
			break;

		case 4:				// Change Current Attrib.

			VTa = c;
			break;

		case 5:				// setting row

			rw = c;
			rFlag = 6;
			return;

		case 6:				// setting col

			VTr = rw;
			if ( ( VTr > 24 ) || ( VTr < 1 ) )
				VTr = 1;
			VTc = c;
			if ( ( VTc > 80 ) || ( VTc < 1 ) )
				VTc = 1;
			break;

		case 7:

			fsattr( VTr, VTc, 1,( 80 - VTc ), c );
			break;

		case 8:

			switch( c )  {

				case '[':

					rFlag = 9;
					return;

				default:

					break;
			}
			break;

		case 9:

			switch( c )  {

				case 'K':

//					EraseScreen( VTr, VTc, VTwb, 80 );

					fsfill( VTr, VTc, VTwb, 80, ' ', VTc );

					break;

				default:

					break;
			}
			break;

		case 10:

			atr = c;
			rFlag = 11;
			return;

		case 11:

			fc = c;
			rFlag = 12;
			return;

		case 12:

			rw = c;
			rFlag = 13;
			return;

		case 13:

			cl = c;
			VTa = atr;

			if ( ( VTr + rw ) > 24 )
				rw = ( 24 - VTr );

			fsfill( VTr, VTc, rw, cl, fc, atr );
			break;

		case 14:       // ^V ^L <a> <b> <c>

			rws = c;
			rFlag = 15;
			return;

		case 15:

			cls = c;
			rFlag = 16;
			return;

		case 16:

			VTa = c;
//			EraseScreen( VTr, VTc, rws, cls );

			if ((VTr + rws) > 24 )

				rws = ( 24 - VTr );

			fsfill( VTr, VTc, rws, cls, ' ', VTa );

			break;


		default:

			break;
	}
	rFlag = 0;
}

