
  /**************************************************************
    An example of using a mouse event handler.
  **************************************************************/
  #include <stdio.h>
  #include <conio.h>
  #include <dos.h>

  #define  MOUSEINT  geninterrupt( 0x33 )

  /*-- mouse event masks (use with M_event) --*/
  #define  MOUSEMOVE      0x01        /* Use, for example:     */
  #define  L_PRESS        0x02       /* L_PRESS | MOUSEMOVE  */
  #define  L_RELEASE      0x04
  #define  R_PRESS        0x08
  #define  R_RELEASE      0x10

  /*-- mouse button status macros --*/
  #define  L_DOWN         ( M_buttonstatus & 0x01 )
  #define  R_DOWN         ( M_buttonstatus & 0x02 )

  #define  HANDLER_EXIT_PROCESSING()  \
   __emit__( (unsigned char) 0x5D,  \
             (unsigned char) 0x5F,  \
             (unsigned char) 0x5E,  \
             (unsigned char) 0x1F,  \
             (unsigned char) 0x07,  \
             (unsigned char) 0x5A,  \
             (unsigned char) 0x59,  \
             (unsigned char) 0x5B,  \
             (unsigned char) 0x58,  \
             (unsigned char) 0xCB  ) ;
  #if 0
  -------------------------------------------
  The above emitted code is equivalent to the
  following assembler code (but does not
  require the -B compiling option):
c         asm  pop   bp    ;
         asm  pop   di    ;
         asm  pop   si    ;
         asm  pop   ds    ;
         asm  pop   es    ;     /* interrupt exit processing */
         asm  pop   dx    ;
         asm  pop   cx    ;
         asm  pop   bx    ;
         asm  pop   ax    ;
         asm  retf        ;     /* far return */
  --------------------------------------------
  #endif

  /*--Global mouse status variables --*/
  int  M_xpos, M_ypos,         /* cursor location */
       M_buttonstatus,         /* bits 0-2 ON if button is down */
       M_eventcount,           /* # of times event has occurred */
       M_event ;               /* flags a mouse event */

  /*-- Reset mouse -- returns # of buttons or 0 if problems --*/
  int Mreset( void )
  {
   _AX = 0 ;
   MOUSEINT ;
   return( _AX  ?  _BX  : _AX ) ;
  }

  /*-- Show mouse cursor --*/
  void Mshow( void )
  {
   _AX = 1 ;
   MOUSEINT ;

  }

  /*-- Hide mouse cursor --*/
  void Mhide( void )
  {
   _AX = 2 ;
   MOUSEINT ;
  }

  /*-- Put Mouse --*/

  void PutMouseAt(int x, int y)
  {
	_AX = 4;
	_CX = x;
	_DX = y;
	MOUSEINT;
  }

  /*-- Get mouse position and button status --*/
  void Mpos( void )
  {
   _AX = 3 ;
   MOUSEINT ;
   M_xpos = _CX ;
   M_ypos = _DX ;
   M_buttonstatus = _BX ;
  }


  /*-- Installs mouse handler --*/
  void Minsthandler( unsigned mask, void interrupt far (*fn)(void) )
  {
   union REGS   reg ;
   struct SREGS seg ;
   reg.x.ax = 20 ;      /* mouse fn. 20 -- replaces fn. 12 */
   reg.x.cx = mask ;
   reg.x.dx = FP_OFF( fn ) ;
   seg.es = FP_SEG( fn ) ;
   int86x( 0x33, &reg, &reg, &seg ) ;
  }

  /*---------------------------------------------------------
   This mouse event handler simply updates mouse information.
  ----------------------------------------------------------*/
  void interrupt far mousehandler( void )
  {
   M_event = _AX ;
   M_buttonstatus = _BX ;
   M_xpos = _CX ;
   M_ypos = _DX ;
   __emit__( (unsigned char) 0x5D,  \
             (unsigned char) 0x5F,  \
             (unsigned char) 0x5E,  \
             (unsigned char) 0x1F,  \
             (unsigned char) 0x07,  \
             (unsigned char) 0x5A,  \
             (unsigned char) 0x59,  \
             (unsigned char) 0x5B,  \
             (unsigned char) 0x58,  \
	     (unsigned char) 0xCB  ) ;
/*   HANDLER_EXIT_PROCESSING() ; */
  }

  /*----------------------------------------------------
   Demonstrate mouse tracking via mouse event handler.
  ----------------------------------------------------*/
int TurnOnMouse()
{
	if( !Mreset() ) {
		return(0) ;
	}

	Minsthandler( MOUSEMOVE|L_PRESS|L_RELEASE|R_PRESS|R_RELEASE,
		mousehandler ) ;
	M_event = 0 ;
/*	Mshow() ; */
	return(1);

}


void TurnOffMouse()
{
   Mhide() ;
   Mreset() ;
}






















