/*----------------------------------------------------------------------
 *  b u f i l l
 *  
 *  Get a bufferful of data from the file that's being sent.
 *  Only control-quoting is done; 8-bit & repeat count prefixes are 
 *  not handled.
 *--------------------------------------------------------------------*/

int bufillold(char buffer[])
{
    int i,				/* Loop index */  
	t;				/* Char read from file */
    char t7;				/* 7-bit version of above */

    i = 0;				/* Init data buffer pointer */
    while((t = getc(kfp)) != EOF)	/* Get the next character */
    {   
	t7 = t & 0177;			/* Get low order 7 bits */

	if(t > 0x7f || t == qbin) {	/* transmit binary */
		buffer[i++] = qbin;	/* Quote the character */ 
		if(t == qbin) {
			buffer[i++] = quote;  
			t = qbin;	/* must be a valid character */
		}
		t &= 0177;
	}
	if (t < SP || t==DEL || t==quote) /* Does char require */  
	{				    /* special handling? */   
	    buffer[i++] = quote;	/* Quote the character */ 
	    if (t7 != quote)   
	    {  
		t = ctl(t);		/* and uncontrolify */   
		t7 = ctl(t7); 
	    }  
	}  
	if (image) 
	    buffer[i++] = t;		/* Deposit the character itself */   
	else   
	    buffer[i++] = t7;  

	if (i >= spsiz-8) return(i);	/* Check length */
    }   
    if (i==0) return(EOF);		/* Wind up here only on EOF */  
    return(i);				/* Handle partial buffer */   
}   
