#include <stdio.h>
#include <alloc.h>

unsigned short poly = 0xA001;
unsigned short accum;

unsigned short calccrc(int data, unsigned short poly,
			unsigned short accum);
void main()
{
	FILE	*log;
	unsigned short	*crctp;
	int i,j,k;

	log=fopen("crc16.h","w");
	if (!log)
		exit(0);
	fprintf(log,"/*  CRC-16 Polynomial */ \n\n");
	fprintf(log,"unsigned short crctab16[256] = {\n");
	if ((crctp = (unsigned short *)malloc(256 * sizeof(unsigned))) == NULL)	{
		printf("no memory\n");
		exit(1);
	}
	for (i=0;i<256;i++)	{
		crctp[i] = calccrc(i, poly, 0);
	}
	k=0;
	for (i=0;i<32;i++)	{
		fprintf(log,"       ");
		for (j=0;j<8;j++)	{
			fprintf(log,"0x%04x, ",crctp[k++]);
		}
		fprintf(log,"\n");
	}
	fprintf(log,"};\n");
	fclose(log);

}

unsigned short calccrc(int data, unsigned short poly, unsigned short accum)
{
	static int 	i;

	data <<= 1;
	for (i=8;i>0;i--)	{
		data >>= 1;
		if ((data ^ accum) & 0x0001)
			accum = (accum >> 1) ^ poly;
		else
			accum >>= 1;
/*		data <<= 1; */
	}
	return(accum);
}


