
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			  All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include "pckeys.h"
#include "vtstrngs.h"
#include "anstring.h"
#include "fsvlib.h"

#define 		ESC 		0x1B
#define 		mTTY 	  	0x00
#define 		mVT52 	  	0x01
#define 		mVT102 	  	0x02
#define 		mANSI 	  	0x03
#define			mAVATAR   	0x04
#define			mTEK4107C 	0x05

#define 		FALSE 		0
#define 		TRUE   		(!FALSE)


extern char 		*buff;
extern char 		vt102SU[10];
extern int            	VTc, VTr, VTa, VTwt, VTwb;
extern int		NUMLOCK, INSMODE, VIPHIDE;
extern int		termCapOpen;
extern unsigned int	EmuMode;

extern FILE		*toCap;


void EraseScreen( int x1, int y1, int x2, int y2 );
void ScrollWindowUp( int x );
void ScrollWindowDown( int x );
void ScrollPageUp( int x );
void ScrollPageDown( int x );
void ScreenCharOut( int c );
void ToggleNumLock( int Mode );
void VT102SKeys( int k );
void ANSIKeys( int k );
void ANSITab( void );
void VT102Tab( void );
void Tek4107SKeys( int k );
void Tek4107Tab( void );
void I3101SKeys( int k );
void I3101Tab( void );

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void ScreenCharOut( int c )
{
	c &= 0xff;
	if ( VTc > 80 )  {
		VTc = 1;
		if ( VTwb >= VTr )
			if ( ++VTr > VTwb )  {
				VTr--;
				ScrollWindowUp( 1 );
			}
	}
	if ( termCapOpen )
		fputc( c, toCap );

	if ( VIPHIDE )
		fswchar( c, VTr, VTc, 0x00 );
	else
		fswchar( c, VTr, VTc, VTa );
	++VTc;
}

/*------------------------------------------------------------------------
  Function to scroll terminal screen up 1 line.
-------------------------------------------------------------------------*/

void ScrollWindowUp( int x )
{
	union REGS xr;

	xr.h.ah = 6;
	xr.h.al = x;
	xr.h.bh = VTa;
	xr.h.ch = VTwt - 1;
	xr.h.cl = 0;
	xr.h.dh = VTr - 1;
	xr.h.dl = 79;
	int86( 0x10, &xr, &xr );
}

/*------------------------------------------------------------------------
	Function to scroll terminal screen down 1 line.
-------------------------------------------------------------------------*/

void ScrollWindowDown( int x )
{
	union REGS xr;

	xr.h.ah=7;
	xr.h.al=x;
	xr.h.bh=VTa;
	xr.h.ch=VTr-1;
	xr.h.cl=0;
	xr.h.dh=VTwb-1;
	xr.h.dl=79;
	int86(0x10,&xr,&xr);
}

void ScrollPageUp( int x )
{
	union REGS xr;

	xr.h.ah = 6;
	xr.h.al = x;
	xr.h.bh = VTa;
	xr.h.ch = VTwt - 1;
	xr.h.cl = 0;
	xr.h.dh = VTwb - 1;
	xr.h.dl = 79;
	int86( 0x10, &xr, &xr );
}

/*------------------------------------------------------------------------
	Function to scroll terminal screen down 1 line.
-------------------------------------------------------------------------*/

void ScrollPageDown( int x )
{
	union REGS xr;

	xr.h.ah=7;
	xr.h.al=x;
	xr.h.bh=VTa;
	xr.h.ch=VTwt-1;
	xr.h.cl=0;
	xr.h.dh=VTwb-1;
	xr.h.dl=79;
	int86(0x10,&xr,&xr);
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void EraseScreen(int x1,int y1,int x2,int y2)
{
	int 	t1;
	int	t2;
	int	i;

	t1 = ( ( ( ( x1 - 1 ) * 80 ) + ( y1 - 1 ) ) << 1 );
	t2 = ( ( ( ( x2 - 1 ) * 80 ) + ( y2 - 1 ) ) << 1 );
	for ( i = t1; i <= t2; i += 2 ) {
		pokeb( VideoSeg, i, 32 );
		pokeb( VideoSeg, i+1, VTa );
	}
}

/*------------------------------------------------------------------------
	Function to toggle numlock on or off.  This function is
	executed by request of the HOST ESC= or ESC> combination.
-------------------------------------------------------------------------*/

void ToggleNumLock(int mode)
{
	int 	keyin;
	int	KeybSeg = 0x0040;

	keyin = peekb( KeybSeg, 0x0017);
	if (mode == 0)  {
		pokeb( KeybSeg, 0x0017, ( keyin & 0xDF ) );
		NUMLOCK = FALSE;
	}
	else
	if (mode == 1)  {
		pokeb( KeybSeg, 0x0017, ( keyin | 0x20 ) );
		NUMLOCK = TRUE;
	}
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void VT102SKeys(int k)
{
	switch(k)  {
		case F1:  SerialString(vtPFK01); break;
		case F2:  SerialString(vtPFK02); break;
		case F3:  SerialString(vtPFK03); break;
		case F4:  SerialString(vtPFK04); break;
		case F5:  SerialString(vtPFK05); break;
		case F6:  SerialString(vtPFK06); break;
		case F7:  SerialString(vtPFK07); break;
		case F8:  SerialString(vtPFK08); break;
		case F9:  SerialString(vtPFK09); break;
		case F10: SerialString(vtPFK10); break;
		case F11: SerialString(vtPFK11); break;
		case F12: SerialString(vtPFK12); break;
		case PGDN: SerialString(vtPA2); break;
		case UP: SerialString(vtUP); break;
		case DN: SerialString(vtDN); break;
		case LEFT: SerialString(vtLEFT); break;
		case RIGHT: SerialString(vtRIGHT); break;
		case END: SerialString(vtEEOF); break;
		case DELETE: SerialString(vtDEL); break;
		case HOME:  SerialString("\033OS\0"); break;
		case INS:
			SerialString(vtINS);
			if (INSMODE)  {
				fswrite("   ",25,68,Black+LightGrayBG);
					INSMODE = FALSE;
			}
			else  {
				fswrite("INS",25,68,Yellow+BlueBG);
				INSMODE = TRUE;
			}
			break;
		case STAB: SerialString(vtFBTAB); break;
		case CTLLEFT: SerialString(vtWBTAB); break;
		case CTLRIGHT: SerialString(vtWTAB); break;
		case CTLDEL: SerialString(vtWDEL); break;
		case F13: SerialString(vtPFK13); break;
		case F14: SerialString(vtPFK14); break;
		case F15: SerialString(vtPFK15); break;
		case F16: SerialString(vtPFK16); break;
		case F17: SerialString(vtPFK17); break;
		case F18: SerialString(vtPFK18); break;
		case F19: SerialString(vtPFK19); break;
		case F20: SerialString(vtPFK20); break;
		case F21: SerialString(vtPFK21); break;
		case F22: SerialString(vtPFK22); break;
		case F23: SerialString(vtPFK23); break;
		case F24: SerialString(vtPFK24); break;
		default: break;
	}
	return;
}


void ANSIKeys(int k)
{
	switch(k)  {
		case F1:  SerialString(anF01); break;
		case F2:  SerialString(anF02); break;
		case F3:  SerialString(anF03); break;
		case F4:  SerialString(anF04); break;
		case F5:  SerialString(anF05); break;
		case F6:  SerialString(anF06); break;
		case F7:  SerialString(anF07); break;
		case F8:  SerialString(anF08); break;
		case F9:  SerialString(anF09); break;
		case F10: SerialString(anF10); break;
		case F11: SerialString(anF11); break;
		case F12: SerialString(anF12); break;

		case F13:  SerialString(anSF01); break;
		case F14:  SerialString(anSF02); break;
		case F15:  SerialString(anSF03); break;
		case F16:  SerialString(anSF04); break;
		case F17:  SerialString(anSF05); break;
		case F18:  SerialString(anSF06); break;
		case F19:  SerialString(anSF07); break;
		case F20:  SerialString(anSF08); break;
		case F21:  SerialString(anSF09); break;
		case F22: SerialString(anSF10); break;
		case F23: SerialString(anSF11); break;
		case F24: SerialString(anSF12); break;

		case PGDN: SerialString(anPGDOWN); break;
		case PGUP: SerialString(anPGUP); break;
		case UP: SerialString(anUP); break;
		case DN: SerialString(anDN); break;
		case LEFT: SerialString(anLEFT); break;
		case RIGHT: SerialString(anRIGHT); break;
		case END: SerialString(anEND); break;
		case HOME:  SerialString(anHOME); break;
		case INS:
			SerialString(anINS);
			if (INSMODE)  {
				fswrite("   ",25,68,Black+LightGrayBG);
					INSMODE = FALSE;
			}
			else  {
				fswrite("INS",25,68,Yellow+BlueBG);
				INSMODE = TRUE;
			}
			break;
		default:
			break;
	}
	return;
}

void ANSITab()
{
	while( SerialOut( 0x09 ) == -1 );
}
/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void VT102Tab()
{
	  SerialString(vtFTAB);
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void Tek4107SKeys(int k)
{
	switch(k)  {
		case F1:  SerialString(vtPFK01); break;
		case F2:  SerialString(vtPFK02); break;
		case F3:  SerialString(vtPFK03); break;
		case F4:  SerialString(vtPFK04); break;
		case F5:  SerialString(vtPFK05); break;
		case F6:  SerialString(vtPFK06); break;
		case F7:  SerialString(vtPFK07); break;
		case F8:  SerialString(vtPFK08); break;
		case F9:  SerialString(vtPFK09); break;
		case F10: SerialString(vtPFK10); break;
		case F11: SerialString(vtPFK11); break;
		case F12: SerialString(vtPFK12); break;
		case PGDN: SerialString(vtPA2); break;
		case UP: SerialString(vtUP); break;
		case DN: SerialString(vtDN); break;
		case LEFT: SerialString(vtLEFT); break;
		case RIGHT: SerialString(vtRIGHT); break;
		case END: SerialString(vtEEOF); break;
		case DELETE: SerialString(vtDEL); break;

		case INS:
			SerialString(vtINS);
			if (INSMODE)  {
				fswrite("   ",25,68,Black+LightGrayBG);
					INSMODE = FALSE;
			}
			else  {
				fswrite("INS",25,75,Yellow+BlueBG);
				INSMODE = TRUE;
			}
			break;
		case STAB: SerialString(TekBTab); break;
		case CTLLEFT: SerialString(vtWBTAB); break;
		case CTLRIGHT: SerialString(vtWTAB); break;
		case CTLDEL: SerialString(vtWDEL); break;
		case F13: SerialString(vtPFK13); break;
		case F14: SerialString(vtPFK14); break;
		case F15: SerialString(vtPFK15); break;
		case F16: SerialString(vtPFK16); break;
		case F17: SerialString(vtPFK17); break;
		case F18: SerialString(vtPFK18); break;
		case F19: SerialString(vtPFK19); break;
		case F20: SerialString(vtPFK20); break;
		case F21: SerialString(vtPFK21); break;
		case F22: SerialString(vtPFK22); break;
		case F23: SerialString(vtPFK23); break;
		case F24: SerialString(vtPFK24); break;
		default: break;
	}
	return;
}


void Tek4107Tab()
{
	  SerialString(TekTab);
}

void I3101SKeys(int k)
{
	switch(k)  {
		case F1:  SerialString("\033J1\0"); break;
		case F2:  SerialString("\033J2\0"); break;
		case F3:  SerialString("\033J3\0"); break;
		case F4:  SerialString("\033J4\0"); break;
		case F5:  SerialString("\033J5\0"); break;
		case F6:  SerialString("\033J6\0"); break;
		case F7:  SerialString("\033J7\0"); break;
		case F8:  SerialString("\033J8\0"); break;
		case F9:  SerialString("\033J9\0"); break;
		case F10: SerialString("\033J0\0"); break;
		case F11: SerialString("\033J-\0"); break;
		case F12: SerialString("\033J=\0"); break;
		case PGDN: SerialString("\033J.\0"); break;
		case UP: SerialString("\033A\0"); break;
		case DN: SerialString("\033B\0"); break;
		case LEFT: SerialString("\033D\0"); break;
		case RIGHT: SerialString("\033C\0"); break;
		case END: SerialString("\033I\0"); break;
		case DELETE: SerialString("\177\0"); break;
		case HOME:  SerialString("\033L\0"); break;
		case INS:
			SerialString("\033J\177\0");
			if (INSMODE)  {
				fswrite("   ",25,68,Black+LightGrayBG);
					INSMODE = FALSE;
			}
			else  {
				fswrite("INS",25,68,Yellow+BlueBG);
				INSMODE = TRUE;
			}
			break;
		case STAB: SerialString("\033J\011\0"); break;
		case CTLLEFT: SerialString("\033\033D\0"); break;
		case CTLRIGHT: SerialString("\033\033C\0"); break;
		case CTLDEL: SerialString("\033\177\0"); break;
		case F13: SerialString("\033J!\0"); break;
		case F14: SerialString("\033J@\0"); break;
		case F15: SerialString("\033J#\0"); break;
		case F16: SerialString("\033J$\0"); break;
		case F17: SerialString("\033Jt\0"); break;
		case F18: SerialString("\033Jy\0"); break;
		case F19: SerialString("\033Ju\0"); break;
		case F20: SerialString("\033Ji\0"); break;
		case F21: SerialString("\033Jo\0"); break;
		case F22: SerialString("\033Jp\0"); break;
		case F23: SerialString("\033J_\0"); break;
		case F24: SerialString("\033J+\0"); break;
		default: break;
	}
	return;
}

void I3101Tab()
{
	  SerialString("\011\0");
}

