
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <io.h>
#include <share.h>
#include <dos.h>
#include <signal.h>
#include <setjmp.h>
#include <sys\types.h>
#include <sys\stat.h>

#include "pckeys.h"
#include "fsvlib.h"
#include "mouse.h"

#define FALSE 0
#define TRUE (!FALSE)
#define MSR	6
#define DCD	0x80
#define MCR	4
#define RTS	0x01

extern char 		*buff;
extern char 		*pp;
extern char		*p;
extern int 		ECHOON;
extern int		PRECCHG;
extern int		LFON;
extern int		VIP;
extern int		CARRIERON;
extern unsigned int	portbase;
extern char 		*PhoneDirData1[13];
extern char 		*ParityData1[5];
extern int 		ParityData2[5];
extern char 		*EmuData1[8];
extern char 		*ProtoData1[11];
extern char 		*InitBuf;
extern char 		*TempBuf;
extern unsigned int 	EmuMode;
extern unsigned int	VIPEMU;
extern int		timeleft;
extern long 		tmr;
extern unsigned long 	speed;
extern unsigned long	savspeed;
extern unsigned long	actualbaud;
extern unsigned int	port;
extern int 		bytesr;
extern int		MacChk;
extern int		MouseCol;
extern int		MouseRow;
extern int		MouseInstalled;
extern int		TIME_OUT;
extern int		KEY_HIT;

typedef struct {
	char			name[36];	// Name of Person
	char			number[31];	// Phone Number
	unsigned long		speed;		// DTE Rate
	int			bits;		// word size
	int			stop;		// Stop bits
	int			parity;		// Parity
	unsigned int		protocol;	// Default Protocol
	unsigned int		emulation;	// Emulation
	int			cr;		// Do CRLF
	int			echo;		// Echo
	unsigned int		TypC;
	int			deleted;	// Delete Flag
	unsigned char		xlat1[256]; 	// Translate Table (in)
	unsigned char		xlat2[256]; 	// Translate Table (out)

	// VERSION4.EXE is needed for v.04 and later releases
	// to rebuild the phonedir.pt records of previous versions
	// and add the following data to the end of each record for
	// future expansion.

	// PTUPGRAD.EXE will add any additional fields to the
	// phonedir records when needed.  A new PTUPGRAD.EXE
	// will be supplied with each release after v.04.

//	char                	macro[9];	// Macro File to use

	// pdversion field will be used from v.04 and later for
	// verification of correct record data.

//	char			pdversion;	// Phone dir version.
//	char			expansion[1024]; // need some room to grow.

}  PHONEDIR;

/*	Emulation Flags     Protocol Flags              Type Connection

	0x0000   TTY	    0x0000    Xmodem(CS)  	  0x0000   Dial
	0x0001   VT52	    0x0001    Xmodem(CRC)	  0x0001   Direct
	0x0002   VT102	    0x0002    Xmodem-1K
	0x0003   ANSI	    0x0003    Ymodem
	0x0004   AVATAR     0x0004    Ymodem-G
	0x0005   TEK4107C   0x0005    Zmodem
	0x0006   VIP7801
	0x0007   IBM3101

	Parity Flags

	0x00   None
	0x08   Odd
	0x18   Even
	0x28   Mark
	0x38   Space
*/

extern struct MODEMPARMS {                        // Filename:  MODEM.IPC
	unsigned long		defs[10];
	char			inits[11][36];
	char			modemmsg[15][16];
}  ModemParms;

PHONEDIR PhoneDir[19];
PHONEDIR PhoneDirBld;
PHONEDIR PhonePurRec;

long PDPtr;
unsigned long savbaud;
unsigned int PDIdx;
unsigned int PDRecs;
unsigned int PDPages;
unsigned int PDCurPage;
unsigned int PDLastRead;

int PD=0;               		// Phone Directory handle.
int PB=0;				// Backup Phone Directory handle.

char *PDBackup="PHONEDIR.BAK";		// Backup Phone Directory file.
char *ppp;

jmp_buf	fdenv;

void 	DisplayDirRecInfo( unsigned int Idx );
int 	DisplayDialDirectory( void );
void 	GetNewParity( unsigned int *Par );
void 	DisplayDirScreen( void );
int 	EditPhoneNumber( int NEW, unsigned int idx );
int 	VerifyPhoneRecordSave( void );
void 	EditTranslationTable( int type );
void 	PurgePhoneRecs( void );
void 	SaveEditPhoneRec( void );
void 	SaveNewPhoneRec( void );
void 	SaveCurrentPhoneRec( void );
int 	DialNumber( unsigned int idx );
int 	WaitForResponse( unsigned int *len, int *waittime );
static void fdsigjmp( int sig );
int 	SendHangupString( unsigned int *len );
void 	ReportModemStatus( void );


/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

int DisplayDialDirectory()
{
	int 		PDQUIT;
	unsigned int 	PDRow;
	unsigned int 	PDMin;
	unsigned int 	PDMax;
	unsigned int 	PDMaxI;
	unsigned int 	PDCol;
	unsigned int	reDialcnt;
	unsigned int	reDials = 100;
	unsigned int	reDialWaitTime = 5;
	int		ch;
	int		key;
	int		retstat;

	PDPtr = 0L;
	PDIdx = 0;
	PDRecs = 0;
	PDRow = 2;
	PDMin = 2;
	PDMax = 0;
	PDMaxI = 0;
	PDCol = 2;
	PDQUIT = FALSE;
	PDLastRead = 0;
	if ((PD=sopen("PHONEDIR.PT",O_BINARY|O_CREAT|O_RDWR,
		SH_DENYWR,S_IWRITE)) != -1)  {
		lseek(PD,0L,SEEK_END);
		PDRecs = ((tell(PD)) / (size_t)sizeof(PHONEDIR));
		lseek(PD,0L,SEEK_SET);
	}
	PDPages = (PDRecs / 20) + 1;
	MakeWindow(1,1,VidRows-1,VidCols,LightCyan+BlueBG,LightCyan+BlueBG,NoShadow,Frame2);
	fswrite("[", 1, 3, LightCyan+BlueBG );
	fswriteM("", LightGreen+BlueBG );
	fswriteM( "]", LightCyan+BlueBG );

//	ExplodeWindow(1,1,VidRows-1,VidCols,LightCyan+BlueBG,LightCyan+BlueBG,NoShadow,Frame2);
	fswrite("",21,1,LightCyan+BlueBG);
	fswrite("",21,80,LastAttr);
	fsfill(21,2,1,78,'',LastAttr);
	fswriteC(" Dial Directory ",1,VidCols,LastAttr);

	fswrite("Emulation:",22,3,LightCyan+BlueBG);
	fswrite("Protocol:",23,4,LastAttr);
/*	fswrite("Word Size:",23,3,LastAttr);
	fswrite("Stop Bits:",23,21,LastAttr);
	fswrite("Parity:",23,39,LastAttr);
	fswrite("Echo:",23,55,LastAttr);
	fswrite("CR:",23,65,LastAttr);	*/
	PDPtr = 0L;
	PDCurPage = 0;
	DisplayDirScreen();
	if (PDRecs > 0)
		fsattr(PDRow,PDCol,1,78,Yellow+BlackBG);
	PDMaxI = PDIdx - 1;
	PDIdx = 0;
//	PDCurPage = 0;
	PDMax = PDMaxI + 2;
	DisplayDirRecInfo( PDIdx );
	if (MouseInstalled)
		Mshow();
	DisplayCmdLine( 3 );

	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch( ch )  {

					case ESCAPE:

						PDQUIT = TRUE;
						break;

					case CR:
					case 'D':

						if ( MouseInstalled )
							Mhide();
						EmuMode = PhoneDir[PDIdx].emulation;
						if ( EmuMode == VIPEMU )
							VIP = TRUE;
						else
							VIP = FALSE;

						kbflush();
//						for ( reDialcnt = 1; reDialcnt <= reDials; reDialcnt++ )	{
						for ( reDialcnt = 1; ; reDialcnt++ )	{
							retstat = DialNumber( PDIdx );
/*							if ( retstat == 9 )  {
								close( PD );

								ECHOON = ( PhoneDir[PDIdx].echo ) ? TRUE : FALSE;
								LFON = ( PhoneDir[PDIdx].cr ) ? TRUE : FALSE;

								CloseWindow();
								return( -1 );
							}*/
							if ( retstat > 0 )
								ReportModemStatus();

							if (( CARRIERON ) || (( retstat > 0 ) && ( retstat < 8 )))  {
								close( PD );

								ECHOON = ( PhoneDir[PDIdx].echo ) ? TRUE : FALSE;
								LFON = ( PhoneDir[PDIdx].cr ) ? TRUE : FALSE;

								CloseWindow();
								return( 1 );
							}
							else
							if ( retstat > 7 )	{
								delay( 300 );
								MakeWindow( 9, 19, 6, 42, LightCyan+CyanBG, LightCyan+CyanBG,
									Shadow, Frame2 );

								fswriteC( " Waiting ", 9, VidCols, LightCyan+CyanBG );

								fswriteC( " Hit any key to cancel ", 14, VidCols, LightCyan+CyanBG );

								alarm( reDialWaitTime );

								while ( ( timeleft > 0 ) && ( !kbhit() ) )	{
									sprintf( buff, "Retry number %02u", reDialcnt );
									fswriteC( buff, 11, VidCols, Blue+CyanBG );
									sprintf( buff, "Re-Dialing in %02u seconds", timeleft );
									fswriteC( buff, 12, VidCols, Blue+CyanBG );
								}

								alarm( 0 );
								if ( kbhit() )	{
									kbflush();
									CloseWindow();
									break;
								}
								else	{
									CloseWindow();
									delay( 1000 );
								}
							}
							else
								break;
						}
						DisplayCmdLine( 3 );
						if ( MouseInstalled )
							Mshow();
						break;

					case 'A':

						if (PDRecs >= 31999)  {
							Beep( 100 );
							break;
						}
						if ( EditPhoneNumber( TRUE, 0) == 1)
							SaveNewPhoneRec();
						lseek( PD, 0L, SEEK_END );
						PDRecs = ((tell(PD)) / (size_t)sizeof(PHONEDIR));
						fsattr( PDRow, PDCol, 1, 78, White+BlueBG );
						PDPtr = 0L;
						PDCurPage = 0;
						PDPages = (PDRecs / 20) + 1;
						DisplayDirScreen();
						PDRow = PDCol = 2;
						PDMaxI = PDIdx - 1;
						PDMax = PDMaxI + 2;
						PDIdx = 0;
						if (PDRecs > 0)
							fsattr( PDRow, PDCol, 1, 78, Yellow+BlackBG );
						DisplayCmdLine( 3 );
						break;

					case 'C':

						EmuMode = PhoneDir[PDIdx].emulation;
						if ( EmuMode == VIPEMU )
							VIP = TRUE;
						else
							VIP = FALSE;
						ECHOON = ( PhoneDir[PDIdx].echo ) ? TRUE : FALSE;
						LFON = ( PhoneDir[PDIdx].cr ) ? TRUE : FALSE;
						speed = PhoneDir[PDIdx].speed;
						port = (unsigned int) ModemParms.defs[0];
						ChangeSpeed( speed );
						ChangeOthers( PhoneDir[PDIdx].parity, PhoneDir[PDIdx].bits,
								PhoneDir[PDIdx].stop);
						PDQUIT = TRUE;
						break;

					case 'E':

						if ( PDRecs == 0 )
							break;
						if ( EditPhoneNumber( FALSE, PDIdx) == 1 )
							SaveEditPhoneRec();
						fsattr( PDRow, PDCol, 1, 78, White+BlueBG );
						PDPtr = 0L;
						PDCurPage = 0;
						DisplayDirScreen();
						PDRow = PDCol = 2;
						PDMaxI = PDIdx - 1;
						PDMax = PDMaxI + 2;
						PDIdx = 0;
						fsattr( PDRow, PDCol, 1, 78, Yellow+BlackBG );
						DisplayCmdLine( 3 );
						break;

					case 'P':

						if ( PDRecs == 0 )
							break;
						PurgePhoneRecs();
						PDPtr = 0L;
						PDCurPage = 0;
						PDPages = ( PDRecs / 20 ) + 1;
						DisplayDirScreen();
						PDRow = PDCol = 2;
						PDMaxI = PDIdx - 1;
						PDIdx = 0;
						PDCurPage = 0;
						PDMax = PDMaxI + 2;
						if ( PDRecs > 0 )
							fsattr( PDRow, PDCol, 1, 78, Yellow+BlackBG );
						if ( MouseInstalled )
							Mshow();
						break;


					case SPECIALKEY:

						if ( MouseInstalled )
							Mhide();
						key = getch();
						switch( key )  {

							case F1:

								GiveUserHelp("T02.HLP");
								DisplayCmdLine( 3 );
								break;

							case HOME:

								if ( PDRecs == 0 )
									break;
								fsattr( PDRow, PDCol, 1, 78, White+BlueBG );
								PDIdx = 0;
								PDRow = 2;
								fsattr( PDRow, PDCol, 1, 78, Yellow+BlackBG );
								break;

							case END:

								if ( PDRecs == 0 )
									break;
								fsattr( PDRow, PDCol, 1, 78, White+BlueBG );
								PDIdx = PDMaxI;
								PDRow = PDMax;
								fsattr( PDRow, PDCol, 1, 78, Yellow+BlackBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case DN:

								if ( PDRecs == 0 )
									break;
								MovePDDown( &PDRow, &PDCol, &PDIdx, &PDMaxI );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( PDRecs == 0 )
									break;
								MovePDUp( &PDRow, &PDCol, &PDIdx, &PDMaxI );
								break;

							case PGDN:

								if ( PDPages < 2 )  {
									Beep( 100 );
									break;
								}
								if ( ( PDCurPage + 1 ) == PDPages )  {
									Beep( 100 );
									break;
								}
								PDCurPage += 1;
								PDIdx = 0;
								PDPtr=(long)(((PDCurPage * 19)+PDIdx)*(size_t)sizeof(PHONEDIR));
								DisplayDirScreen();
								PDRow = PDCol = 2;
								PDMaxI = PDIdx - 1;
								PDMax = PDMaxI + 2;
								PDIdx = 0;
								fsattr( PDRow, PDCol, 1, 78, Yellow+BlackBG );
								break;

							case PGUP:

								if ( PDCurPage == 0 )   {
									Beep( 100 );
									break;
								}
								PDCurPage -= 1;
								PDIdx = 0;
								PDPtr = ( long ) ( ( ( PDCurPage * 19 ) + PDIdx ) *
									 ( size_t ) sizeof( PHONEDIR ) );
								DisplayDirScreen();
								PDRow = PDCol = 2;
								PDMaxI = PDIdx - 1;
								PDMax = PDMaxI + 2;
								PDIdx = 0;
								fsattr(PDRow,PDCol,1,78,Yellow+BlackBG);
								break;

							case DELETE:

								if(PhoneDir[PDIdx].deleted)  {
									PhoneDir[PDIdx].deleted = FALSE;
									fswrite(" ",PDRow,78,Yellow+BlackBG);
								}
								else  {
									PhoneDir[PDIdx].deleted = TRUE;
									sprintf(buff,"%c\0",4);
									fswrite(buff,PDRow,78,Yellow+BlackBG);
								}
								SaveCurrentPhoneRec();
								break;

							default:

								Beep(100);
								break;
						}
/*						DisplayDirRecInfo( PDIdx );
						if (MouseInstalled)
							Mshow(); */

						break;

					default:
						Beep( 100 );
						break;
				}
				DisplayDirRecInfo(PDIdx);
				if ( MouseInstalled )
					Mshow();
				break;

			case MOUSE1BUTTON:

				if (( MouseRow == 1 ) && ( MouseCol == 4 ))	{
					PDQUIT = TRUE;
					break;
				}
				if ( MouseInstalled )
					Mhide();
				if (( MouseRow == 1 ) && ( MouseCol == 77 ))	{
					if ( PDPages < 2 )  {
						break;
					}
//					if (( peek(VideoSeg,76 << 1) == 27))	{
					if ( ( PDCurPage + 1 ) == PDPages )  {
//						Beep( 100 );
						PDCurPage -= 1;
						PDIdx = 0;
						PDPtr = ( long ) ( ( ( PDCurPage * 19 ) + PDIdx ) *
							 ( size_t ) sizeof( PHONEDIR ) );
						DisplayDirScreen();
						PDRow = PDCol = 2;
						PDMaxI = PDIdx - 1;
						PDMax = PDMaxI + 2;
						PDIdx = 0;
						fsattr(PDRow,PDCol,1,78,Yellow+BlackBG);
					}
					else	{
						PDCurPage += 1;
						PDIdx = 0;
						PDPtr=(long)(((PDCurPage * 19)+PDIdx)*(size_t)sizeof(PHONEDIR));
						DisplayDirScreen();
						PDRow = PDCol = 2;
						PDMaxI = PDIdx - 1;
						PDMax = PDMaxI + 2;
						PDIdx = 0;
						fsattr( PDRow, PDCol, 1, 78, Yellow+BlackBG );
					}
				}
				else
				if ((( MouseRow >= PDMin ) && ( MouseRow <= PDMax )) &&
					(( MouseCol >= PDCol ) && ( MouseCol <= 79 )))	{
					if ( PDRecs == 0 )
						break;
					MovePD( &PDRow, &PDCol, &PDIdx, &PDMaxI, MouseRow );
					DisplayDirRecInfo( PDIdx );
				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				PDQUIT = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();
				if ((( MouseRow >= PDMin ) && ( MouseRow <= PDMax )) &&
					(( MouseCol >= PDCol ) && ( MouseCol <= 79 )))	{
					if ( PDRecs == 0 )
						break;
					MovePD( &PDRow, &PDCol, &PDIdx, &PDMaxI, MouseRow );
					DisplayDirRecInfo( PDIdx );
					EmuMode = PhoneDir[PDIdx].emulation;
					if ( EmuMode == VIPEMU )
						VIP = TRUE;
					else
						VIP = FALSE;
					for ( reDialcnt = 1; ; reDialcnt++ )	{
						retstat = DialNumber( PDIdx );
/*						if ( retstat == 9 )  {
							close( PD );
							ECHOON = ( PhoneDir[PDIdx].echo ) ? TRUE : FALSE;
							LFON = ( PhoneDir[PDIdx].cr ) ? TRUE : FALSE;
							CloseWindow();
							return( -1 );
						}*/
						if ( retstat > 0 )
							ReportModemStatus();
						if (( CARRIERON ) || (( retstat > 0 ) && ( retstat < 8 )))  {
							close( PD );
							ECHOON = ( PhoneDir[PDIdx].echo ) ? TRUE : FALSE;
							LFON = ( PhoneDir[PDIdx].cr ) ? TRUE : FALSE;
							CloseWindow();
							return( 1 );
						}
						else
						if ( retstat > 7 )	{
							delay( 300 );
							MakeWindow( 9, 19, 6, 42, LightCyan+CyanBG, LightCyan+CyanBG,
								Shadow, Frame2 );
							fswriteC( " Waiting ", 9, VidCols, LightCyan+CyanBG );
							fswriteC( " Hit any key to cancel ", 14, VidCols, LightCyan+CyanBG );
							alarm( reDialWaitTime );
							while ( ( timeleft > 0 ) && ( !kbhit() ) )	{
								sprintf( buff, "Retry number %02u", reDialcnt );
								fswriteC( buff, 11, VidCols, Blue+CyanBG );
								sprintf( buff, "Re-Dialing in %02u seconds", timeleft );
								fswriteC( buff, 12, VidCols, Blue+CyanBG );
							}
							alarm( 0 );
							if ( kbhit() )	{
								kbflush();
								CloseWindow();
								break;
							}
							else	{
								CloseWindow();
								delay( 1000 );
							}
						}
						else
							break;
					}
				}
				DisplayCmdLine( 3 );
				if ( MouseInstalled )
					Mshow();
				break;

			default:

				break;
		}
	} while (!PDQUIT);
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	close( PD );
	return( 0 );
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void DisplayDirScreen()
{
	int	i;

	if (( PDPages > 1 ) && ( (PDCurPage+1) < PDPages ))	{
		sprintf( buff, "%c", 26 );
		fswrite( "[", 1, 76, LightCyan+BlueBG );
		fswriteM( buff, LightGreen+BlueBG );
		fswriteM( "]", LightCyan+BlueBG );
	}
	else
	if (( PDPages > 1 ) && ( (PDCurPage+1) == PDPages ))	{
		sprintf( buff, "%c", 27 );
		fswrite( "[", 1, 76, LightCyan+BlueBG );
		fswriteM( buff, LightGreen+BlueBG );
		fswriteM( "]", LightCyan+BlueBG );
	}

	fsfill(2,2,19,78,' ',White+BlueBG);
	if (PDRecs > 0)  {
		lseek(PD,PDPtr,SEEK_SET);
		PDIdx = 0;
		while (!eof(PD)) {
			if((bytesr=read(PD,&PhoneDir[PDIdx],
				(size_t)sizeof(PHONEDIR))) == -1)  {
				printf("Phone Dir Read error");
				break;
			}
			if (++PDIdx > 18) break;
			PDLastRead+=1;
		}
		for ( i = 0; i < PDIdx; i++ )  {
			fswrite(PhoneDir[i].name,(i+2),3,White+BlueBG);
			fswrite(PhoneDir[i].number,(i+2),39,LastAttr);
			sprintf(buff,"%lu  ",PhoneDir[i].speed);
			fswrite(buff,(i+2),70,LastAttr);
			if (PhoneDir[i].deleted)  {
				sprintf(buff,"%c\0",4);
				fswrite(buff,(i+2),78,LastAttr);
			}
		}
	}
	fswrite( "Page ", 22, 60, LightCyan+BlueBG );
	sprintf( buff, "%u\0", ( PDCurPage + 1 ) );
	fswriteM( buff, Yellow+BlueBG );
	fswriteM( " of ", LightCyan+BlueBG );
	sprintf( buff, "%u        \0", PDPages );
	fswriteM( buff, Yellow+BlueBG );
}


void DisplayDirRecInfo( unsigned int Idx )
{

//	unsigned int Par;

	fswrite(EmuData1[(PhoneDir[Idx].emulation)],22,14,Yellow+BlueBG);
	fswrite(ProtoData1[(PhoneDir[Idx].protocol)],23,14,LastAttr);
/*	sprintf(buff,"%d",PhoneDir[Idx].bits);
	fswrite(buff,23,14,LastAttr);
	sprintf(buff,"%d",PhoneDir[Idx].stop);
	fswrite(buff,23,32,LastAttr);
	switch(PhoneDir[Idx].parity)  {
		case 0x00: Par = 0; break;
		case 0x08: Par = 1; break;
		case 0x18: Par = 2; break;
		case 0x28: Par = 3; break;
		case 0x38: Par = 4; break;
		default:   Par = 0; break;
	}
	fswrite(ParityData1[Par],23,47,LastAttr);
//	if (PhoneDir[Idx].echo)
//		fswrite("Yes",23,61,LastAttr);
	fswrite((( PhoneDir[Idx].echo ) ? "Yes" : "No" ),23,61,LastAttr);
//	else
//		fswrite("No ",23,61,LastAttr);
//	if (PhoneDir[Idx].cr)
	fswrite( (( PhoneDir[Idx].cr ) ? "Yes" : "No" ),23,69,LastAttr);
//	else
		fswrite("No ",23,69,LastAttr);	*/
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

int EditPhoneNumber(int NEW, unsigned idx)
{
	int 	     	APN = FALSE;
	int		rc;
	unsigned int	sum;
	unsigned int	sum2;
	int		i;
	int		ch;
	int		key;
	unsigned int 	APNIdx = 0;
	unsigned int 	APNRow = 6;
	unsigned int 	APNMin = 6;
	unsigned int 	APNMax = 18;
	unsigned int 	APNMaxI = 12;
	unsigned int 	Col    = 11;
	unsigned int 	APNCol = 28;
	unsigned int 	Par = 0;

	MakeWindow( 4, 10, 17, 60, LightCyan+CyanBG, LightCyan+CyanBG,
		Shadow, Frame1 );
	fswrite( "[", 4, 12, LightCyan+CyanBG );
	fswriteM( "", LightGreen+CyanBG );
	fswriteM( "]", LightCyan+CyanBG );
/*	fswrite("Esc", 20, 12, Red+CyanBG );
	fswriteM( "-Abort", LightCyan+CyanBG );
	fswrite("F10", 20, 60, Red+CyanBG );
	fswriteM( "-Save", LightCyan+CyanBG );*/
	setstrng(InitBuf,'\0',35);
	setstrng(PhoneDirBld.name,'\0',35);
	setstrng(PhoneDirBld.number,'\0',30);
	setstrng(InitBuf,'',35);
	PRECCHG = FALSE;
	if ( NEW )  {
		PhoneDirBld.speed = 2400L;
		PhoneDirBld.bits = 8;
		PhoneDirBld.stop = 1;
		PhoneDirBld.parity = 0x00;     		// NO_PARITY
		PhoneDirBld.protocol = 0x0000;		// ASCII
		PhoneDirBld.emulation = 0x0000;		// TTY
		PhoneDirBld.cr = FALSE;             // No CR
		PhoneDirBld.echo = FALSE;			// No Echo
		PhoneDirBld.deleted = FALSE;		// Not Deleted
		for (	i = 0; i < 256; i++ )  {
			PhoneDirBld.xlat1[i]= i;
			PhoneDirBld.xlat2[i]= i;
		}
//		setstrng(PhoneDirBld.macro, '\0', 12 );
	}
	else  {
		strcpy( PhoneDirBld.name,	PhoneDir[idx].name );
		strcpy( PhoneDirBld.number,	PhoneDir[idx].number );
		PhoneDirBld.speed = 		PhoneDir[idx].speed;
		PhoneDirBld.bits = 			PhoneDir[idx].bits;
		PhoneDirBld.stop = 			PhoneDir[idx].stop;
		PhoneDirBld.parity = 		PhoneDir[idx].parity;
		PhoneDirBld.protocol = 		PhoneDir[idx].protocol;
		PhoneDirBld.emulation = 	PhoneDir[idx].emulation;
		PhoneDirBld.cr = 			PhoneDir[idx].cr;
		PhoneDirBld.echo = 			PhoneDir[idx].echo;
		PhoneDirBld.deleted = 		PhoneDir[idx].deleted;

		// Check for zeroed xlate table

		sum = 0;
		sum2 = 0;
		for ( i = 0; i < 256; i++ )	{
			sum += PhoneDir[idx].xlat1[i];
			sum2 += PhoneDir[idx].xlat2[i];
		}
		if ( !sum )	{
			for (	i = 0; i < 256; i++ )  {
				PhoneDirBld.xlat1[i] = i;
			}
			PRECCHG = TRUE;
		}
		if ( !sum2 )	{
			for (	i = 0; i < 256; i++ )  {
				PhoneDirBld.xlat2[i] = i;
			}
			PRECCHG = TRUE;
		}
		else	{
			for (	i = 0; i < 256; i++ )  {
				PhoneDirBld.xlat1[i]= PhoneDir[idx].xlat1[i];
				PhoneDirBld.xlat2[i]= PhoneDir[idx].xlat2[i];
			}
		}
//		strcpy( PhoneDirBld.macro, 	PhoneDir[idx].macro );
	}
	for ( i = 0; i < 13; i++ )  {
	  fswrite(PhoneDirData1[i],(i+6),11,Yellow+CyanBG);
	}
	fswrite(PhoneDirBld.name,6,APNCol,White+CyanBG);
	fswrite(PhoneDirBld.number,7,APNCol,LastAttr);
	sprintf(buff,"%lu  ",PhoneDirBld.speed);
	fswrite(buff,8,APNCol,LastAttr);
	sprintf(buff,"%d",PhoneDirBld.bits);
	fswrite(buff,9,APNCol,LastAttr);
	sprintf(buff,"%d",PhoneDirBld.stop);
	fswrite(buff,10,APNCol,LastAttr);
	switch(PhoneDirBld.parity)  {
		case 0x00: Par = 0; break;
		case 0x08: Par = 1; break;
		case 0x18: Par = 2; break;
		case 0x28: Par = 3; break;
		case 0x38: Par = 4; break;
		default:   Par = 0; break;
	}
	fswrite(ParityData1[Par],11,APNCol-1,LastAttr);
	fswrite(ProtoData1[PhoneDirBld.protocol],12,APNCol-1,LastAttr);
	fswrite(EmuData1[PhoneDirBld.emulation],13,APNCol-1,LastAttr);
//	if (PhoneDirBld.cr)
	fswrite( (( PhoneDirBld.cr ) ? "Yes" : "No" ),14,APNCol,LastAttr);
//	else
//		fswrite("No ",14,APNCol,LastAttr);
//	if (PhoneDirBld.echo)
	fswrite( (( PhoneDirBld.echo ) ? "Yes" : "No" ),15,APNCol,LastAttr);
//	else
//		fswrite("No ",15,APNCol,LastAttr);
//	fswrite( PhoneDirBld.macro, 18, APNCol, LastAttr );
	fswrite(PhoneDirData1[0],6,Col,Yellow+BlueBG);
	DisplayCmdLine( 9 );
	if ( MouseInstalled )
		Mshow();
	do  {
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )  {

					case ESCAPE:

					// If record was changed or added,
					// then verify save before escaping.

						rc = 0;
						if ( PRECCHG )	{
							if ( MouseInstalled )
								Mhide();
							if ( VerifyPhoneRecordSave() )
								rc = 1;
							if ( MouseInstalled )
								Mshow();
						}
						APN = TRUE;
						break;

					case CR:

						if ( MouseInstalled )
							Mhide();
						switch ( APNIdx )  {

							case 0:

								setstrng( InitBuf, '', 35 );
								EditStringValue( PhoneDirBld.name, 35,
									APNRow, APNCol, InitBuf,
									Cyan+BlueBG, White+BlueBG, White+CyanBG );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 1:

								setstrng( InitBuf, '', 30 );
								EditStringValue( PhoneDirBld.number, 30,
									APNRow, APNCol, InitBuf,
									Cyan+BlueBG, White+BlueBG, White+CyanBG );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 2:

								GetNewBaudRate( &PhoneDirBld.speed, FALSE );
								sprintf (buff,"%lu  ",PhoneDirBld.speed);
								fswrite (buff,APNRow,APNCol,White+CyanBG);
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 3:

								getbit:
								setstrng( InitBuf, '', 1 );
								EditIntValue( &PhoneDirBld.bits, 1,
									APNRow, APNCol, InitBuf, 8,
									Cyan+BlueBG, White+BlueBG, White+CyanBG );
								if ( ( PhoneDirBld.bits < 5 ) || ( PhoneDirBld.bits > 8 ) ) {
									Beep( 100 );
									goto getbit;
								}
								sprintf( buff, "%d",PhoneDirBld.bits );
								fswrite( buff,APNRow,APNCol,White+CyanBG );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 4:

								getstop:
								setstrng( InitBuf, '', 1 );
								EditIntValue( &PhoneDirBld.stop, 1,
									APNRow, APNCol, InitBuf, 2,
									Cyan+BlueBG, White+BlueBG, White+CyanBG );
								if ((PhoneDirBld.stop < 1) || (PhoneDirBld.stop > 2)) {
									Beep( 100 );
									goto getstop;
								}
								sprintf( buff, "%d", PhoneDirBld.stop );
								fswrite( buff, APNRow, APNCol, White+CyanBG );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 5:

								GetNewParity( &Par );
								PhoneDirBld.parity = ParityData2[Par];
								fswrite( ParityData1[Par], APNRow, APNCol - 1, White+CyanBG );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 6:

								PhoneDirBld.protocol = SelectProtocol( PhoneDirBld.protocol );
								fswrite( ProtoData1[PhoneDirBld.protocol], APNRow, APNCol - 1, White+CyanBG );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );

								break;

							case 7:

								PhoneDirBld.emulation = SwitchEmulation(PhoneDirBld.emulation);
								fswrite( EmuData1[PhoneDirBld.emulation], APNRow, APNCol - 1, White+CyanBG );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 8:

								if ( PhoneDirBld.cr )  {
									PhoneDirBld.cr = FALSE;
									fswrite( "No ", APNRow, APNCol, White+CyanBG );
									PRECCHG = TRUE;
								}
								else  {
									PhoneDirBld.cr = TRUE;
									fswrite( "Yes", APNRow, APNCol, White+CyanBG );
									PRECCHG = TRUE;
								}
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 9:

								if ( PhoneDirBld.echo )  {
									PhoneDirBld.echo = FALSE;
									fswrite( "No ", APNRow, APNCol, White+CyanBG );
									PRECCHG = TRUE;
								}
								else  {
									PhoneDirBld.echo = TRUE;
									fswrite( "Yes", APNRow, APNCol, White+CyanBG );
									PRECCHG = TRUE;
								}
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 10:	// X-late table (in)

								EditTranslationTable( 0 );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case 11:	// X-Late table (out)

								EditTranslationTable( 1 );
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;


							case 12:	// Select Macro File

//								setstrng( InitBuf, '', 8 );
//								MacChk = TRUE;
//								EditStringValue( PhoneDirBld.macro, 8,
//									APNRow, APNCol, InitBuf,
//									Cyan+BlueBG, White+BlueBG, White+CyanBG );
//								MacChk = FALSE;
								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;


							default:

								break;
						}
						DisplayCmdLine( 9 );
						if ( MouseInstalled )
							Mshow();
						break;

					case SPECIALKEY:

						if ( MouseInstalled )
							Mhide();
						key = getch();
						switch( key )  {

							case F10:

								rc = 1;
								APN = TRUE;
								break;

							case DN:

								MoveMenuBarDown( PhoneDirData1,
									&APNIdx, &APNRow, &APNMin,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							case UP:

								MoveMenuBarUp( PhoneDirData1,
									&APNIdx, &APNRow, &APNMax,
									&Col, &APNMaxI, Yellow+CyanBG,
									Yellow+BlueBG );
								break;

							default:

								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					default:
						break;

				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();
				if ( ( MouseRow == 4 ) && ( MouseCol == 13 ) )	{
					rc = 0;
					APN = TRUE;
					break;
				}
				else
				if ((( MouseRow >= APNMin ) && ( MouseRow <= APNMax )) &&
					(( MouseCol >= Col ) && ( MouseCol <= Col+14 )))	{
					MoveMenuBar( PhoneDirData1,
						&APNIdx, &APNRow, MouseRow,
						&APNMin, &Col, &APNMaxI,
						Yellow+CyanBG, Yellow+BlueBG );
				}
				if ( MouseInstalled )
					Mshow();
				break;

			default:
				break;
		}
	} while ( !APN );
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return( rc );
}

int VerifyPhoneRecordSave( void )
{
	int	ch;
	int	DONE;
	int	rc;

	MakeWindow( 16, 8, 3, 64, White+RedBG, White+RedBG,
		Shadow, Frame1 );
	fswriteC( "Current phone record not saved.  Save (Y/n) ?", 17, VidCols,
		Yellow+RedBG );
	Ringing( 1 );
	DONE = FALSE;
	if (MouseInstalled)
		Mshow();
	do 	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch( ch )	{

					case CR:

						rc = 1;
						DONE = TRUE;
						break;

					case 'Y':

						rc = 1;
						DONE = TRUE;
						break;

					default:

						rc = 0;
						DONE = TRUE;
						break;
				}
				break;

			case MOUSE1BUTTON:

				Beep( 200 );
				break;
		}
	} while( !DONE );
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return( rc );
}


/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void EditTranslationTable( int type )
{
	int	ch;
	int	DONE;
	int	XLIdx;
	int	r;
	int	c;

	MakeWindow( 1, 1, 24, 80, LightCyan+CyanBG, LightCyan+CyanBG,
		NoShadow, Frame1 );
	sprintf( buff, " Translation Table (%s) ", ( type ) ? "OUT" : "IN" );
	fswriteC( buff, 1, VidCols, LightCyan+BlueBG );
	fswrite( "0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F", 3, 8,
		Blue+CyanBG );
	fswrite( "", 4, 6,
		Blue+CyanBG );
	DONE = FALSE;
	XLIdx = 0;
	for ( r = 5; XLIdx < 256; r++ )	{
		for ( c = 8; c < 72; c+=4 )	{
			sprintf( buff, "%c", ((type) ? PhoneDirBld.xlat2[XLIdx] : PhoneDirBld.xlat1[XLIdx] ));
			fswrite( buff, r, c, White+CyanBG );
			XLIdx++;
		}
	}
	if ( MouseInstalled )
		Mshow();
	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( toupper( ch ) )	{

					case ESCAPE:

						DONE = TRUE;
						break;

					default:
						break;
				}
				break;

			default:
				break;
		}
	} while( !DONE );
	if (MouseInstalled )
		Mhide();
	CloseWindow();
}




void PurgePhoneRecs()
{
	char far	*sav_dta;

	sav_dta = getdta();
	setdta( (char far *)&PhonePurRec );
	if ( ( PB = sopen( PDBackup, O_BINARY | O_CREAT | O_RDWR,
		SH_DENYWR, S_IWRITE ) ) == -1 )  {
		return;
	}
	lseek( PD, 0L, SEEK_SET );
	while ( !eof( PD ) ) {
		if ( ( bytesr = read( PD, &PhonePurRec,
			( size_t ) sizeof( PHONEDIR ) ) ) == -1 )  {
			fprintf(stderr, "Phone Dir Read error" );
			break;
		}
		if ( PhonePurRec.deleted )  {
			PDRecs -= 1;
		}
		else  {
			bytesr = write( PB, &PhonePurRec,
				( size_t ) sizeof( PHONEDIR ) );
		}
	}
	close( PD );
	close( PB );
	setdta( sav_dta );
	unlink( "PHONEDIR.PT" );
	rename( PDBackup, "PHONEDIR.PT" );
	if ( ( PD = sopen( "PHONEDIR.PT", O_BINARY | O_CREAT | O_RDWR,
		SH_DENYWR, S_IWRITE ) ) == -1 )  {
		return;
	}
	lseek( PD, 0L, SEEK_END );
	PDRecs = ( ( tell( PD ) ) / ( size_t ) sizeof( PHONEDIR ) );
	lseek( PD, 0L, SEEK_SET );
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void SaveEditPhoneRec()
{
	PDPtr = ( long ) ( ( ( PDCurPage * 19 ) + PDIdx) *
			( size_t ) sizeof( PHONEDIR ) );
	lseek( PD, PDPtr, SEEK_SET );
	bytesr = write( PD, &PhoneDirBld, ( size_t ) sizeof( PHONEDIR ) );
	return;
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void SaveCurrentPhoneRec()
{
	PDPtr = ( long ) ( ( ( PDCurPage * 19 ) + PDIdx ) *
		 ( size_t ) sizeof( PHONEDIR ) );
	lseek( PD, PDPtr, SEEK_SET );
	bytesr = write( PD, &PhoneDir[PDIdx], ( size_t ) sizeof( PHONEDIR ) );
	return;
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void SaveNewPhoneRec( void )
{
	lseek( PD, 0L, SEEK_END );
	if ( ( bytesr = write( PD, &PhoneDirBld,
			( size_t )sizeof( PHONEDIR ) ) ) == -1 )  {
		Beep( 1000 );
		return;
	}
	lseek( PD, 0L, SEEK_SET );
	PDRecs = ( ( tell( PD ) ) / ( size_t )sizeof( PHONEDIR ) );
	return;
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void GetNewParity( unsigned int *Par )
{
	int		i;
	int 		GNP = FALSE;
	unsigned int 	MPIdx = 0;
	unsigned int 	MPRow = 9;
	unsigned int 	Col = 60;
	unsigned int 	MPMaxI = 4;
	unsigned int 	MPMax = 13;
	unsigned int 	MPMin = 9;
	int		key;
	int		ch;

	MakeWindow( 8, 59, 7, 9, White+BlueBG, White+BlueBG, Shadow,
		Frame1);
	for ( i = 0; i < 5; i++ )
		fswrite( ParityData1[i], ( i + 9 ), 60, White+BlueBG );
	fswrite( ParityData1[0], 9, 60, White+CyanBG );
	if ( MouseInstalled )
		Mshow();
	do  {
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )  {

					case ESCAPE:

						GNP=TRUE;
						break;

					case CR:

						GNP = TRUE;
						( *Par ) = MPIdx;
						PRECCHG = TRUE;
						break;

					case SPECIALKEY:

						if ( MouseInstalled )
							Mhide();
						key = getch();
						switch( key )  {

							case DN:

								MoveMenuBarDown( ParityData1,
									&MPIdx, &MPRow, &MPMin,
									&Col, &MPMaxI, White+BlueBG,
									White+CyanBG );
								break;

							case UP:

								MoveMenuBarUp( ParityData1,
									&MPIdx, &MPRow, &MPMax,
									&Col, &MPMaxI, White+BlueBG,
									White+CyanBG );
								break;

							default:

								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					default:
						break;
				}

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();
				if ((( MouseRow >= MPMin ) && ( MouseRow <= MPMax )) &&
					(( MouseCol >= Col ) && ( MouseCol <= ( Col + 6 ))))	{
					MoveMenuBar( ParityData1,
						&MPIdx, &MPRow, MouseRow,
						&MPMin, &Col, &MPMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );

					( *Par ) = MPIdx;
					PRECCHG = TRUE;
					GNP = TRUE;
				}
				if ( MouseInstalled )
					Mshow();
				break;

			case MOUSE2BUTTON:

				GNP = TRUE;
				break;

			default:
				break;
		}
	} while ( !GNP );
	CloseWindow();
	if ( MouseInstalled )
		Mhide();

/*	return(*Par);  */
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

int DialNumber( unsigned int idx )
{
	int 			c;

	unsigned int		len;
	int			waittime;

	speed = PhoneDir[idx].speed;   		// Used also for status line display
	port = (unsigned int) ModemParms.defs[0];
	if ( ChangeSpeed( speed ) != 0 )
		return( -1 );
	if ( ChangeOthers( PhoneDir[idx].parity, PhoneDir[idx].bits,
		PhoneDir[idx].stop) != 0 )
		return( -1 );

	LFON = PhoneDir[idx].cr;
	ECHOON = PhoneDir[idx].echo;
	if ( strln( PhoneDir[idx].number ) == 0 )
		return( 9 );
	MakeWindow( 9, 19, 6, 42, LightCyan+CyanBG, LightCyan+CyanBG,
			Shadow, Frame2 );
	fswriteC( " Dialing ", 9, VidCols, LightCyan+CyanBG );
	fswriteC( " Hit escape to cancel ", 14, VidCols, LightCyan+CyanBG );
	fswriteC( PhoneDir[idx].name, 11, 80, Blue+CyanBG );
	sprintf( buff, "%s%s\0", ModemParms.inits[7],
		PhoneDir[idx].number );
	fswriteC( buff, 12, VidCols, LastAttr );
	setstrng( TempBuf, '\0', 35 );
	sprintf( buff, "%s%s%s%s\0", ModemParms.inits[6],
			ModemParms.inits[7], PhoneDir[idx].number,
			ModemParms.inits[8] );
	while ( ( pp = strstr( buff, "|" ) ) != NULL )  *pp = '\r';
	flushinput();
	if ( signal( SIGTERM, fdsigjmp  ) == SIG_ERR )	{
		fprintf(stderr,"Fatal SIGNAL error in DialNumber()\n");
		return( -1 );
	}

	// Put Check for CTS first!!!

	SerialString(buff);
	delay( ModemParms.defs[5] * 100 );

	// Throw out anything echoed

	flushinput();
	len = 30;
	waittime = ( int ) ModemParms.defs[6];
	c = WaitForResponse( &len, &waittime );
	CloseWindow();
	return( c );
}


/*------------------------------------------------------------------------
  Function to wait for modem response after dial command sent.  Response
  is checked with the modem messages that are in the configuration
  file.
-------------------------------------------------------------------------*/

int WaitForResponse( unsigned int *len, int *wt )
{
	int 	tbp;
	int	i;
	int 	c;
	char	*str;
	char	*p;
	char	*pp;
	int 	ch;
	int	rc;

	TIME_OUT = FALSE;
	KEY_HIT = FALSE;

	tbp = 0;
	p = TempBuf;
	kbflush();
	if ( setjmp( fdenv ) )	{
		alarm( 0 );
		return( SendHangupString( len ) );
	}
	delay( ModemParms.defs[5] * 100 );
	alarm((*wt));
	do	{
		*p = char_waiting();
	}	while( (*p == '\r') || (*p == '\n'));
	p++; 	// Keep good char
	while ( (p-TempBuf) < (*len) )  {
		for ( i = 0; i < 15; i++ )	{
			if ( ( str = strstr( TempBuf, ModemParms.modemmsg[i] ) ) != NULL )	{
				rc = i;
				break;
			}
		}
		*p = char_waiting();
		if ( KEY_HIT )	{
			ch = tolower( getch() );
			if ( ch == ESCAPE )	{	// Cancel
				alarm( 0 );
				kbflush();
				KEY_HIT = FALSE;
				return( SendHangupString( len ) );
			}
			kbflush();
			KEY_HIT = FALSE;
		}
		else	{
			if ( ( *p == '\r' ) || ( *p == '\n' ) )
				break;
			p++;
		}
	}
	alarm(0);
	*p = '\0';
/*	if ( !str )
		strcpy( TempBuf, "UNKNOWN RESPONSE" );*/
	return( i );
}


int SendHangupString( unsigned int *len )
{
	int	tbp;
	int	c;
	char	*p;

	sprintf( buff, "%s\0", ModemParms.inits[1] );
	while( ( p = strstr( buff, "|" ) ) != NULL ) *p = '\r';
	SerialString( buff );
	delay( ModemParms.defs[5] * 100 );
	tbp = 0;
	while ( tbp < ( * len ) )  {
		if ( ( c = getccb() ) != -1 )	{
			if ( ( c == '\r' ) || ( c == '\n') )
				continue;
			TempBuf[tbp++] = c;
		}
		else	{
			break;
		}
	}
/*	pp = TempBuf;	*/
	return( 0 );
}

static void fdsigjmp( int sig )
{
	if ( sig == SIGTERM )	{
		if ( signal( SIGTERM, fdsigjmp  ) == SIG_ERR )
			fprintf(stderr,"Fatal SIGNAL error in fdsigjmp()\n");
		longjmp( fdenv, TRUE );		/*  give up */
	}
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void ReportModemStatus( void )
{
	int 			i, j;
	int			c;
	char			baud[32]="\0";
	unsigned long	newbaud;

	// Allow enough time for DCD interrupt

	delay( 200 );
	MakeWindow( 10, 18, 5, 45, LightCyan+CyanBG, LightCyan+CyanBG,
		Shadow, Frame2 );
	fswriteC( " Modem Reported ", 10, 80, LightCyan+CyanBG );
	if ( CARRIERON )	{
		c = inportb( portbase + MCR ) | RTS;
		outportb( portbase + MCR, c );
		fswriteC( "Carrier Detect!", 11, VidCols, Yellow+CyanBG );
	}
	fswriteC( TempBuf, 12, 80, Yellow+CyanBG );
	actualbaud = 0L;
	if ( CARRIERON )	{
//  	Ringing( 2 );
		Ringing2();

		// Try to guess the connected baud rate & set DTE

/*		if ( !ModemParms.defs[8] )	{
			i = j = 0;
			while ( ( isalpha( TempBuf[i] ) ) || ( isspace( TempBuf[i] ) ) ) {
				i++;
			}
			while( ( isdigit( TempBuf[i] ) ) && ( j < 10 ) ) 	{
				baud[j] = TempBuf[i];
				i++; j++;
			}
			newbaud = (unsigned long)atol( baud );
			if ( !newbaud )	{
				delay( 100 );
				CloseWindow();
				return;
			}
			else
			if ( !ChangeSpeed( newbaud ) )
				speed = newbaud;
			ChangeOthers( ModemParms.defs[3],
					ModemParms.defs[2],
					ModemParms.defs[4] );
		} */

		// Try to Determine actual baud...for effiecency reports

/*		i = j = 0;
		while ( ( isalpha( TempBuf[i] ) ) || ( isspace( TempBuf[i] ) ) ) {
			i++;
		}
		while( ( isdigit( TempBuf[i] ) ) && ( j < 10 ) ) 	{
			baud[j] = TempBuf[i];
			i++; j++;
		}
		actualbaud = (unsigned long)atol( baud ); */
		delay( 200 );
	}
	else	{
		delay( 2500 );
	}
	CloseWindow();
	return;
}


/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/
/*
void WaitModemResponse( char *str, unsigned int len, unsigned int wt )
{
	int 	tbp;
	char 	c;

	tmr = ( long )( wt * 20L );
	tbp = 0;
	strset( TempBuf, '\0' );
	while ( strstr( TempBuf, str ) == NULL )   {
		( long )--tmr;
		delay( 50 );
		if ( ( long )tmr == 0L )
			return;
		while ( ( ( c = getccb() ) != -1 ) && ( tbp < len ) )  {
			TempBuf[tbp++] = c;
		}
	}
	TempBuf[tbp] = '\0';
}
*/