
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			   All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include "fsvlib.h"
#include "mouse.h"

#define 		COM1    1
#define 		MCR	4
#define         DTR	0x01
#define         RTS	0x02
#define		ESCAPE	0x1b
#define			FALSE 	0
#define			TRUE	(!FALSE)

time_t 			tnow;


extern struct MODEMPARMS  {
	long			defs[10];
	char			inits[11][36];
	char			modemmsg[15][16];
} ModemParms;

extern char 		*EmuData1[7];
extern char 		*ModemPorts[2];
extern char 		*buff;
extern char far 	*TermScrn;
extern unsigned int	portbase;
extern int		M_event, M_buttonstatus;
extern int 		VTa, VTc, VTr, ch;
extern int 		VIPLOCAL, VIP, AUTOLF, ECHOON, ROLL;
extern int		KBSCAN;
extern unsigned int 	EmuMode;
extern int		M_event, M_xpos, M_ypos;
extern int		KB_101;
extern int		MouseInstalled;
int			MouseCol, MouseRow;

union REGS kbxr;

extern unsigned long speed;

void MovePDDown( unsigned int *Row, unsigned int *Col, unsigned int *Idx,
		unsigned int *MaxI );

void MovePD( unsigned int *Row, unsigned int *Col, unsigned int *Idx,
		unsigned int *MaxI, int Mr );

void MovePDUp( unsigned int *Row, unsigned int *Col, unsigned int *Idx,
		unsigned int *MaxI );

void HangUpLine( void );
void Whoop( void );
void Ringing( int duration );
void Ringing2( void );
void Bog( void );
void ClearMouseEvent( void );
void SaveTermScreen( void );
void RestTermScreen( void);
void Beep( unsigned int Freq );
void ShowDateTime( void );
void WaitForKeyPress( void );
void NoOp( void );
int WaitForEvent (void);
long ReadTimeMills( void );

/*-----------------------------------------------------------------------
------------------------------------------------------------------------*/

void MovePDDown(unsigned int *Row, unsigned int *Col, unsigned int *Idx,
		unsigned int *MaxI)
{
	fsattr( ( * Row ), ( * Col ), 1, 78, White+BlueBG );

/*	if ( ( * Idx ) == ( * MaxI ) )  {
		( * Idx ) = 0;
		( * Row ) = 2;
	}
	else  {
		( * Idx )++;
		( * Row )++;
	}	*/

	( * Idx )++;
	( * Row )++;
	( * Idx ) %= ( ( * MaxI ) + 1 );
	( * Row ) %= ( ( * MaxI ) + 3 );

	if ( !( * Row ) )
		( * Row ) = 2;

	fsattr( ( * Row ),( * Col ), 1, 78, Yellow+BlackBG );
	return;
}


void MovePD(unsigned int *Row, unsigned int *Col, unsigned int *Idx,
		unsigned int *MaxI, int Mr)
{
	fsattr( ( * Row ), ( * Col ), 1, 78, White+BlueBG );
	( * Row ) = Mr;
	( * Idx ) = ( Mr - 2 );
	fsattr( ( * Row ), ( * Col ), 1, 78, Yellow+BlackBG );
	return;
}


void MovePDUp(unsigned int *Row, unsigned int *Col, unsigned int *Idx,
		unsigned int *MaxI)
{
	fsattr( ( * Row ), ( * Col ), 1, 78, White+BlueBG );
	if ( !( * Idx ) )  {
		( * Idx ) = ( * MaxI );
		( * Row ) = ( * MaxI ) + 2;
	}
	else  {
		( * Idx )--;
		( * Row )--;
	}
	fsattr( ( * Row ), ( * Col ), 1, 78, Yellow+BlackBG );
	return;
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void HangUpLine()
{
	int c;
	char *pp;

	if ( !ModemParms.defs[7])  {
		sprintf(buff,"%s\0",ModemParms.inits[0]);
		SerialString(buff);
//		delay(ModemParms.defs[5] * 100);
		sprintf(buff,"%s\0",ModemParms.inits[1]);
		while((pp=strstr(buff,"|")) != NULL) *pp='\r';
		SerialString(buff);
	}
	else  {
		disable();
		c = inportb(portbase + MCR) & ~DTR;
		outportb(portbase + MCR, c);
//		delay(ModemParms.defs[5] * 100);
		delay( 2000 );
		c = inportb(portbase + MCR) | DTR | RTS;
		outportb(portbase + MCR, c);
		enable();
	}
	VTa = 0x03;
	return;
}




/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void Whoop(void)
{
	int i;

	for (i = 523; i < 880; i++)  {
		sound(i);
		delay(1);
	}
	for (i = 880; i > 523; i--)  {
		sound(i);
		delay(1);
	}
	nosound();
}


void Ringing( int duration )
{
	int 	i;
	int	j;

	for ( i = 0; i < duration; i++ )	{
		sound( 523 );
		delay( 40 );
		sound( 880 );
		delay( 25 );
		sound( 698 );
		delay( 40 );
		nosound();
		delay( 400 );
	}
}

void Ringing2( void )
{
	int 	i;

	for ( i = 0; i < 4; i++ )	{
		sound( 523 );
		delay( 40 );
		sound( 880 );
		delay( 25 );
		sound( 698 );
		delay( 40 );
		nosound();
		delay( 400 );
	}
}

void Bog(void)
{
	int i;

	for (i = 300; i > 30; i--)  {
		sound(i/4);
		delay(4);
	}
	nosound();
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void SaveTermScreen ()
{
	gettext (1, 1, 80, 25, (char far *)TermScrn);
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void RestTermScreen()
{
	 puttext (1, 1, 80, 25, (char far *)TermScrn);
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/


void Beep (unsigned int Freq)
{
  sound (523);
  delay (25);
  sound (880);
  delay (25);
  sound (698);
  delay (40);
  nosound();
}



/**********************************************************************/
/*                                                                    */
/**********************************************************************/

void ShowDateTime ()
{
  time (&tnow);
  sprintf (buff, "%s", ctime (&tnow));
  buff [(strlen (buff) -1 )] = '\0';
  fswrite (buff, 1, 56, LightCyan+BlueBG);
}


/**********************************************************************/
/*                                                                    */
/**********************************************************************/

void WaitForKeyPress ()
{
	while (!(M_event & 0x02)) {		// Check for left button
		if ( fast_kbhit() )
			break;
/*		ShowDateTime (); */
	}
	MouseCol = (M_xpos/8)+1;
	MouseRow = (M_ypos/8)+1;
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void NoOp ()
{
	int 	DONE;
	int	ch;

	MakeWindow(16,12,3,60,White+RedBG,White+RedBG,Shadow,
		Frame1);
	fswriteC("This option is reserved for future expansion.",17,80,
		White+RedBG);
	DisplayCmdLine( 8 );
	if ( MouseInstalled )
		Mshow();
	DONE = FALSE;
	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				switch( ch = toupper( getch() ))	{

					case 0x1B:	// Escape

						DONE = TRUE;
						break;

					default:

						break;
				}
				break;

			case MOUSE1BUTTON:

				DONE = TRUE;
				break;

			default:
				break;
		}
	} while( !DONE );
	kbflush();
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return;
}



void ClearMouseEvent()
{
	M_event ^= M_event;
}

/**********************************************************************/
/*       Function to wait for any event to happen.		      */
/*	 ie.  Character, mouse event.				      */
/*	 Pass back type of event occurred.			      */
/*								      */
/*	 Double click feature added 21 Jan 93			      */
/**********************************************************************/


/*
void interrupt far WaitForEvent ( long WFEmsg )
{
}

*/

int WaitForEvent ()
{

	static clock_t	mbtstart = 0;
	static clock_t  mbtend = 0;
	static int	MOUSE1CLICK = FALSE;

	M_event = 0;
	do	{
/*		if ( KB_101 )
			kbxr.h.ah = 0x11;
		else
			kbxr.h.ah = 0x01;
		int86( 0x16, &kbxr, &kbxr );
		if ( !( kbxr.x.flags & 0x40 ) )	{	// key hit?
		if ( kbhit() )	{	*/
		if ( fast_kbhit() )	{
//			KBSCAN = kbxr.h.ah;
			MOUSE1CLICK = FALSE;
			return( CHAR_EVENT );
		}
		mbtend = clock();
		if ( ( ( mbtend - mbtstart ) > ( float ) 5.0 ) &&
					 ( MOUSE1CLICK ) )
			MOUSE1CLICK = FALSE;
	}	while( !M_event );
	MouseCol = ( M_xpos >> 3 ) + 1;
	MouseRow = ( M_ypos >> 3 ) + 1;
	if ( M_event & 0x02 )	{
		if ( !MOUSE1CLICK )	{
			mbtstart = clock();
			MOUSE1CLICK = TRUE;
			return( MOUSE1BUTTON );
		}
		else	{
			if ( ( mbtend - mbtstart ) <=  (float) 5.0 )	{
				MOUSE1CLICK = FALSE;
				return( DOUBLE1CLICK );

			}
			else	{
				MOUSE1CLICK = FALSE;
				return( MOUSE1BUTTON );
			}
		}
	}
	else
	if ( M_event & 0x08 )	{
		MOUSE1CLICK = FALSE;
		return( MOUSE2BUTTON );
	}
/*	else
	if ( M_event & 0x01 )	{
		MOUSE1CLICK = FALSE;
		return( MOUSE_EVENT );
	}	*/
	else
	if ( M_event & 0x04 )	{
		return( MOUSE_EVENT );
	}
	return( MOUSE_EVENT );
}



long ReadTimeMills( void )
{

	union REGS 	r;
	long 		milliseconds;


	r.h.ah = 0x2c;

	int86( 0x21, &r, &r );

	milliseconds = (long) r.h.dl * 10;

	milliseconds += (long) r.h.dh * 1000;

	milliseconds += (long) r.h.cl * 60000L;

	milliseconds += (long) r.h.ch * 360000L;

	return( milliseconds );

}
