/*
				---------------------------------------
				PowerTerm (c) 1992-94  Byron D Copeland
					    All Rights Reserved.
				---------------------------------------

*/


#include <stdio.h>
#include <stdlib.h>
#include <dir.h>

#include "pckeys.h"
#include "fsvlib.h"
//#include "modem.h"
#include "mouse.h"

#define FALSE 0
#define TRUE (!FALSE)

#define COM1 1L
#define COM2 2L
#define COM3 3L
#define COM4 4L
#define COM5 5L
#define COM6 6L
#define COM7 7L
#define COM8 8L


typedef struct {                        // Filename:  PTCOM.DEF
	unsigned long		defs[10];
	char			inits[11][36];
	char			modemmsg[15][16];
}  MODEMPARMS;

typedef struct	{			// Filename:  PT.CFG
	char			Dirs[4][66];
} PTDEFS;

char MPFilename[13]="MODEM.DEF";


MODEMPARMS ModemParms;

typedef struct PortParms	{
	unsigned int		portnum;		// COM1 - COM8
	unsigned int		address;		//
	unsigned char		irqmask;		// IRQ0 - IRQ7
	unsigned int		irqline;		// 0 - 7
	unsigned int		intnum;			// 0x00 - 0xFF
	unsigned char		handshake;		// Handshake for port
} PORTS;

PORTS	PortDefs[8];

typedef struct	PTSETUP	{


	char	PTPaths[66];

} PTS;

PTS  PTSetup[4];

unsigned char	IRQMASKS[8]={ 0xfe, 0xfd, 0xfb, 0xf7,
							  0xef, 0xdf, 0xbf, 0x7f };

char *ModemPorts[8]={" COM1 "," COM2 "," COM3 "," COM4 "," COM5 ",
					 " COM6 "," COM7 "," COM8 "};

unsigned long ComPortNums[8]={0L, 1L, 2L, 3L, 4L, 5L, 6L, 7L};

char *ParityData1[5]={" None  "," Odd   "," Even  "," Mark  "," Space "};

char *EmuData1[8]={" TTY      "," VT52     "," VT102    "," ANSI     ",
				   " AVATAR   "," TEK4107C "," VIP7801  "," IBM3101  "};

char *ProtoData1[11]={" None           "," Ascii          "," Xmodem (CS)    ",
					  " Xmodem (CRC)   "," 1-K Xmodem     "," Ymodem         ",
					  " Ymodem Batch   "," Ymodem-G Batch "," Jmodem         ",
					  " SEAlink        "," Zmodem         "};

char *ModemMsgData1[15]={
	" Ok          "," 300         "," 1200        ",
	" 2400        "," 4800        "," 9600        ",
	" 19200       "," 38400       "," Busy        ",
	" Ring        "," Voice       "," Error       ",
	" No Carrier  "," No Dialtone "," No Answer   "};

char *ModemInitData1[11]={
	" Escape Code   "," Onhook        ",
	" Offhook       "," Return Online ",
	" Attention     "," Reset         ",
	" Dial          ","  Prefix     ",
	"  Suffix     "," Init-1        ",
	" Init-2        "};

char	*ModemDefsData1[10]={
	" Default Port                ",
	" Default Baud Rate           ",
	" Default Data Bits           ",
	" Default Parity              ",
	" Default Stop Bits           ",
	" Modem Delay (ms)            ",
	" Timeout Delay (secs)        ",
	" Lower DTR to Terminate Call ",
	" Lock DTE at default baud    ",
	" Default Terminal Emulation  "};

char *ModemSpeeds[9]={
	" 300    "," 1200   "," 2400   "," 4800   ",
	" 9600   "," 19200  "," 38400  ",
	" 57600  "," 115200 "};

char *PhoneDirData1[13]={
	" Name          "," Phone Number  ",
	" Speed         "," Data Bits     ",
	" Stop Bits     "," Parity        ",
	" Protocol      "," Emulation     ",
	" CR Expansion  "," Local Echo    ",
	" Xlate In      "," XLate Out     ",
	" Macro Name    "};

extern char 		*InitBuf;
extern char 		MsgBuf[16];
extern char 		DefsBuf[10];
extern char 		*buff;
extern char		*PTEnviron;
extern char		*TempBuf;
extern char		*MacFile;

int	   		ParityData2[5]={0x00,0x08,0x18,0x28,0x38};

extern int		VIP;
extern int		PRECCHG;
extern int		UPPERONLY;
extern unsigned int	EmuMode;
extern unsigned int	VTa;
extern unsigned int	VIPEMU;
extern int		MouseInstalled;
extern int		MouseRow;
extern int		MouseCol;


void		SetModemHardware( void );
void		GetNewComPort( unsigned long *Port );
void		GetNewBaudRate( unsigned long *baudvar );
void		ToggleYNSwitch( unsigned int Idx, unsigned int *Row,
					unsigned int *Col );
void		SetModemHStrings( void );
void		SetModemHMessages( void );
void		LoadModemDefaults( void );
void		LoadModemInits( void );
void		LoadModemMsgDefs( void );
void		SaveModemDefaults( void );
unsigned int 	SwitchEmulation( unsigned int emu );
unsigned int 	SelectProtocol( unsigned int pro );
void		ComPortSetup( void );
void		PTDirSetup( void );
int 		readSetupFiles( void );


/*------------------------------------------------------------------------
	Function to set default port values, ie. Baud rate, bits, parity.
-------------------------------------------------------------------------*/

void SetModemHardware()
{
	int 			SDD = FALSE;
	int 			EDITOK;
	int 			j;
	int				i;
	unsigned int 	SDDIdx = 0;
	unsigned int 	SDDRow = 12;
	unsigned int 	SDDCol = 38;
	unsigned int 	SDDMax = 21;
	unsigned int 	SDDMin = 12;
	unsigned int 	SDDMaxI = 9;
	unsigned int 	Col = 7;
	int	     		ch;
	int	     		key;

	ExplodeWindow( 10, 5, 13, 43, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow,	Frame1 );
	fswrite("[", 10, 7, LightCyan+BlueBG );
	fswriteM("", LightGreen+BlueBG );
	fswriteM( "]", LightCyan+BlueBG );
	fswrite(" Port Parameters ",10,18,LightCyan+BlueBG);
	for ( i = 12, j = 0; j < 10; j++, i++ )  {
	  fswrite( ModemDefsData1[j], i, Col, LightCyan+BlueBG );
	}
	i = 12;
	fswrite( ModemPorts[ (unsigned int) ( ModemParms.defs[0] )], i++,
		SDDCol-1, White+BlueBG );

	// Baud

	sprintf ( buff, "%lu  ", ModemParms.defs[1] );
	fswrite ( buff, i++, SDDCol,LastAttr );

	// Data Bits

	sprintf( buff,"%u ", (unsigned int) ModemParms.defs[2] );
	fswrite( buff, i++, SDDCol, LastAttr );

	// Parity

	fswrite( ParityData1[(unsigned int) (ModemParms.defs[3])], i++,
		SDDCol - 1, White+BlueBG );

	// Stop Bits

	sprintf( buff, "%u", (unsigned int) ModemParms.defs[4] );
	fswrite( buff, i++, SDDCol, White+BlueBG );

	// Modem Delay

	sprintf( buff, "%u", (unsigned int)ModemParms.defs[5] );
	fswrite( buff, i++, SDDCol,	White+BlueBG );

	// Timeout Delay

	sprintf( buff, "%u", ( unsigned int ) ModemParms.defs[6] );
	fswrite( buff, i++, SDDCol, White+BlueBG );

	// DTR

	if ( ModemParms.defs[7] )
		fswrite ( "Yes", i++, SDDCol, LastAttr );
	else
		fswrite ( "No ", i++, SDDCol, LastAttr );

	// Lock DTE

	if ( ModemParms.defs[8] )
		fswrite ( "Yes", i++, SDDCol, LastAttr );
	else
		fswrite ( "No ", i++, SDDCol, LastAttr );
	fswrite( EmuData1[( ( unsigned int )ModemParms.defs[9] ) ], i++, SDDCol - 1, LastAttr );
	fswrite( ModemDefsData1[SDDIdx], SDDRow, 7, Yellow+CyanBG );
	setstrng( DefsBuf, '', 2 );
	DisplayCmdLine( 1 );
	if ( MouseInstalled )
		Mshow();
	kbflush();
	do	{

		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )	{

					case ESCAPE:

						SDD = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )  {

							case F2:

								if ( MouseInstalled )
									Mhide();
								LoadModemDefaults();
								strset( DefsBuf, ' ' );
								fswrite( DefsBuf, 18, SDDCol,
									White+BlueBG );
								i = 16;
								fswrite( ModemPorts[( int )( ModemParms.defs[0] ) - 1], i++,
									SDDCol-1, White+BlueBG );
								sprintf( buff, "%lu  ", ModemParms.defs[1] );
								fswrite( buff, i++, SDDCol, LastAttr );
								sprintf( buff, "%u ", ModemParms.defs[2] );
								fswrite( buff, i++, SDDCol, LastAttr );
								if ( ModemParms.defs[3] )
									fswrite( "Yes", i++, SDDCol, LastAttr );
								else
									fswrite( "No ", i++, SDDCol, LastAttr );
								if ( MouseInstalled )
									Mshow();
								break;

							case DN:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarDown( ModemDefsData1,
									&SDDIdx, &SDDRow, &SDDMin,
									&Col, &SDDMaxI, LightCyan+BlueBG,
										Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarUp( ModemDefsData1,
									&SDDIdx, &SDDRow, &SDDMax,
									&Col, &SDDMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								break;
						}
						break;

					case CR:

						switch( SDDIdx )  {

							case 0:

								if ( MouseInstalled )
									Mhide();
								GetNewComPort( &ModemParms.defs[0] );
								fswrite( ModemPorts[( ModemParms.defs[0] )],
									SDDRow,SDDCol-1,White+BlueBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case 1:

								if ( MouseInstalled )
									Mhide();
								GetNewBaudRate( &ModemParms.defs[1] );
								sprintf( buff,"%lu  ",ModemParms.defs[1] );
								fswrite( buff, SDDRow, SDDCol,White+BlueBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case 2:                            // data bits

								if ( MouseInstalled )
									Mhide();
								EDITOK = FALSE;
								do	{
									setstrng( DefsBuf, '', 1 );
									EditIntValue( &ModemParms.defs[SDDIdx], 1,
										SDDRow, SDDCol, DefsBuf, 8,
										Cyan+BlueBG, White+CyanBG, White+BlueBG );
									if ( ( ModemParms.defs[SDDIdx] >= 5 ) &&
										( ModemParms.defs[SDDIdx] <= 8 ) )
										EDITOK = TRUE;
									else
										Beep( 250 );
								}	while ( !EDITOK );
								if ( MouseInstalled )
									Mshow();
								break;

							case 3:

								if ( MouseInstalled )
									Mhide();
								GetNewParity( &ModemParms.defs[SDDIdx] );
								fswrite( ParityData1[(unsigned int) (ModemParms.defs[3])], SDDRow,
									SDDCol - 1, White+BlueBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case 4:				// Stop bits

								if ( MouseInstalled )
									Mhide();
								EDITOK = FALSE;
								do	{
									setstrng(DefsBuf,'',1);
									EditIntValue( &ModemParms.defs[SDDIdx], 1,
										SDDRow, SDDCol, DefsBuf, 2,
										Cyan+BlueBG, White+CyanBG, White+BlueBG);
									if ( ( ModemParms.defs[SDDIdx] >= 1 ) &&
										( ModemParms.defs[SDDIdx] <= 2 ) )
										EDITOK = TRUE;
									else
										Beep( 250 );
								}	while( !EDITOK );
								if ( MouseInstalled )
									Mshow();
								break;

							case 5:

								if ( MouseInstalled )
									Mhide();
								EDITOK = FALSE;
								do	{
									setstrng( DefsBuf, '', 2 );
									EditIntValue( &ModemParms.defs[SDDIdx], 2,
										SDDRow, SDDCol, DefsBuf, 99,
										Cyan+BlueBG, White+CyanBG, White+BlueBG );
									if ( ( ModemParms.defs[SDDIdx] >= 0 ) &&
										( ModemParms.defs[SDDIdx] <= 99 ) )
										EDITOK = TRUE;
									else
										Beep( 250 );
								}	while ( !EDITOK );
								if (MouseInstalled)
									Mshow();
								break;

							case 6:

								if ( MouseInstalled )
									Mhide();
								EDITOK = FALSE;
								do	{
									setstrng( DefsBuf, '', 2 );
									EditIntValue( &ModemParms.defs[SDDIdx], 2,
										SDDRow, SDDCol, DefsBuf, 99,
										Cyan+BlueBG, White+CyanBG, White+BlueBG );
									if ( ( ModemParms.defs[SDDIdx] >= 0 ) &&
										( ModemParms.defs[SDDIdx] <= 99 ) )
										EDITOK = TRUE;
									else
										Beep( 250 );
								}	while ( !EDITOK );
								if ( MouseInstalled )
									Mshow();
								break;

							case 7:

								if ( MouseInstalled )
									Mhide();
								ToggleYNSwitch( SDDIdx, &SDDRow, &SDDCol );
								if ( MouseInstalled )
									Mshow();
								break;

							case 8:

								if ( MouseInstalled )
									Mhide();
								ToggleYNSwitch( SDDIdx, &SDDRow, &SDDCol );
								if ( MouseInstalled )
									Mshow();
								break;

							case 9:

								if ( MouseInstalled )
									Mhide();
								ModemParms.defs[SDDIdx] =
									( unsigned long )SwitchEmulation( ( unsigned int )ModemParms.defs[SDDIdx] );
								fswrite( EmuData1[( ( unsigned int )ModemParms.defs[9] ) ], SDDRow, SDDCol - 1, White+BlueBG );
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								break;

						}
						DisplayCmdLine( 1 );
						break;

					default:

						Beep( 500 );
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( ( MouseRow == 10 ) && ( MouseCol == 8 ) )	{
					SDD = TRUE;
					break;
				}

				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseRow >= SDDMin ) && ( MouseRow <= SDDMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col+28 ) ) ) )	{
					MoveMenuBar( ModemDefsData1,
						&SDDIdx, &SDDRow, MouseRow,
						&SDDMin, &Col, &SDDMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
/*					switch( SDDIdx )  {

						case 0:

							GetNewComPort( &ModemParms.defs[0] );
							fswrite ( ModemPorts[(ModemParms.defs[0] )],
								SDDRow,SDDCol-1,White+BlueBG );
							break;

						case 1:

							GetNewBaudRate( &ModemParms.defs[1] );
							sprintf( buff,"%lu  ",ModemParms.defs[1] );
							fswrite( buff,SDDRow,SDDCol,White+BlueBG );
							break;

						case 2:

							EDITOK = FALSE;
							do	{
								setstrng( DefsBuf, '', 1 );
								EditIntValue( &ModemParms.defs[SDDIdx], 1,
									SDDRow, SDDCol, DefsBuf, 8,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 5 ) &&
									( ModemParms.defs[SDDIdx] <= 8 ) )
									EDITOK = TRUE;
							}	while ( !EDITOK );
							break;

						case 3:

							GetNewParity( &ModemParms.defs[SDDIdx] );
							fswrite( ParityData1[(unsigned int) (ModemParms.defs[3] )], SDDRow,
								SDDCol - 1, White+BlueBG );
							break;

						case 4:

							EDITOK = FALSE;
							do	{
								setstrng( DefsBuf, '', 1 );
								EditIntValue( &ModemParms.defs[SDDIdx], 1,
									SDDRow, SDDCol, DefsBuf, 2,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 1 ) &&
									( ModemParms.defs[SDDIdx] <= 2 ) )
									EDITOK = TRUE;
								else
									Beep( 250 );
							}	while ( !EDITOK );
							break;

						case 5:

							EDITOK = FALSE;
							do 	{
								setstrng( DefsBuf, '', 2 );
								EditIntValue( &ModemParms.defs[SDDIdx], 2,
									SDDRow, SDDCol, DefsBuf, 99,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 0 ) &&
									( ModemParms.defs[SDDIdx] <= 99 ) )
									EDITOK = TRUE;
								else
									Beep( 250 );
							}	while( !EDITOK );
							break;

						case 6:

							EDITOK = FALSE;
							do	{
								setstrng( DefsBuf, '', 2 );
								EditIntValue( &ModemParms.defs[SDDIdx], 2,
									SDDRow, SDDCol, DefsBuf, 99,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 0 ) &&
									( ModemParms.defs[SDDIdx] <= 99 ) )
									EDITOK = TRUE;
								else
									Beep( 250 );
							}	while( !EDITOK );
							break;

						case 7:

							ToggleYNSwitch( SDDIdx, &SDDRow, &SDDCol );
							break;

						case 8:

							ToggleYNSwitch( SDDIdx, &SDDRow, &SDDCol );
							break;

						default:
							break;
					}
					DisplayCmdLine( 1 );	*/
				}
				if ( MouseInstalled )
					Mshow();
				break;

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= SDDMin ) && ( MouseRow <= SDDMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col+28 ) ) ) )	{
					MoveMenuBar( ModemDefsData1,
						&SDDIdx, &SDDRow, MouseRow,
						&SDDMin, &Col, &SDDMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
					switch( SDDIdx )  {

						case 0:

							GetNewComPort( &ModemParms.defs[0] );
							fswrite( ModemPorts[( ModemParms.defs[0] )],
								SDDRow,SDDCol-1,White+BlueBG );
							break;

						case 1:

							GetNewBaudRate( &ModemParms.defs[1] );
							sprintf( buff,"%lu  ",ModemParms.defs[1] );
							fswrite( buff, SDDRow, SDDCol, White+BlueBG );
							break;

						case 2:

							EDITOK = FALSE;
							do	{
								setstrng( DefsBuf, '', 1 );
								EditIntValue( &ModemParms.defs[SDDIdx], 1,
									SDDRow, SDDCol, DefsBuf, 8,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 5 ) &&
									( ModemParms.defs[SDDIdx] <= 8 ) )
									EDITOK = TRUE;
							}	while ( !EDITOK );
							break;

						case 3:

							GetNewParity( &ModemParms.defs[SDDIdx] );
							fswrite( ParityData1[( unsigned int ) ( ModemParms.defs[3] )], SDDRow,
								SDDCol - 1, White+BlueBG );
							break;

						case 4:

							EDITOK = FALSE;
							do	{
								setstrng( DefsBuf, '', 1 );
								EditIntValue( &ModemParms.defs[SDDIdx], 1,
									SDDRow, SDDCol, DefsBuf, 2,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 1 ) &&
									( ModemParms.defs[SDDIdx] <= 2 ) )
									EDITOK = TRUE;
								else
									Beep( 250 );
							}	while ( !EDITOK );
							break;

						case 5:

							EDITOK = FALSE;
							do 	{
								setstrng( DefsBuf, '', 2 );
								EditIntValue( &ModemParms.defs[SDDIdx], 2,
									SDDRow, SDDCol, DefsBuf, 99,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 0 ) &&
									( ModemParms.defs[SDDIdx] <= 99 ) )
									EDITOK = TRUE;
								else
									Beep( 250 );
							}	while( !EDITOK );
							break;

						case 6:

							EDITOK = FALSE;
							do	{
								setstrng( DefsBuf, '', 2 );
								EditIntValue( &ModemParms.defs[SDDIdx], 2,
									SDDRow, SDDCol, DefsBuf, 99,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );
								if ( ( ModemParms.defs[SDDIdx] >= 0 ) &&
									( ModemParms.defs[SDDIdx] <= 99 ) )
									EDITOK = TRUE;
								else
									Beep( 250 );
							}	while( !EDITOK );
							break;

						case 7:

							ToggleYNSwitch( SDDIdx, &SDDRow, &SDDCol );
							break;

						case 8:

							ToggleYNSwitch( SDDIdx, &SDDRow, &SDDCol );
							break;

						case 9:

							ModemParms.defs[SDDIdx] =
								( unsigned long )SwitchEmulation( ( unsigned int )ModemParms.defs[SDDIdx] );
							fswrite( EmuData1[( ( unsigned int )ModemParms.defs[9] ) ], SDDRow, SDDCol - 1, White+BlueBG );
							break;

						default:
							break;
					}
					DisplayCmdLine( 1 );
				}
				if ( MouseInstalled )
					Mshow();

				break;

/*			case MOUSE2BUTTON:

				SDD = TRUE;
				break;*/

			default:
				break;
		}
	} 	while ( !SDD );
	kbflush();
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return;
}

/*------------------------------------------------------------------------
	Function to allow selection of com port, ie. COM1 or COM2, etc...
-------------------------------------------------------------------------*/

void GetNewComPort( unsigned long *Port )
{
	int 		GNP = FALSE;
	int		i;
	unsigned int 	MPIdx = 0;
	unsigned int 	MPRow = 11;
	unsigned int 	Col = 60;
	unsigned int 	MPMaxI = 7;
	unsigned int 	MPMax = 18;
	unsigned int 	MPMin = 11;
	int	     	ch;
	int		key;

	MakeWindow( 10, 59, 10, 8, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow,	Frame1 );
	for ( i = 0; i < 8; i++ )  {
	  fswrite( ModemPorts[i], ( i + 11 ), 60, LightCyan+BlueBG );
	}
	fswrite( ModemPorts[0], 11, 60, Yellow+CyanBG );
	DisplayCmdLine( 5 );
	if ( MouseInstalled )
		Mshow();
	do  {
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch ) 	{

					case ESCAPE:

						GNP=TRUE;
						break;

					case CR:

						( *Port ) = ComPortNums[MPIdx];
						GNP = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )  {

							case DN:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarDown( ModemPorts,
								&MPIdx, &MPRow, &MPMin,
								&Col, &MPMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarUp( ModemPorts,
								&MPIdx, &MPRow, &MPMax,
								&Col, &MPMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								break;
						}
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseRow >= MPMin ) && ( MouseRow <= MPMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col+5 ) ) ) )	{
					MoveMenuBar( ModemPorts,
						&MPIdx, &MPRow, MouseRow,
						&MPMin,	&Col, &MPMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
/*					( unsigned long )( *Port ) =
						ComPortNums[MPIdx];
					GNP = TRUE;	*/
				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				GNP = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseRow >= MPMin ) && ( MouseRow <= MPMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col+5 ) ) ) )	{
					MoveMenuBar( ModemPorts,
						&MPIdx, &MPRow, MouseRow,
						&MPMin,	&Col, &MPMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
					( unsigned long )( *Port ) =
						ComPortNums[MPIdx];
					GNP = TRUE;
				}
				if ( MouseInstalled )
					Mshow();
				break;

			default:

				break;
		}
	} while ( !GNP );
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return;
}

/*------------------------------------------------------------------------
	Function to allow selction of baud rate.
-------------------------------------------------------------------------*/

void GetNewBaudRate( unsigned long *baudvar )
{
	int 		GNB = FALSE;
	unsigned int 	MSIdx = 0;
	unsigned int 	MSRow = 11;
	unsigned int 	Col = 60;
	unsigned int 	MSMaxI = 8;
	unsigned int 	MSMax = 19;
	unsigned int 	MSMin = 11;
	int		i;
	int		ch;
	int		key;

	MakeWindow( 10, 59, 11, 10, LightCyan+BlueBG, LightCyan+BlueBG,
			Shadow,	Frame1 );
	for ( i = 0; i < 9; i++ )  {
	  fswrite( ModemSpeeds[i], ( i + 11 ), 60, LightCyan+BlueBG );
	}
	fswrite( ModemSpeeds[0], 11, 60, Yellow+CyanBG );
	DisplayCmdLine( 5 );
	if ( MouseInstalled )
		Mshow();
	do  {
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )  {

					case ESCAPE:

						GNB = TRUE;
						break;

					case CR:

						( *baudvar ) =
							( unsigned long )atol(ModemSpeeds[MSIdx]);
						PRECCHG = TRUE;
						GNB = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )  {

							case DN:

								if ( MouseInstalled)
									Mhide();
								MoveMenuBarDown( ModemSpeeds,
									&MSIdx, &MSRow, &MSMin,
									&Col, &MSMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarUp( ModemSpeeds,
									&MSIdx, &MSRow, &MSMax,
									&Col, &MSMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mhide();
								break;

							default:

								break;
						}
						break;
					default:
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseRow >= MSMin ) && ( MouseRow <= MSMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 7 ) ) ) )	{
					MoveMenuBar( ModemSpeeds,
						&MSIdx, &MSRow, MouseRow,
						&MSMin,	&Col, &MSMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );

/*					( *baudvar ) =
						( unsigned long )atol( ModemSpeeds[MSIdx] );
					GNB = TRUE;	*/
				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				GNB = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseRow >= MSMin ) && ( MouseRow <= MSMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 7 ) ) ) )	{
					MoveMenuBar( ModemSpeeds,
						&MSIdx, &MSRow, MouseRow,
						&MSMin,	&Col, &MSMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );

					( *baudvar ) =
						( unsigned long )atol( ModemSpeeds[MSIdx] );
					PRECCHG = TRUE;
					GNB = TRUE;
				}
				if ( MouseInstalled )
					Mshow();
				break;

			default:

				break;
		}
	} while( !GNB );
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return;
}

/*------------------------------------------------------------------------
	Function to toggle a yes/no setting for a type of parameter.
-------------------------------------------------------------------------*/

void ToggleYNSwitch( unsigned int Idx, unsigned int *Row, unsigned int *Col )
{
	if ( ModemParms.defs[Idx] )  {
		ModemParms.defs[Idx] = FALSE;
		fswrite( "No ", ( *Row ), ( *Col ), White+BlueBG );
		PRECCHG = TRUE;
	}
	else  {
		ModemParms.defs[Idx] = TRUE;
		fswrite( "Yes", ( *Row ), ( *Col ), White+BlueBG );
		PRECCHG = TRUE;
	}
}


/*------------------------------------------------------------------------
	Function to set up modem initialization strings.
-------------------------------------------------------------------------*/

void SetModemHStrings( void )
{
	unsigned int 	j;
	unsigned int 	i;
	unsigned int 	SMSIdx = 0;
	int 		SMS = FALSE;

	unsigned int 	SMSRow = 11;
	unsigned int 	SMSCol = 24;
	unsigned int 	SMSMax = 21;
	unsigned int 	SMSMin = 11;
	unsigned int 	SMSMaxI = 10;
	unsigned int 	Col = 7;
	int		ch;
	int		key;

//	MakeWindow( 9, 5, 15, 56, LightCyan+BlueBG, LightCyan+BlueBG,
//			Shadow,	Frame1 );
	ExplodeWindow( 9, 5, 14, 56, LightCyan+BlueBG, LightCyan+BlueBG,
			Shadow,	Frame1 );
	fswrite( "[", 9, 7, LightCyan+BlueBG );
	fswriteM( "", LightGreen+BlueBG );
	fswriteM( "]", LightCyan+BlueBG );
	fswrite( " Modem Init Strings ", 9, 22, LightCyan+BlueBG );
	for ( i = 11, j = 0; j < 11; j++, i++ )  {
		fswrite( ModemInitData1[j], i, 7, LightCyan+BlueBG );
		fswrite( ModemParms.inits[j], i, SMSCol, White+BlueBG );
	}
	fswrite( ModemInitData1[SMSIdx], SMSRow, 7, Yellow+CyanBG );
	setstrng( InitBuf, '', 35 );
	DisplayCmdLine( 1 );
	if ( MouseInstalled )
		Mshow();
	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )  {

					case ESCAPE:

						SMS = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )  {

							case F2:

								if ( MouseInstalled )
									Mhide();
								LoadModemInits();
								setstrng( InitBuf, ' ',35 );
								for ( i = 11, j = 0; j < 11; j++, i++ )  {
									fswrite( InitBuf, i, SMSCol,
										White+BlueBG );
									fswrite( ModemParms.inits[j],
										i, SMSCol, White+BlueBG );
								}
								if ( MouseInstalled )
									Mshow();
								break;

							case DN:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarDown( ModemInitData1,
									&SMSIdx, &SMSRow, &SMSMin,
									&Col, &SMSMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarUp( ModemInitData1,
									&SMSIdx, &SMSRow, &SMSMax,
									&Col, &SMSMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								break;
						}
						break;

					case CR:

						if ( MouseInstalled )
							Mhide();
						setstrng( InitBuf, '', 35 );
						EditStringValue( ModemParms.inits[SMSIdx], 35,
							SMSRow, SMSCol, InitBuf,
							Cyan+BlueBG, White+CyanBG, White+BlueBG );
						DisplayCmdLine( 1 );
						if ( MouseInstalled )
							Mshow();
						break;

					default:

						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( ( MouseRow == 9 ) && ( MouseCol == 8 ) )	{
					SMS = TRUE;
					break;
				}
				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 14 ) ) ) &&
					( ( MouseRow >= SMSMin ) && ( MouseRow <= SMSMax ) ) )	{
					MoveMenuBar( ModemInitData1,
						&SMSIdx, &SMSRow,
						MouseRow,
						&SMSMin,
						&Col, &SMSMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
/*					setstrng( InitBuf, '', 35 );
					EditStringValue( ModemParms.inits[SMSIdx], 35,
						SMSRow, SMSCol, InitBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					DisplayCmdLine( 1 );	*/

				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				SMS = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 14 ) ) ) &&
					( ( MouseRow >= SMSMin ) && ( MouseRow <= SMSMax ) ) )	{
					MoveMenuBar( ModemInitData1,
						&SMSIdx, &SMSRow,
						MouseRow,
						&SMSMin,
						&Col, &SMSMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
					setstrng( InitBuf, '', 35 );
					EditStringValue( ModemParms.inits[SMSIdx], 35,
						SMSRow, SMSCol, InitBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					DisplayCmdLine( 1 );

				}
				if ( MouseInstalled )
					Mshow();
				break;


			default:

				break;
		}
	} 	while ( !SMS );
	kbflush();
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return;
}

/*------------------------------------------------------------------------
	Function to set up modem result messages.
-------------------------------------------------------------------------*/

void SetModemHMessages( void )
{
	unsigned int 	SMMIdx = 0;
	unsigned int 	j;
	unsigned int 	i;
	int 		SMM = FALSE;
	int		ch;
	int		key;
	unsigned int 	SMMMaxI = 14;
	unsigned int 	Col = 3;

	unsigned int SMMRow = 7;
	unsigned int SMMCol = 18;
	unsigned int SMMMax = 21;
	unsigned int SMMMin = 7;

//	MakeWindow( 5, 2, 19, 33, LightCyan+BlueBG, LightCyan+BlueBG,
//		Shadow,	Frame1 );
	ExplodeWindow( 5, 2, 18, 33, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow,	Frame1 );
	fswrite( "[", 5, 4, LightCyan+BlueBG );
	fswriteM( "", LightGreen+BlueBG );
	fswriteM( "]", LightCyan+BlueBG );
	fswrite( " Modem Messages ", 5, 10, LightCyan+BlueBG );
	for ( i = 7, j = 0; j < 15; j++, i++ )  {
		fswrite( ModemMsgData1[j], i, 3, LightCyan+BlueBG );
		fswrite( ModemParms.modemmsg[j], i, SMMCol, White+BlueBG );
	}
	fswrite( ModemMsgData1[SMMIdx], 7, 3, Yellow+CyanBG );
	setstrng( MsgBuf, '', 15 );
	DisplayCmdLine( 1 );
	if ( MouseInstalled )
		Mshow();
	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )  {

					case ESCAPE:
						SMM = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )  {

							case F2:

								if ( MouseInstalled )
									Mhide();
								LoadModemMsgDefs();
								setstrng( MsgBuf, ' ', 15 );
								for ( i = 7, j = 0; j < 15; j++, i++ )  {
									fswrite( MsgBuf, i, SMMCol,
										White+BlueBG );
									fswrite( ModemParms.modemmsg[j],
										i, SMMCol, White+BlueBG );
								}
								if ( MouseInstalled )
									Mshow();
								break;

							case DN:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarDown( ModemMsgData1,
									&SMMIdx, &SMMRow, &SMMMin,
									&Col, &SMMMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarUp( ModemMsgData1,
									&SMMIdx, &SMMRow, &SMMMax,
									&Col, &SMMMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								break;
						}
						break;

					case CR:

						if ( MouseInstalled )
							Mhide();
						setstrng( MsgBuf, '', 15 );
						EditStringValue( ModemParms.modemmsg[SMMIdx], 15,
							SMMRow, SMMCol, MsgBuf,
							Cyan+BlueBG, White+CyanBG, White+BlueBG );
						DisplayCmdLine( 1 );
						if ( MouseInstalled )
							Mshow();
						break;

					default:

						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( ( MouseRow == 5 ) && ( MouseCol == 5 ) )	{
					SMM = TRUE;
					break;
				}
				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 12 ) ) ) &&
					( ( MouseRow >= SMMMin ) && ( MouseRow <= SMMMax ) ) )	{
					MoveMenuBar( ModemMsgData1,
						&SMMIdx, &SMMRow,
						MouseRow,
						&SMMMin,
						&Col, &SMMMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
/*					setstrng( MsgBuf, '', 15 );
					EditStringValue( ModemParms.modemmsg[SMMIdx], 15,
						SMMRow, SMMCol, MsgBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					DisplayCmdLine( 1 );	*/

				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				SMM = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();
				if ( ( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 12 ) ) ) &&
					( ( MouseRow >= SMMMin ) && ( MouseRow <= SMMMax ) ) )	{
					MoveMenuBar( ModemMsgData1,
						&SMMIdx, &SMMRow,
						MouseRow,
						&SMMMin,
						&Col, &SMMMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
					setstrng( MsgBuf, '', 15 );
					EditStringValue( ModemParms.modemmsg[SMMIdx], 15,
						SMMRow, SMMCol, MsgBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					DisplayCmdLine( 1 );

				}
				if ( MouseInstalled )
					Mshow();
				break;


			default:

				break;
		}
	} 	while ( !SMM );
	kbflush();
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return;
}

/*------------------------------------------------------------------------
	Function to set up port defaults if config file missing or when
	requested by user.
-------------------------------------------------------------------------*/

void LoadModemDefaults( void )
{
	ModemParms.defs[0] = 0L;		// Com1
	ModemParms.defs[1] = 9600L;		// Baud
	ModemParms.defs[2] = 8L;		// Data
	ModemParms.defs[3] = 0L;		// Parity
	ModemParms.defs[4] = 1L;		// Stop
	ModemParms.defs[5] = 10L;		// Modem Delay
	ModemParms.defs[6] = 60L;		// Timeout
	ModemParms.defs[7] = TRUE;		// DTR
	ModemParms.defs[8] = TRUE;		// Lock DTE
	ModemParms.defs[9] = 0L;		// Default Emulation
}

/*------------------------------------------------------------------------
	Function to set up port defaults if config file missing or when
	requested by user.
-------------------------------------------------------------------------*/

void LoadModemInits( void )
{
	int	i;

	for ( i = 0; i < 11; i++ )
		strset( ModemParms.inits[i], '\0' );
	strcpy( ModemParms.inits[0], "~+++~\0" );
	strcpy( ModemParms.inits[1], "ATH0|\0" );
	strcpy( ModemParms.inits[2], "ATH1|\0" );
	strcpy( ModemParms.inits[3], "ATO|\0" );
	strcpy( ModemParms.inits[4], "AT|\0" );
	strcpy( ModemParms.inits[5], "ATZ|\0" );
	strcpy( ModemParms.inits[6], "ATDT\0" );
	strcpy( ModemParms.inits[7], "\0" );
	strcpy( ModemParms.inits[8], "|\0" );
	strcpy( ModemParms.inits[9], "ATE0M0&C1&D2|\0" );
	strcpy( ModemParms.inits[10], "ATV1B1H0|\0" );
}

/*------------------------------------------------------------------------
	Function to set up port defaults if config file missing or when
	requested by user.
-------------------------------------------------------------------------*/

void LoadModemMsgDefs( void )
{
	int 	i;

	for ( i = 0; i < 15; i++ )
		strset( ModemParms.modemmsg[i], '\0' );
	strcpy( ModemParms.modemmsg[0], "OK\0" );
	strcpy( ModemParms.modemmsg[1], "CONNECT|\0" );
	strcpy( ModemParms.modemmsg[2], "CONNECT 1200\0" );
	strcpy( ModemParms.modemmsg[3], "CONNECT 2400\0" );
	strcpy( ModemParms.modemmsg[4], "CONNECT 4800\0" );
	strcpy( ModemParms.modemmsg[5], "CONNECT 9600\0" );
	strcpy( ModemParms.modemmsg[6], "CONNECT 14400\0" );
	strcpy( ModemParms.modemmsg[7], "CONNECT 19200\0" );
	strcpy( ModemParms.modemmsg[8], "BUSY\0" );
	strcpy( ModemParms.modemmsg[9], "RING|\0" );
	strcpy( ModemParms.modemmsg[10], "VOICE\0" );
	strcpy( ModemParms.modemmsg[11], "ERROR\0" );
	strcpy( ModemParms.modemmsg[12], "NO CARRIER\0" );
	strcpy( ModemParms.modemmsg[13], "NO DIALTONE\0" );
	strcpy( ModemParms.modemmsg[14], "NO ANSWER\0" );
}


/*------------------------------------------------------------------------
	Function to set up port defaults if config file missing or when
	requested by user.
-------------------------------------------------------------------------*/


void LoadComPortDefaults( void )
{
	PortDefs[0].portnum	= 0;
	PortDefs[0].address 	= 0x3F8;	// COM1
	PortDefs[0].irqmask	= IRQMASKS[4];
	PortDefs[0].irqline	= 4;
	PortDefs[0].intnum	= 0x0C;
	PortDefs[0].handshake = 0x00;
	PortDefs[1].portnum	= 1;
	PortDefs[1].address 	= 0x2F8;	// COM2
	PortDefs[1].irqmask	= IRQMASKS[3];
	PortDefs[1].irqline	= 3;
	PortDefs[1].intnum	= 0x0B;
	PortDefs[1].handshake = 0x00;
	PortDefs[2].portnum	= 2;
	PortDefs[2].address 	= 0x3E8;	// COM3
	PortDefs[2].irqmask	= IRQMASKS[4];
	PortDefs[2].irqline	= 4;
	PortDefs[2].intnum	= 0x0C;
	PortDefs[2].handshake = 0x00;
	PortDefs[3].portnum	= 3;
	PortDefs[3].address 	= 0x2E8;	// COM4
	PortDefs[3].irqmask	= IRQMASKS[3];
	PortDefs[3].irqline	= 3;
	PortDefs[3].intnum	= 0x0B;
	PortDefs[3].handshake = 0x00;
	PortDefs[4].portnum	= 4;
	PortDefs[4].address 	= 0x3F8;	// COM5
	PortDefs[4].irqmask	= IRQMASKS[4];
	PortDefs[4].irqline	= 4;
	PortDefs[4].intnum	= 0x0C;
	PortDefs[4].handshake = 0x00;
	PortDefs[5].portnum	= 5;
	PortDefs[5].address 	= 0x3F8;	// COM6
	PortDefs[5].irqmask	= IRQMASKS[4];
	PortDefs[5].irqline	= 4;
	PortDefs[5].intnum	= 0x0C;
	PortDefs[5].handshake = 0x00;
	PortDefs[6].portnum	= 6;
	PortDefs[6].address 	= 0x3F8;	// COM7
	PortDefs[6].irqmask	= IRQMASKS[4];
	PortDefs[6].irqline	= 4;
	PortDefs[6].intnum	= 0x0C;
	PortDefs[6].handshake = 0x00;
	PortDefs[7].portnum	= 7;
	PortDefs[7].address 	= 0x3F8;	// COM8
	PortDefs[7].irqmask	= IRQMASKS[4];
	PortDefs[7].irqline	= 4;
	PortDefs[7].intnum	= 0x0C;
	PortDefs[7].handshake = 0x00;
}


/*------------------------------------------------------------------------
	Function to save parameters.
-------------------------------------------------------------------------*/

void SaveModemDefaults( void )
{
	FILE 	*MF;
	FILE 	*PTF;
	int	ch;
	int	i;
	int	SavQuit;

	MakeWindow( 13, 10, 6, 60, LightCyan+BlackBG, LightCyan+BlackBG,
			Shadow, Frame2 );
	fswriteC( "You are about to save Setup Parameters!", 15, VidCols,
		Cyan+BlackBG );
	fswriteC( "Continue (Y/n) ?", 16, VidCols, LastAttr );

	kbflush();
	WaitForKeyPress();
	ch = toupper( getch() );
	if ( ( ch == 'Y' ) || ( ch == CR ) )  {

		// Save PT Modem Defs

		if ( ( MF = fopen( "PTCOM.DEF", "wb" ) ) == NULL )  {
			CloseWindow();
			return;
		}
		else	{
			if ( ( fwrite( &ModemParms, (size_t) sizeof( MODEMPARMS ), 1, MF ) ) != 1 )  {
				CloseWindow();
				fclose( MF );
				return;
			}
			for ( i = 0; i < 8; i++ )	{
				if ( ( fwrite( &PortDefs[i], (size_t)sizeof( PORTS ), 1, MF ) ) != 1 )  {
					CloseWindow();
					fclose( MF );
					return;
				}
			}
			fclose( MF );
		}

		// Save PT Setups

		if ( ( PTF = fopen( "PT.DEF", "wb" ) ) == NULL )  {
			CloseWindow();
			return;
		}
		else  {

		// Write PT Definitions

			for ( i = 0; i < 4; i++ )	{
				if ( ( fwrite( &PTSetup[i],
					( size_t ) sizeof( PTS ), 1, PTF ) ) != 1 )  {
					fprintf( stderr, "Write Error in PT.DEF file.\n" );
					fclose( PTF );
					return;
				}
			}
			fclose( PTF );
		}
	}

	CloseWindow();
	return;
}

/*------------------------------------------------------------------------
	Function to allow selection of terminal emulation.  This is used
	during online sessions or when building a phone record.
-------------------------------------------------------------------------*/

unsigned int SwitchEmulation( unsigned int emu )
{
	unsigned int 	SEIdx = 0;
	int 		j;
	int 		SE = FALSE;
	int		ch;
	int		key;
	unsigned int 	SEMaxI = 7;
	unsigned int 	Col = 60;

	unsigned int SERow = 9;
	unsigned int SECol = 60;
	unsigned int SEMax = 16;
	unsigned int SEMin = 9;

	MakeWindow( 8, 59, 10, 12, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow,	Frame1 );
	for ( SEIdx = 0; SEIdx < 8; SEIdx++ )
		fswrite( EmuData1[SEIdx], ( SEIdx + 9 ), 60,
			LightCyan+BlueBG );
	SEIdx = 0;
	fswrite( EmuData1[SEIdx], SERow, SECol, Yellow+CyanBG );
	if ( MouseInstalled )	{
		DisplayCmdLine( 6 );
		Mshow();
	}
	else
		DisplayCmdLine( 5 );
	do  {
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch( ch )	{

					case ESCAPE:

						SE = TRUE;
						break;

					case CR:

						emu = SEIdx;
						SE = TRUE;
						VTa = 0x03;
						PRECCHG = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )	{

							case DN:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarDown( EmuData1,
									&SEIdx, &SERow, &SEMin,
									&Col, &SEMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarUp( EmuData1,
									&SEIdx, &SERow, &SEMax,
									&Col, &SEMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								break;
						}
						break;

					default:

						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= SEMin ) && ( MouseRow <= SEMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= (Col + 13) ) ) )	{
					MoveMenuBar( EmuData1,	&SEIdx,
						&SERow, MouseRow, &SEMin,
						&Col, &SEMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
/*					emu = SEIdx;
					SE = TRUE;
					VTa = 0x07;	*/
				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				SE = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= SEMin ) && ( MouseRow <= SEMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 13 ) ) ) )	{
					MoveMenuBar( EmuData1,	&SEIdx,
						&SERow, MouseRow, &SEMin,
						&Col, &SEMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
					emu = SEIdx;
					SE = TRUE;
					VTa = 0x03;
				}
				if ( MouseInstalled )
					Mshow();
				break;


			default:
				break;
		}
	} while( !SE );
	kbflush();
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	VIP = ( emu == VIPEMU ) ? TRUE : FALSE;
	return( emu );
}


/*------------------------------------------------------------------------
	Function to allow selection of transfer protocol.  This is used
	during online sessions or when building a phone record.
-------------------------------------------------------------------------*/

unsigned int SelectProtocol( unsigned int pro )
{
	unsigned int 	PRIdx = 0;
	int 		j;
	int 		PR = FALSE;
	int		ch;
	int		key;
	unsigned int 	PRMaxI = 10;
	unsigned int 	Col = 60;

	unsigned int PRRow = 9;
	unsigned int PRCol = 60;
	unsigned int PRMax = 19;
	unsigned int PRMin = 9;

	MakeWindow( 8, 59, 13, 18, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow,	Frame1 );
	for ( PRIdx = 0; PRIdx < 11; PRIdx++ )
		fswrite( ProtoData1[PRIdx], ( PRIdx + 9 ), 60,
			LightCyan+BlueBG );
	PRIdx = 0;
	fswrite( ProtoData1[PRIdx], PRRow, PRCol, Yellow+CyanBG );
	if ( MouseInstalled )	{
		DisplayCmdLine( 6 );
		Mshow();
	}
	else
		DisplayCmdLine( 5 );
	do  {
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch( ch )	{

					case ESCAPE:

						PR = TRUE;
						break;

					case CR:

						pro = PRIdx;
						PR = TRUE;
						PRECCHG = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )	{

							case DN:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarDown( ProtoData1,
									&PRIdx, &PRRow, &PRMin,
									&Col, &PRMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							case UP:

								if ( MouseInstalled )
									Mhide();
								MoveMenuBarUp( ProtoData1,
									&PRIdx, &PRRow, &PRMax,
									&Col, &PRMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								break;
						}
						break;

					default:

						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= PRMin ) && ( MouseRow <= PRMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= (Col + 15) ) ) )	{
					MoveMenuBar( ProtoData1,	&PRIdx,
						&PRRow, MouseRow, &PRMin,
						&Col, &PRMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
/*					pro = PRIdx;
					PR = TRUE;
					VTa = 0x07;	*/
				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				PR = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= PRMin ) && ( MouseRow <= PRMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col + 15 ) ) ) )	{
					MoveMenuBar( ProtoData1,	&PRIdx,
						&PRRow, MouseRow, &PRMin,
						&Col, &PRMaxI, LightCyan+BlueBG,
						Yellow+CyanBG );
					pro = PRIdx;
					PR = TRUE;
				}
				if ( MouseInstalled )
					Mshow();
				break;


			default:
				break;
		}
	} while( !PR );
	kbflush();
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	return( pro );
}


/*------------------------------------------------------------------------
	Function to set up port addresses, irq's and vectors.
-------------------------------------------------------------------------*/

void ComPortSetup( void )
{
	int 		ch;
	int		key;
	int		i;
	int		RADIX16 = 16;
	int		CPSQUIT = FALSE;
	unsigned int	CPSIdx = 0;
	unsigned int	CPSMin = 15;
	unsigned int	CPSRow = 15;
	unsigned int	CPSMax = 22;
	unsigned int	CPSMaxI = 7;
	unsigned int	Col = 11;

	char			HexBuf[5]="\0";
	char			*p;
	char			*stopat;

//	MakeWindow( 10, 10, 14, 60, LightCyan+BlueBG, LightCyan+BlueBG,
//		Shadow, Frame1 );
	ExplodeWindow( 10, 10, 13, 60, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow, Frame1 );
	fswrite( "[", 10, 12, LightCyan+BlueBG );
	fswriteM( "", LightGreen+BlueBG );
	fswriteM( "]", LightCyan+BlueBG );
	fswriteC( "Port Configuration", 10, VidCols, LightCyan+BlueBG );
	for ( i = 0; i < 8; i++ )	{
		fswrite( ModemPorts[i], i + 15, 11, LightCyan+BlueBG );
		fswrite( "", i + 15, 17, LightCyan+BlueBG );
	}
	fswrite( " Base             IRQ    ", 12, 21, LightCyan+BlueBG );
	fswrite( "Address           Line           Interrupt", 13, 21,
		LightCyan+BlueBG );

	for ( i = 0; i < 8; i++ )	{
		fswrite( "0x", i + 15, 22, White+BlueBG );
		sprintf( buff, "%03x\0", PortDefs[i].address );
		p = buff;
		while( *p++ )
			*( p - 1 ) = toupper( *( p - 1 ) );
		fswriteM( buff, LastAttr );
		sprintf( buff, "IRQ%d\0", PortDefs[i].irqline );
		fswrite( buff, ( i + 15 ), 39, LastAttr );
		fswrite( "0x", ( i + 15 ), 56, LastAttr );
		sprintf( buff, "%02x\0", PortDefs[i].intnum );
		p = buff;
		while( *p++ )
			*( p - 1 ) = toupper( *( p - 1 ) );
		fswriteM( buff, LastAttr );
	}
	fswrite( ModemPorts[0], 15, 11, Yellow+CyanBG );

	DisplayCmdLine( 1 );
	if ( MouseInstalled )
		Mshow();

	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )	{

					case CR:

						if ( MouseInstalled )
							Mhide();
						sprintf( HexBuf, "%03x\0", PortDefs[CPSIdx].address );
						p = HexBuf;
						while( *p++ )
							*( p - 1 ) = toupper( *( p - 1 ) );
						setstrng( InitBuf, '', 3 );
						EditHexValue( HexBuf, 3,
							CPSRow, 24, InitBuf,
							Cyan+BlueBG, White+CyanBG, White+BlueBG );
						sprintf( buff, "0x%s\0", HexBuf );		// Fixup for Radix-16
						PortDefs[CPSIdx].address =
							( int )strtoul( buff, &stopat, RADIX16 );

						setstrng( InitBuf, '', 1 );
						EditIntValue( &PortDefs[CPSIdx].irqline, 1,
							CPSRow, 42, InitBuf, 7,
							Cyan+BlueBG, White+CyanBG, White+BlueBG);

						sprintf( HexBuf, "%02x\0", PortDefs[CPSIdx].intnum );
						p = HexBuf;
						while( *p++ )
							*( p - 1 ) = toupper( *( p - 1 ) );
						setstrng( InitBuf, '', 2 );
						EditHexValue( HexBuf, 2,
							CPSRow, 58, InitBuf,
							Cyan+BlueBG, White+CyanBG, White+BlueBG );
						sprintf( buff, "0x%s\0", HexBuf );		// Fixup for Radix-16
						PortDefs[CPSIdx].intnum =
							( int )strtoul( buff, &stopat, RADIX16 );
						DisplayCmdLine( 1 );
						if ( MouseInstalled )
							Mshow();
						break;

					case ESCAPE:

						CPSQUIT = TRUE;
						break;

					case SPECIALKEY:

						if ( MouseInstalled )
							Mhide();

						key = getch();
						switch( key )	{

							case F1:

								GiveUserHelp( "M03B.HLP" );
								break;

							case DN:

								MoveMenuBarDown( ModemPorts,
									&CPSIdx, &CPSRow, &CPSMin,
									&Col, &CPSMaxI, LightCyan+BlueBG,
										Yellow+CyanBG );
								break;

							case UP:

								MoveMenuBarUp( ModemPorts,
									&CPSIdx, &CPSRow, &CPSMax,
									&Col, &CPSMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								break;

							case END:

								MoveMenuBar( ModemPorts,
									&CPSIdx, &CPSRow, CPSMax,
									&CPSMin, &Col, &CPSMaxI,
									LightCyan+BlueBG, Yellow+CyanBG );

								break;

							case HOME:

								MoveMenuBar( ModemPorts,
									&CPSIdx, &CPSRow, CPSMin,
									&CPSMin, &Col, &CPSMaxI,
									LightCyan+BlueBG, Yellow+CyanBG );

								break;

							default:
								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					default:
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( ( MouseRow == 10 ) && ( MouseCol == 13 ) )	{
					CPSQUIT = TRUE;
					break;
				}
				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= CPSMin ) && ( MouseRow <= CPSMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col+5 ) ) ) )	{

					MoveMenuBar( ModemPorts,
						&CPSIdx, &CPSRow, MouseRow,
						&CPSMin, &Col, &CPSMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
/*					sprintf( HexBuf, "%03x\0", PortDefs[CPSIdx].address );
					p = HexBuf;
					while( *p++ )
						*( p - 1 ) = toupper( *( p - 1 ) );
					setstrng( InitBuf, '', 3 );
					EditHexValue( HexBuf, 3,
						CPSRow, 24, InitBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					sprintf(buff, "0x%s", HexBuf );		// Fixup for radix-16
					PortDefs[CPSIdx].address =
						( int )strtoul( buff, &stopat, RADIX16 );

					setstrng( InitBuf, '', 1 );
					EditIntValue( &PortDefs[CPSIdx].irqline, 1,
						CPSRow, 42, InitBuf, 7,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );

					sprintf( HexBuf, "%02x\0", PortDefs[CPSIdx].intnum );
					p = HexBuf;
					while( *p++ )
						*( p - 1 ) = toupper( *( p - 1 ) );
					setstrng( InitBuf, '', 2 );
					EditHexValue( HexBuf, 2,
						CPSRow, 58, InitBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					sprintf(buff, "0x%s\0", HexBuf );		// Fixup for Radix-16
					PortDefs[CPSIdx].intnum =
						( int )strtoul( buff, &stopat, RADIX16 );
					DisplayCmdLine( 1 );	*/

				}
				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				CPSQUIT = TRUE;
				break;*/

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= CPSMin ) && ( MouseRow <= CPSMax ) ) &&
					( ( MouseCol >= Col ) && ( MouseCol <= ( Col+5 ) ) ) )	{

					MoveMenuBar( ModemPorts,
						&CPSIdx, &CPSRow, MouseRow,
						&CPSMin, &Col, &CPSMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
					sprintf( HexBuf, "%03x\0", PortDefs[CPSIdx].address );
					p = HexBuf;
					while( *p++ )
						*( p - 1 ) = toupper( *( p - 1 ) );
					setstrng( InitBuf, '', 3 );
					EditHexValue( HexBuf, 3,
						CPSRow, 24, InitBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					sprintf( buff, "0x%s", HexBuf );		// Fixup for radix-16
					PortDefs[CPSIdx].address =
						( int )strtoul( buff, &stopat, RADIX16 );

					setstrng( InitBuf, '', 1 );
					EditIntValue( &PortDefs[CPSIdx].irqline, 1,
						CPSRow, 42, InitBuf, 7,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );

					sprintf( HexBuf, "%02x\0", PortDefs[CPSIdx].intnum );
					p = HexBuf;
					while( *p++ )
						*( p - 1 ) = toupper( *( p - 1 ) );
					setstrng( InitBuf, '', 2 );
					EditHexValue( HexBuf, 2,
						CPSRow, 58, InitBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
					sprintf(buff, "0x%s\0", HexBuf );		// Fixup for Radix-16
					PortDefs[CPSIdx].intnum =
						( int )strtoul( buff, &stopat, RADIX16 );
					DisplayCmdLine( 1 );

				}
				if ( MouseInstalled )
					Mshow();
				break;

			default:
				break;
		}
	}	while( !CPSQUIT );

	// Set up correct masks for any IRQ's changed

	PortDefs[0].irqmask = IRQMASKS[ ( PortDefs[0].irqline ) ];
	PortDefs[1].irqmask = IRQMASKS[ ( PortDefs[1].irqline ) ];
	PortDefs[2].irqmask = IRQMASKS[ ( PortDefs[2].irqline ) ];
	PortDefs[3].irqmask = IRQMASKS[ ( PortDefs[3].irqline ) ];
	PortDefs[4].irqmask = IRQMASKS[ ( PortDefs[4].irqline ) ];
	PortDefs[5].irqmask = IRQMASKS[ ( PortDefs[5].irqline ) ];
	PortDefs[6].irqmask = IRQMASKS[ ( PortDefs[6].irqline ) ];
	PortDefs[7].irqmask = IRQMASKS[ ( PortDefs[7].irqline ) ];

	if ( MouseInstalled )
		Mhide();
	CloseWindow();

}


/*------------------------------------------------------------------------
	Function to set up upload and download directory paths.
-------------------------------------------------------------------------*/


void PTDirSetup( void )
{
	int		i;
	unsigned int	PTDCol = 7;
	unsigned int	Col = 20;
	unsigned int	PTDIdx = 0;
	unsigned int	PTDMaxI = 3;
	unsigned int	PTDMin = 13;
	int		PTDRows[4]={ 13, 14, 18, 19 };
	int		PTDQuit;
	int		ch;
	int		key;
	int		drv;
	int		PTPGood;
	char		*PTDTags[4] = { " Download: \0", "   Upload: \0",
					" Download: \0", "   Upload: \0" };

	PTDQuit = FALSE;
	PTDIdx = 0;

	MakeWindow( 9, 5, 14, 70, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow, Frame1 );
	fswrite( "[", 9, 7, LightCyan+BlueBG );
	fswriteM( "", LightGreen+BlueBG );
	fswriteM( "]", LightCyan+BlueBG );
	fswriteC( "Default Directory Paths Setup", 9, VidCols, LightCyan+BlueBG );
	fswrite( "Terminal Mode", 11, PTDCol, Yellow+BlueBG );
	fswrite( "  Download:  ", 13, PTDCol, LightCyan+BlueBG );
	fswriteM( PTSetup[PTDIdx++].PTPaths, White+BlueBG );
	fswrite( "    Upload:  ", 14, PTDCol, LightCyan+BlueBG );
	fswriteM( PTSetup[PTDIdx++].PTPaths, White+BlueBG );
	fswrite( "Host Mode", 16, PTDCol, Yellow+BlueBG );
	fswrite( "  Download:  ", 18, PTDCol, LightCyan+BlueBG );
	fswriteM( PTSetup[PTDIdx++].PTPaths, White+BlueBG );
	fswrite( "    Upload:  ", 19, PTDCol, LightCyan+BlueBG );
	fswriteM( PTSetup[PTDIdx].PTPaths, White+BlueBG );

	PTDIdx = 0;
	++PTDCol;
	fsattr( PTDRows[PTDIdx], PTDCol, 1, (strlen( PTDTags[PTDIdx] ) ),
			Yellow+CyanBG );

	if ( MouseInstalled )
		Mshow();

	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = getch();
				switch( ch )	{

					case ESCAPE:

						PTDQuit = TRUE;
						break;

					case CR:

						if ( MouseInstalled )
							Mhide();
						PTPGood = FALSE;
						UPPERONLY = TRUE;
						do	{
							setstrng( InitBuf, '', 53 );
							EditStringValue( PTSetup[PTDIdx].PTPaths, 53,
								PTDRows[PTDIdx], Col, InitBuf,
								Cyan+BlueBG, White+CyanBG, White+BlueBG );

							// Check existance of Path

							PTPGood = TRUE;
						}	while( !PTPGood );
						UPPERONLY = FALSE;

						// Ensure we have slashes at end of path

						if ( strlen(PTSetup[PTDIdx].PTPaths) > 0 )	{
							if ( PTSetup[PTDIdx].PTPaths[strlen(PTSetup[PTDIdx].PTPaths) - 1] != '\\' )
								strcat( PTSetup[PTDIdx].PTPaths, "\\" );
						}
						if ( MouseInstalled )
							Mshow();

						break;

					case SPECIALKEY:

						if ( MouseInstalled )
							Mhide();
						key = getch();
						switch( key )	 {

							case DN:

								fsattr( PTDRows[PTDIdx], PTDCol, 1,
									(strlen( PTDTags[PTDIdx] ) ),
									LightCyan+BlueBG );

								if ( PTDIdx == PTDMaxI )
									PTDIdx = 0;
								else
									PTDIdx++;

								fsattr( PTDRows[PTDIdx], PTDCol, 1,
									( strlen( PTDTags[PTDIdx] ) ),
									Yellow+CyanBG );

								break;

							case UP:

								fsattr( PTDRows[PTDIdx], PTDCol, 1,
									( strlen( PTDTags[PTDIdx] ) ),
									LightCyan+BlueBG );

								if ( PTDIdx == 0 )
									PTDIdx = PTDMaxI;
								else
									PTDIdx--;

								fsattr( PTDRows[PTDIdx], PTDCol, 1,
									( strlen( PTDTags[PTDIdx] ) ),
									Yellow+CyanBG );

								break;

							default:
								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					default:

						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( ( MouseRow == 9 ) && ( MouseCol == 8 ) )	{
					PTDQuit = TRUE;
					break;
				}
				if ( MouseInstalled )
					Mhide();
				if ( ( MouseCol >= 8 ) && ( MouseCol <= ( PTDCol + 10 ) ) )	{
					switch( MouseRow )	{

						case 13:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );
							PTDIdx = 0;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );

							break;

						case 14:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );
							PTDIdx = 1;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );
							break;

						case 18:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );
							PTDIdx = 2;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );
							break;

						case 19:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );

							PTDIdx = 3;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );
							break;

						default:

							Beep( 100 );
							break;

					}
				}
				else
					Beep( 100 );

				if ( MouseInstalled )
					Mshow();

				break;

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();

				if ( ( MouseCol >= 8 ) && ( MouseCol <= ( PTDCol + 10 ) ) )	{
					switch( MouseRow )	{

						case 13:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );
							PTDIdx = 0;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );
							PTPGood = FALSE;
							UPPERONLY = TRUE;
							do	{
								setstrng( InitBuf, '', 53 );
								EditStringValue( PTSetup[PTDIdx].PTPaths, 53,
									PTDRows[PTDIdx], Col, InitBuf,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );

							// Check existance of Path

								PTPGood = TRUE;
							}	while( !PTPGood );

							// Ensure we have slashes at end of path

							if ( strlen(PTSetup[PTDIdx].PTPaths) > 0 )	{
								if ( PTSetup[PTDIdx].PTPaths[strlen(PTSetup[PTDIdx].PTPaths) - 1] != '\\' )
									strcat( PTSetup[PTDIdx].PTPaths, "\\" );
							}
							UPPERONLY = FALSE;
							break;

						case 14:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );
							PTDIdx = 1;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );
							PTPGood = FALSE;
							UPPERONLY = TRUE;
							do	{
								setstrng( InitBuf, '', 53 );
								EditStringValue( PTSetup[PTDIdx].PTPaths, 53,
									PTDRows[PTDIdx], Col, InitBuf,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );

							// Check existance of Path

								PTPGood = TRUE;
							}	while( !PTPGood );
							UPPERONLY = FALSE;
							break;

						case 18:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );
							PTDIdx = 2;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );
							PTPGood = FALSE;
							UPPERONLY = TRUE;
							do	{
								setstrng( InitBuf, '', 53 );
								EditStringValue( PTSetup[PTDIdx].PTPaths, 53,
									PTDRows[PTDIdx], Col, InitBuf,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );

							// Check existance of Path

								PTPGood = TRUE;
							}	while( !PTPGood );
							UPPERONLY = FALSE;
							break;

						case 19:

							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								LightCyan+BlueBG );

							PTDIdx = 3;
							fsattr( PTDRows[PTDIdx], PTDCol, 1,
								( strlen( PTDTags[PTDIdx] ) ),
								Yellow+CyanBG );
							PTPGood = FALSE;
							UPPERONLY = TRUE;
							do	{
								setstrng( InitBuf, '', 53 );
								EditStringValue( PTSetup[PTDIdx].PTPaths, 53,
									PTDRows[PTDIdx], Col, InitBuf,
									Cyan+BlueBG, White+CyanBG, White+BlueBG );

							// Check existance of Path

								PTPGood = TRUE;
							}	while( !PTPGood );
							UPPERONLY = FALSE;
							break;

						default:

							Beep( 100 );
							break;
					}
				}
				else
					Beep( 100 );

				if ( MouseInstalled )
					Mshow();
				break;

/*			case MOUSE2BUTTON:

				PTDQuit = TRUE;
				break;*/

			default:
				break;
		}
	}	while( !PTDQuit );

	if ( MouseInstalled )
		Mhide();

	CloseWindow();
}


/*------------------------------------------------------------------------
	Function to read config information from files.
-------------------------------------------------------------------------*/

int readSetupFiles( void )
{

	int	i;
	int	drv;
	char	f1[13]="PTCOM.DEF\0";
	char   	f2[13]="PT.DEF\0";
	char	f3[13]="DEFAULT.MAC\0";
	FILE	*MPF;
	FILE    *PTF;


	if ( *PTEnviron )	{
		if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
			sprintf( TempBuf, "%s\\%s", PTEnviron, f1 );
		else
			sprintf( TempBuf, "%s%s", PTEnviron, f1 );
	}
	if ( ( MPF = fopen( TempBuf, "rb" ) ) == NULL )  {
		LoadModemDefaults();
		LoadModemInits();
		LoadModemMsgDefs();
		LoadComPortDefaults();
		return( 0 );
	}
	else  {
		if ( ( fread( &ModemParms,
			( size_t )sizeof( MODEMPARMS ), 1, MPF ) ) != 1 )  {
			fclose( MPF );
			return( -1 );
		}
		for ( i = 0; i < 8; i++ )	{
			if ( ( fread( &PortDefs[i],
				( size_t ) sizeof(PORTS ), 1, MPF ) ) != 1 )  {
				fclose( MPF );
				return( -1 );
			}
		}
		fclose( MPF );
	}

	if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
		sprintf( TempBuf, "%s\\%s", PTEnviron, f2 );
	else
		sprintf( TempBuf, "%s%s", PTEnviron, f2 );

	if ( ( PTF = fopen( TempBuf, "rb" ) ) == NULL )  {
		drv = getdisk();
		getcurdir( drv+1, TempBuf );

		for ( i = 0; i < 4; i++ )
			sprintf( PTSetup[i].PTPaths, "%c:\\%s\\", drv+'A', TempBuf );
//		LoadPTDefaults();
	}
	else  {

		// Read PT Definitions

		for ( i = 0; i < 4; i++ )	{
			if ( ( fread( &PTSetup[i],
				( size_t ) sizeof( PTS ), 1, PTF ) ) != 1 )  {
				fclose( PTF );
				return( -1 );
			}
		}
		fclose( PTF );
	}

	// See if we have a default macro file.  Otherwise create one.

	if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
		sprintf( MacFile, "%s\\%s", PTEnviron, f3 );
	else
		sprintf( MacFile, "%s%s", PTEnviron, f3 );

	if ( ReadMacroFile( MacFile ) == -1 )	{
		InitMacroKeys();	// Set to blank fields.
		SaveMacroKeys( MacFile );
	}
	return( 0 );
}


/*------------------------------------------------------------------------
			PowerTerm v0.01 (c) 1992-1993 Byron D Copeland
-------------------------------------------------------------------------*/