
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			  All Rights Reserved.
		---------------------------------------

*/

#define VERSION 		0x01
#define VIDEOINT 		0x10
#define FALSE           0
#define NOERROR			0
#define TRUE           	(!FALSE)

/*  Structure for maintaining correct window sizes for each       */
/*  pull-down menu.                                               */

struct POS  {
	unsigned int 	Row;
	unsigned int 	Col;
	unsigned int 	RowMin;
	unsigned int 	MaxIdx;
	unsigned int 	RowMax;
	unsigned int 	MaxRows;
	unsigned int 	MaxCol;
};

struct POS MenPos[10];

struct 	MSPOS  {
	unsigned int 	Row;
	unsigned int 	Col;
	unsigned int 	RowMin;
	unsigned int 	MaxIdx;
	unsigned int 	RowMax;
	unsigned int 	MaxRows;
	unsigned int 	MaxCol;
};

struct {
	void ( *pointer ) ();
} Term[20];

struct {
	void ( *pointer ) ();
} Fkey[20];

struct {
	void ( *pointer ) ();
} Tkey[20];

extern struct MODEMPARMS {
	unsigned long	defs[9];
	char			inits[11][36];
	char			modemmsg[15][16];
}  ModemParms;

extern struct PORTS	{
	unsigned int		portnum;		// COM1 - COM8
	unsigned int		address;		//
	unsigned char		irqmask;		// IRQ0 - IRQ7
	unsigned int		irqline;		// 0 - 7
	unsigned int		intnum;			// 0x00 - 0xFF
	unsigned char		handshake;
} PortDefs[8];

extern struct	PTS	{

	char		PTPaths[66];

} PTSetup[4];

extern unsigned PDIdx;

struct MSPOS 	MSPos[10];
struct date 	date;
struct ffblk	fileinfo;

int            	SError = NOERROR;
unsigned int	portbase;
int            	ECHOON;
int		LFON;
int		KB_101;
unsigned char	KBSCAN;
int		INSMODE;
int		STATLINE;
int	       	NOECHO;
int		ROLL;
int		VIP;
int		VIPLOCAL;
int		VIPHIDE;
int		AUTOLF;
int            	tstat;
int		MenuLevel;
int            	VTc;
int		VTr;
int		VTa;
int		VTwt;
int		VTwb;
int		fc;
int		PrtFlag;
int            	ABORT;
int		DEFCHG;
int		NUMLOCK;
int		HLPOPEN;
int		UPPERONLY;
int	       	tbp;
int		PRECCHG;
// int				TimeOutV;
int         	parity   = NO_PARITY;
int         	bits     = 8;
int         	stopbits = 1;
int    		bytesr;
int		FL;
int		FnChk;
int		MouseInstalled;

unsigned int  	port;
unsigned    	WaitTime = 10;
unsigned	MSOpIdx;
unsigned	MSPosIdx;
unsigned	MenOpIdx;
unsigned	MenPosIdx;
unsigned	MainMax;
unsigned	EmuMode;
unsigned	VIPEMU;
unsigned	OLDVMODE;
unsigned	filestodo;
unsigned	fileslefttodo;

long            tmr;
unsigned long  	speed;
unsigned long 	savspeed;
unsigned long	actualbaud;




char		*M10[10];
char		*M20[10];
char		*M30[10];
char 		*M40[10];
char 		*M30A[10];
char		*PTEnviron;
unsigned char 		*buff;
char 		*fp;
char 		**M[10];
char 		**MS[10];
char 		*filestoxfer[20];
char		*WCNames[1000];
char far 	*TermScrn;
char 		*pp;
char		*p;
char 		*fileswork1;
char 		*fileswork2;
char 		*TempBuf;
char 		*InitBuf;
char 		MsgBuf[16]="\0";
char 		DefsBuf[10]="\0";
char 		TempNum[20]="\0";
char 		vt102SU[10]="\033`I\0";		   	// Enable PC-type Insert Mode
char 		CURRPT[10]="\033[%d;%dR\0";                // Response to ESC[?6n

char		Serial_Number[13]="UNREGISTERED";
unsigned char	PTChkSum=0;
unsigned char	PTVerify='Z';

jmp_buf		ptenv;

extern int	M_xpos;
extern int	M_ypos;
extern int	M_buttonstatus;
extern int	M_eventcount;
extern int	M_event;
extern int	MacChk;
extern int	timeleft;
extern int	ParityData2[5];
extern int	TIME_OUT;
extern int	KEY_HIT;
extern int	MouseRow;
extern int	MouseCol;
extern int	M_event;
extern int	VIP_STS_LINE_IN_USE;


/*---------------------------------------------------------------------
	Local function declarations
 ---------------------------------------------------------------------*/


int		  	main( void );
void interrupt far	c_break( void );
void interrupt far  	c_break2( void );
void 			(interrupt far *old_brk)();
void 			(interrupt far *old_brk2)();




int			WaitForModemMsg( char *buff2, int secs );
void 			waitmsg( int sig );
void 			LightUpQuit( void );
void 			SetQuitOn( int *QuitFlag );
void 			SysInfo( void );
extern void		RegistrationInfo( void );
void 			SystemProcs( void );
void 			dosShell( void );
void 			DisplayM10( void );
void 			DisplayM20( void );
void 			DisplayM30( void );
void 			DisplayM40( void );
void 			DisplayM30A( void );
void 			ProcessSubMenuLvl_1( void );
void 			DisplayMainMenuLine( void );
static void 		ptsigjmp( int sig );			/* Timer interrupt handler */

/*--------------------------------------------------------------------
	External function declarations
 --------------------------------------------------------------------*/

extern void		TerminalOps( void );
extern char 		*lstrip(char *p);
extern void 		tstrip(char *p);
extern void 		SetModemHardware( void );
extern void 		SetModemHStrings( void );
extern void 		SetModemHMessages( void );
extern void 		SaveModemDefaults( void );
extern void 		PTDirSetup( void );
extern void 		NoOp( void );
extern void 		ProcessTTY( int c );
extern void 		ProcessVT52( int c );
extern void 		ProcessVT102( int c );
extern void 		ProcessANSI( int c );
extern void 		ProcessTK4107C( int c );
extern void 		ProcessAVATAR( int c );
extern void 		ProcessVip7801( int c );
extern void 		ProcessI3101( int c );
extern void 		VT102SKeys( int key );
extern void		ANSIKeys( int key );
extern void		ANSITab( void );
extern void 		VT102Tab( void );
extern void 		Tek4107SKeys( int key );
extern void 		Tek4107Tab( void );
extern void 		I3101SKeys( int key );
extern void 		I3101Tab( void );
extern void		Vip7801Tab( void );
extern void 		VIP7801SKeys( int key );
extern void 		ComPortSetup( void );
extern void 		EditMacroKeys( void );
extern void		HostModeOps( void );

extern unsigned 	_stklen = 20000;
