
/*
		---------------------------------------
					PowerTerm v.01
		PowerTerm (c) 1992-93  Byron D Copeland
				All Rights Reserved.
		---------------------------------------

		KERMIT.C


*/

#include	<stdio.h>	    				/* Standard definitions */
#include	<signal.h> 
#include	<setjmp.h> 
#include	<fcntl.h>
#include 	<string.h>
#include 	<io.h>
#include 	<fcntl.h>
#include 	<dos.h>
#include	<sys\types.h>
#include	<sys\stat.h>
#include	"fsvlib.h"


/* #include	<termio.h>  */

/* Symbol Definitions */

#define ESCAPE		0x1b

#define	LOADMULT	2					/* a multiplier in case of slow comm handling on the UNIX system */
								/* If timeouts occur while doing file transfer this may be */
								/* increased to a two or a three, normally '1' is sufficient but */
								/* systems with a heavy load may require this to be increased */
#define MYTIME		5*LOADMULT				/* Seconds after which I should be timed out */
#define MAXTIM		60					/* Maximum timeout interval */
#define MINTIM		2					/* Minumum timeout interval */


#define FALSE		0 
#define TRUE		( !FALSE )				/* Boolean constants */

#define MAXPACKSIZ	94					/* Maximum packet size */
#define SOH		1					/* Start of header */
#define CR		13					/* ASCII Carriage Return */
#define SP		32					/* ASCII space */
#define DEL		127					/* Delete (rubout) */
#define ESCCHR		'^'					/* Default escape character for CONNECT */

#define MAXTRY		10					/* Times to retry a packet */
#define MYQUOTE		'#'					/* Quote character I will use */
#define MYQBIN		'$'					/* binary character I will use */
#define MYPAD		0					/* Number of padding characters I will need */
#define MYPCHAR		0					/* Padding character I need (NULL) */
#define MYEOL		'\n'					/* End-Of-Line character I need */


/* Macro Definitions */ 

/*
 * tochar: converts a control character to a printable one by adding a space. 
 *
 * unchar: undoes tochar. 
 *
 * ctl:    converts between control characters and printable characters by
 *	   toggling the control bit (ie. ^A becomes A and A becomes ^A). 
 */ 
#define tochar(ch)  ((ch) + ' ')
#define unchar(ch)  ((ch) - ' ')
#define ctl(ch)	    ((ch) ^ 64 )

/* Global Variables */

int	size,							/* Size of present data */
	rpsiz,							/* Maximum receive packet size */
	spsiz,							/* Maximum send packet size */
	pad,							/* How much padding to send */
	timint,							/* timout for foriegn host sends */
	n,							/* Packet number */
	numtry,							/* Times this packet retried */
	oldtry,							/* Times previous packet retried */
	image;							/* -1 means 8-bit mode */

char	state,							/* Present state of the automaton */
	padchar,						/* Padding character to send */
	eol,							/* End-Of-Line character to send */
	escchr,							/* Connect command escape character */
	quote,							/* Quote character in incoming data */
	qbin,							/* binary character in incoming data */
	*filnam,						/* Current file name */
	recpkt[MAXPACKSIZ+7],					/* Receive packet buffer */
	packet[MAXPACKSIZ+7];					/* Packet buffer */

char 	*filenam2;


int		kget;
int		bytein;
unsigned long 	kbin = 0L;
unsigned long 	kpkn = 0L;
unsigned long 	fbin = 0L;

char			*rxType={"(Batch)"};

extern char 	*filestoxfer[20];
extern char 	*buff;
extern char 	*fileswork1;
extern char 	*fileswork2;
extern char 	*InitBuf;

extern unsigned int filestodo;
extern unsigned int fileslefttodo;
extern int WINLOOK;
extern int TIME_OUT;
extern int KEY_HIT;

int	kfp;							/* File handle for current disk file */

jmp_buf kmenv;							/* Environment ptr for timeout longjump */

void kermit(char typ);
void kmsigjmp(int sig);						/* My Timer interrupt handler */
int sendsw(void);                               		/* send the files */
int recsw(void);						/* receive the file */
int finishsw(char how);
char fininit(char how);
void spar(char *packet);					/* Fill up init info packet */
void rpar(char *recpkt);					/* Get other side's init info */
void spack(char type,int num,int len,char *data);
int rpack(int *len,int *num,char *recpkt);			/* What was the reply? */
void serror(char *str,char *f);
/* int bufillold(char buffer[]); */
int bufill(char *packet);					/* Get first data from file */
/* void bufempold(char buffer[],int len); */
void bufemp(char buffer[],int len);
void flushinput(void);
void KermitCmds(void);
void KermServXmit(void);
void KermServRecv(void);

extern char *lstrip(char *p);
extern void tstrip(char *p);

/*---------------------------------------------------------------------
---------------------------------------------------------------------*/

void KermitCmds(void)
{
	int	ch;

	WINLOOK = TRUE;
	MakeWindow(6,13,13,54,LightCyan+CyanBG,LightCyan+CyanBG,Shadow,Frame1);
	Boxit(7,15,3,50,LightCyan+CyanBG,Frame1);
	fswriteC("Kermit Remote Server Command Menu",8,80,LightCyan+CyanBG);
	Boxit(11,19,3,10,LightCyan+CyanBG,Frame1);
	Boxit(11,35,3,10,LightCyan+CyanBG,Frame1);
	Boxit(14,19,3,10,LightCyan+CyanBG,Frame1);
	Boxit(14,35,3,10,LightCyan+CyanBG,Frame1);
	fswrite("S",12,22,Yellow+CyanBG);
	fswriteM("end",LightCyan+CyanBG);
	fswrite("G",12,38,Yellow+CyanBG);
	fswriteM("et",LightCyan+CyanBG);
	fswrite("F",15,21,Yellow+CyanBG);
	fswriteM("inish",LightCyan+CyanBG);
	fswrite("B",15,38,Yellow+CyanBG);
	fswriteM("ye",LightCyan+CyanBG);
/*	fswrite("E)xecute cmd",14,22,Yellow+BlueBG);  */
	ch = toupper( getch() );
	switch (ch)  {
		case 'S': KermServXmit();
			  return;
		case 'G': KermServRecv();
			  return;
		case 'F': kermit('f'); break;
		case 'B': kermit('b'); break;
		default: break;
	}
	CloseWindow();
	WINLOOK = FALSE;
	return;
}

/*---------------------------------------------------------------------
---------------------------------------------------------------------*/

void KermServXmit(void)
{
	char 	*p;
	int	ch;

	MakeWindow(10,7,11,65,White+CyanBG,White+CyanBG,Shadow,Frame1);
	Boxit(11,8,3,63,White+CyanBG,Frame1);
	fswriteC(" File(s) to Send. Wildcards O.K. ",12,80,LightCyan+CyanBG);
	fswriteC("Enter each filename to send separated by a space.",
		14,80,Yellow+CyanBG);
	Boxit(16,8,4,63,White+CyanBG,Frame1);
	setstrng(InitBuf,'',60);
	setstrng(fileswork1,'\0',60);
	filestodo=0;
	fileslefttodo=0;
	EditStringValue( fileswork1, 60,
			17, 9, InitBuf, Blue+CyanBG,
			LightCyan+BlueBG, LightCyan+CyanBG );
	p=NULL;
	p=strtok(fileswork1,"@ ");
	while ((p) && (filestodo < 20))  {
		p=lstrip(p);
		tstrip(p);
		strcpy(filestoxfer[filestodo++],p);
		p=strtok(0,"@ ");
	}
	setstrng(InitBuf,'',60);
	setstrng(fileswork2,'\0',60);
	EditStringValue( fileswork2, 60,
			18, 9, InitBuf, Blue+CyanBG,
			LightCyan+BlueBG, LightCyan+CyanBG );
	p=NULL;
	p=strtok(fileswork2,"@ ");
	while ((p) && (filestodo < 20))  {
		p=lstrip(p);
		tstrip(p);
		strcpy(filestoxfer[filestodo],p);
		filestodo++;
		p=strtok(0,"@ ");
	}
	if (filestodo < 1)  {
		CloseWindow();
		CloseWindow();
		return;
	}
	fswriteC("Press any key to proceed, ESC to Abort.",19,80,White+CyanBG);
	ch = toupper( getch() );
	if ( ch == ESCAPE )  {
		CloseWindow();
		CloseWindow();
		return;
	}
	CloseWindow();
	CloseWindow();
	kermit('s');
	return;
}

/*---------------------------------------------------------------------
---------------------------------------------------------------------*/

void KermServRecv(void)
{
	char 	*p;
	int	ch;

	MakeWindow(10,7,11,65,White+CyanBG,White+CyanBG,Shadow,Frame1);
	Boxit(11,8,3,63,White+CyanBG,Frame1);
	fswriteC(" File(s) to Receive ",12,80,LightCyan+CyanBG);
	fswriteC("Enter each filename to receive separated by a space.",
		14,80,Yellow+CyanBG);
	Boxit(16,8,4,63,White+CyanBG,Frame1);
	setstrng(InitBuf,'',60);
	setstrng(fileswork1,'\0',60);
	filestodo=0;
	fileslefttodo=0;
	EditStringValue( fileswork1, 60,
			17, 9, InitBuf, Blue+CyanBG,
			LightCyan+BlueBG, LightCyan+CyanBG );
	p = NULL;
	p = strtok(fileswork1,"@ ");
	while ((p) && (filestodo < 20))  {
		p=lstrip(p);
		tstrip(p);
		strcpy(filestoxfer[filestodo],p);
		filestodo++;
		p=strtok(0,"@ ");
	}
	setstrng(InitBuf,'',60);
	setstrng(fileswork2,'\0',60);
	EditStringValue( fileswork2, 60,
			18, 9, InitBuf, Blue+CyanBG,
			LightCyan+BlueBG, LightCyan+CyanBG );
	p=NULL;
	p=strtok(fileswork2,"@ ");
	while ((p) && (filestodo < 20))  {
		p=lstrip(p);
		tstrip(p);
		strcpy(filestoxfer[filestodo],p);
		filestodo++;
		p=strtok(0,"@ ");
	}
	fswriteC("Press any key to proceed, ESC to Abort.",19,80,White+CyanBG);
	ch = toupper( getch() );
	if ( ch == ESCAPE )  {
		CloseWindow();
		CloseWindow();
		return;
	}
	CloseWindow();
	CloseWindow();
	kermit('r');
	return;
}

/*---------------------------------------------------------------------
---------------------------------------------------------------------*/

void kermit( char typ )
{
	image = TRUE;
	kget = FALSE;
	kpkn = 0L;
	kbin = 0L;
	fbin = 0L;
	fileslefttodo = 0;
	kfp = NULL;						/* indicate no file open yet */

	DisplayXferWndw();
	if ( typ == 'r' ) {
			fswrite( "Kermit RECEIVE ", 9, 32, White+BlueBG );
		if ( filestodo > 1 )
			fswrite( rxType, 9, 32, White+BlueBG );
		if ( filestodo > 0 )
			kget = TRUE;
		if ( kget )  {
			while ( fileslefttodo != filestodo )  {
				recsw();
				delay( 400 );			/* let things settle. */
				fileslefttodo++;
			}
		}
		else  {
			recsw();		       		/* receive the file */
		}
//		CloseWindow();

	} else if ( typ == 's' ) {
			fswrite( "Kermit SEND ", 9, 32, White+BlueBG );
		if (filestodo > 1)
			fswriteM( rxType, White+BlueBG );
		sendsw();					/* send the file */
//		CloseWindow();

	} else if ( typ == 'f' )  {
		finishsw( typ );					/* We will send an G packet with F */
		return;

	} else if ( typ == 'b' )  {
		finishsw( typ );					/* We will send an G packet with L */
		return;
	}
	alarm( 0 );
	CloseWindow();
	flushinput();
}


/*
 *  s e n d s w 
 *
 *  Sendsw is the state table switcher for sending files.  It loops until 
 *  either it finishes, or an error is encountered.  The routines called
 *  by sendsw are responsible for changing the state. 
 *
 */ 

int sendsw()
{ 
	char sinit(), sfile(), sdata(), seof(), sbreak(); 

	state = 'S';						/* Send initiate is the start state */
	n = 0;							/* Initialize message number */
	numtry = 0;						/* Say no tries yet */
	image=TRUE;

	if ( signal( SIGTERM, kmsigjmp ) == SIG_ERR )  {
		fprintf(stderr,"sendsw() - signal error\n");
		return FALSE;
	}

	while(TRUE)						/* Do this as long as necessary */
	{

		sprintf(buff,"%lu",kpkn);
		fswrite(buff,13,32,White+BlueBG);
		sprintf(buff,"%lu",fbin);
		fswrite(buff,11,32,White+BlueBG);
		sprintf(buff,"%d",numtry);
		fswrite(buff,14,32,White+BlueBG);
		kpkn+=1L;

		switch(state)
		{
		case 'S':	fswrite("Send-Init    ",16,32,White+BlueBG);
				state = sinit();  break; 	/* Send-Init */
		case 'F':	fswrite("Send-File    ",16,32,White+BlueBG);
				state = sfile();  break; 	/* Send-File */
		case 'D':	fswrite("Send-Data    ",16,32,White+BlueBG);
				state = sdata();  break; 	/* Send-Data */
		case 'Z':	fswrite("Send-EOF     ",16,32,White+BlueBG);
				state = seof();	  break; 	/* Send-End-of-File */
		case 'B':	fswrite("Send-Break   ",16,32,White+BlueBG);
				state = sbreak(); break; 	/* Send-Break */
		case 'C':	fswrite("Send-Complete",16,32,White+BlueBG);
				delay(3000);
				return (TRUE);		 	/* Complete */
		case 'A':	alarm(0);
				delay(3000);
				return (FALSE);		 	/* "Abort" */
		default:	alarm(0);
				return (FALSE);		 	/* Unknown, fail */
		}
	} 
} 


/*
 *  s i n i t 
 *
 *  Send Initiate: send this host's parameters and get other side's back. 
 */ 

char sinit()
{ 
	int num, len;						/* Packet number, length */

	if (numtry++ > MAXTRY) return('A'); 			/* If too many tries, give up */
	spar(packet);						/* Fill up init info packet */

	flushinput();  						/* Flush pending input */
	if (!eol)
		eol='\r';
	spack('S',n,10,packet);					/* Send an S packet */
	switch(rpack(&len,&num,recpkt))				/* What was the reply? */
	{

	case 'N':  return(state);				/* NAK, try it again */

	case 'Y':						/* ACK */
		if (n != num)					/* If wrong ACK, stay in S state */
			return(state);				/* and try again */
		rpar(recpkt);					/* Get other side's init info */

		sprintf(buff,"%d",spsiz);
		fswrite(buff,12,32,White+BlueBG);

		if (eol == 0) eol = '\n'; 			/* Check and set defaults */
		if (quote == 0) quote = '#';   
		if (qbin == 0) qbin = MYQBIN;  

		numtry = 0;					/* Reset try counter */
		n = (n+1)%64;					/* Bump packet count */
		return('F');					/* OK, switch state to F */

	case 'E':						/* Error packet received */
		fsfill(17,27,1,30,' ',White+BlueBG);
		fswrite(packet,17,32,White+BlueBG);
		return('A');					/* abort */

	case FALSE: return(state);				/* Receive failure, try again */

	default: return('A');					/* Anything else, just "abort" */
	}
}  


/*  
 *  s f i l e   
 *  
 *  Send File Header.   
 */ 

char sfile()
{   
	int	num, len;					/* Packet number, length */
	char	filnam1[61],					/* Converted file name */
		*newfilnam,					/* Pointer to file name to send */
		*cp;						/* char pointer */

	if (numtry++ > MAXTRY) return('A'); 			/* If too many tries, give up */

	if (kfp == NULL)					/* If not already open, */
	{
		if (fileslefttodo == filestodo)
			return('B');				/* All done, EOT.  */
		fbin=0L;
		if (!image)  {
			if ((kfp = open(filestoxfer[fileslefttodo],
				O_RDONLY)) == -1)		/* open the file to be sent */
			{
				serror("Cannot open file %s",
					filestoxfer[fileslefttodo]);
				return('A');
			}
		}
		else  {
			if ((kfp = open(filestoxfer[fileslefttodo],
				O_RDONLY|O_BINARY)) == -1)	/* open the file to be sent */
			{
				serror("Cannot open file %s",
					filestoxfer[fileslefttodo]);
				return('A');
			}
		}
		strcpy(filnam1, filestoxfer[fileslefttodo++]);
	}

	newfilnam = cp = filnam1;
	while (*cp != '\0')					/* Strip off all leading directory */
		if (*cp++ == '/')				/* names (ie. up to the last /). */
			newfilnam = cp;

	len = cp - newfilnam;					/* Compute length of new filename */

	fsfill(10,32,1,12,' ',White+BlueBG);
	fswrite(newfilnam,10,32,White+BlueBG);

	spack('F',n,len,newfilnam);				/* Send an F packet */
	switch(rpack(&len,&num,recpkt))				/* What was the reply? */
	{

	case 'N':						/* NAK, just stay in this state, */
	    num = (--num<0 ? 63:num);				/* unless it's NAK for next packet */
	    if (n != num)					/* which is just like an ACK for */
		return(state);					/* this packet so fall thru to... */

	case 'Y':						/* ACK */
	    if (n != num) return(state); 			/* If wrong ACK, stay in F state */
	    numtry = 0;						/* Reset try counter */
	    n = (n+1)%64;					/* Bump packet count */

	    /* Added by Byron Copeland */

	    if ((size = bufill(packet)) == -1)			/* Get first data from file */
		return('Z');					/* IF EOF switch state.     */
	    return('D');					/* Switch state to D */

	case 'E':						/* Error packet received */
	    fsfill(17,32,1,25,' ',White+BlueBG);
	    fswrite(packet,17,32,White+BlueBG);
	    return('A');					/* abort */

	case FALSE: return(state);				/* Receive failure, stay in F state */

	default:    return('A');				/* Something else, just "abort" */
	}   
}   

/*  
 *  s d a t a   
 *  
 *  Send File Data  
 */ 

char sdata()
{   
    int num, len;						/* Packet number, length */

    if (kbhit())
	return('Z');						/* Signal Break          */

    if (numtry++ > MAXTRY) return('A'); 			/* If too many tries, give up */

    spack('D',n,size,packet);					/* Send a D packet */
    switch(rpack(&len,&num,recpkt))				/* What was the reply? */
    {

	case 'N':						/* NAK, just stay in this state, */
	    num = (--num<0 ? 63:num);				/* unless it's NAK for next packet */
	    if (n != num)					/* which is just like an ACK for */
		return(state);					/* this packet so fall thru to... */
		  
	case 'Y':						/* ACK */
	    if (n != num) return(state); 			/* If wrong ACK, fail */
	    numtry = 0;						/* Reset try counter */
	    n = (n+1)%64;					/* Bump packet count */
	    if ((size = bufill(packet)) == -1)   		/* Get data from file */
		return('Z');					/* If EOF set state to try another */
	    return('D');					/* Got data, stay in state D */

	case 'E':						/* Error packet received */
	    fsfill(17,32,1,25,' ',White+BlueBG);
	    fswrite(packet,17,32,White+BlueBG);
	    return('A');					/* abort */

	case FALSE: return(state);				/* Receive failure, stay in D */

	default:    return('A');				/* Anything else, "abort" */
    }   
}   


/*  
 *  s e o f 
 *  
 *  Send End-Of-File.   
 */ 

char seof() 
{   
    int num, len;						/* Packet number, length */
    if (numtry++ > MAXTRY) return('A'); 			/* If too many tries, "abort" */

    if (kbhit())
	spack('Z',n,1,"D\0");					/* Send a 'Z' packet to discard */
    else
	spack('Z',n,0,packet);					/* Send a 'Z' packet */
    switch(rpack(&len,&num,recpkt))				/* What was the reply? */
    {

	case 'N':						/* NAK, just stay in this state, */
	    num = (--num<0 ? 63:num);				/* unless it's NAK for next packet, */
	    if (n != num)					/* which is just like an ACK for */
		return(state);					/* this packet so fall thru to... */

	case 'Y':						/* ACK */
	    if (n != num) return(state); 			/* If wrong ACK, hold out */
	    numtry = 0;						/* Reset try counter */
	    n = (n+1)%64;					/* and bump packet count */
	    close(kfp);						/* Close the input file */
	    kfp = NULL;						/* Set flag indicating no file open */

	    return('F');					/* See if more files left */

	case 'E':						/* Error packet received */
	    fsfill(17,32,1,25,' ',White+BlueBG);
	    fswrite(packet,17,32,White+BlueBG);
	    return('A');					/* abort */

	case FALSE: return(state);				/* Receive failure, stay in Z */

	default:    return('A');				/* Something else, "abort" */
    }   
}   


/*  
 *  s b r e a k 
 *  
 *  Send Break (EOT)
 */ 

char sbreak()   
{   
    int num, len;						/* Packet number, length */
    if (numtry++ > MAXTRY) return('A'); 			/* If too many tries "abort" */

    spack('B',n,0,packet);					/* Send a B packet */
    switch (rpack(&len,&num,recpkt))				/* What was the reply? */
    {

	case 'N':						/* NAK, just stay in this state, */
	    num = (--num<0 ? 63:num);				/* unless NAK for previous packet, */
	    if (n != num)					/* which is just like an ACK for */
		return(state);					/* this packet so fall thru to... */

	case 'Y':						/* ACK */
	    if (n != num) return(state); 			/* If wrong ACK, fail */
	    numtry = 0;						/* Reset try counter */
	    n = (n+1)%64;					/* and bump packet count */
	    return('C');					/* Switch state to Complete */

	case 'E':						/* Error packet received */
	    fsfill(17,32,1,25,' ',White+BlueBG);
	    fswrite(packet,17,32,White+BlueBG);
	    return('A');					/* abort */

	case FALSE: return(state);				/* Receive failure, stay in B */

	default:    return ('A');				/* Other, "abort" */
   }
}   


/*  
 *  r e c s w   
 *  
 *  This is the state table switcher for receiving files.   
 */ 

int recsw()
{   
	char getinit(), rinit(), rfile(), rdata();		/* Use these procedures */

	state = 'R';
	n = 0;							/* Initialize message number */
	numtry = 0;						/* Say no tries yet */
	image = TRUE;
	fbin = 0L;

	sprintf( buff, "%d", MAXPACKSIZ );
	fswrite( buff, 12, 32, White+BlueBG );

	if ( signal( SIGTERM, kmsigjmp ) == SIG_ERR )  {
		fprintf(stderr,"recvsw() - signal error\n");
		return( FALSE );
	}

	if ( kget )  {
		spack( 'R', n, strlen( filestoxfer[fileslefttodo] ),
			filestoxfer[fileslefttodo]);		/* Send an R packet */
	}
	state = 'R';

	while( TRUE )  {

		sprintf( buff, "%lu", kpkn );
		fswrite( buff, 13, 32, White+BlueBG );
		sprintf( buff, "%d", numtry );
		fswrite( buff, 14, 32, White+BlueBG );
		sprintf( buff, "%lu", fbin );
		fswrite( buff, 11, 32, White+BlueBG );
		kpkn += 1L;

		switch( state )					/* Do until done */
		{
			case 'R':

				state = rinit();

				break; 				/* Receive-Init */

			case 'F':

				fswrite( "Recv-File    ", 16, 32, White+BlueBG );

				state = rfile();

				break; 				/* Receive-File */

			case 'D':

				fswrite( "Recv-Data    ", 16, 32, White+BlueBG );

				state = rdata();

				break; 				/* Receive-Data */

			case 'C':

				fswrite( "Recv-Complete", 16, 32, White+BlueBG );

				delay( 3000 );

				return( TRUE );			/* Complete state */

			case 'A':

				alarm( 0 );
				delay( 3000 );
				return( FALSE );		/* "Abort" state */
		}
	}
}


    
/*  
 *  r i n i t   
 *  
 *  Receive Initialization  
 */ 
    
char rinit()
{   
    int 	len;
    int		num;						/* Packet length, number */

    if ( numtry++ > MAXTRY )
	return( 'A' ); 						/* If too many tries, "abort" */

    switch( rpack( &len, &num, packet ) )			/* Get a packet */
    {

	case 'S':						/* Send-Init */

	    fswrite( "Recv-Init    ", 16, 32, White+BlueBG );
	    rpar( packet );					/* Get the other side's init data */
	    spar( packet );					/* Fill up packet with my init info */
	    spack(' Y', n, 10, packet );			/* ACK with my parameters */
	    oldtry = numtry;					/* Save old try count */
	    numtry = 0;						/* Start a new counter */
	    n = ( n + 1 ) % 64;					/* Bump packet number, mod 64 */
	    return( 'F' );					/* Enter File-Receive state */

	case 'E':						/* Error packet received */

	    fsfill( 17, 32, 1, 25, ' ', White+BlueBG );
	    fswrite( packet, 17, 32, White+BlueBG );
	    return( 'A' );					/* abort */

	case FALSE:						/* Didn't get packet */

	    spack( 'N', n, 0, 0 );				/* Return a NAK */
	    return( state );					/* Keep trying */

	default:
		return( 'A' );					/* Some other packet type, "abort" */
    }
}


/*  
 *  r f i l e   
 *  
 *  Receive File Header 
 */ 

char rfile()
{   
    int 	num;
    int		len;						/* Packet number, length */
    char 	filnam1[50];					/* Holds the converted file name */

    if ( numtry++ > MAXTRY )
	return( 'A' ); 						/* "abort" if too many tries */

    switch( rpack( &len, &num, packet ) )			/* Get a packet */
    {

	case 'S':						/* Send-Init, maybe our ACK lost */

	    if ( oldtry++ > MAXTRY )
		return( 'A' ); 					/* If too many tries "abort" */
	    if ( num == ( ( n == 0 ) ? 63: n - 1 ) ) 		/* Previous packet, mod 64? */
	    {							/* Yes, ACK it again with  */
		spar( packet );					/* our Send-Init parameters */
		spack( 'Y', num, 10, packet );
		numtry = 0;					/* Reset try counter */
		return( state );				/* Stay in this state */
	    }
	    else
		return( 'A' );					/* Not previous packet, "abort" */

	case 'Z':						/* End-Of-File */

	    if ( oldtry++ > MAXTRY )
		return( 'A' );
	    if ( num == ( ( n == 0 ) ? 63: n - 1 ) ) 		/* Previous packet, mod 64? */
	    {							/* Yes, ACK it again. */
		spack( 'Y', num, 0, 0 );
		numtry = 0;
		return( state );				/* Stay in this state */
	    }
	    else
		return( 'A' );					/* Not previous packet, "abort" */

	case 'F':						/* File Header (just what we want) */

	    if ( num != n )
		return( 'A' );					/* The packet number must be right */

	    strcpy( filnam1, packet );				/* the file name to receive is in packet */

	    fsfill( 10, 32, 1, 25, ' ', White+BlueBG );
	    fswrite( filnam1, 10, 32, White+BlueBG );

	    if ( !image )  {
		if ( ( kfp = open( filnam1,
			O_TEXT|O_CREAT|O_WRONLY,S_IWRITE ) ) == -1 ) /* Try to open a new file */
		{
			serror( "Cannot create %s", filnam1 ); 	/* Give up if can't */
			return( 'A' );
		}
	    }
	    else  {
		if ( ( kfp = open( filnam1,
			O_BINARY|O_CREAT|O_WRONLY,S_IWRITE ) ) == -1 ) /* Try to open a new file */
		{
			serror( "Cannot create %s",filnam1 ); 	/* Give up if can't */
			return( 'A' );
		}
	    }

	    spack( 'Y', n, 0, 0 );				/* Acknowledge the file header */
	    oldtry = numtry;					/* Reset try counters */
	    numtry = 0;						/* ... */
	    n = ( n + 1 ) % 64;					/* Bump packet number, mod 64 */
	    return( 'D' );					/* Switch to Data state */

	case 'B':						/* Break transmission (EOT) */

	    fswrite( "Recv-Break   ", 16, 32, White+BlueBG );
	    if ( num != n )
		return( 'A' ); 					/* Need right packet number here */
	    spack( 'Y', n, 0, 0 );				/* Say OK */
	    return( 'C' );					/* Go to complete state */

	case 'E':						/* Error packet received */

	    fsfill( 17, 32, 1, 25, ' ', White+BlueBG );
	    fswrite( packet, 17, 32, White+BlueBG );
	    return( 'A' );					/* abort */

	case FALSE:						/* Didn't get packet */

	    spack( 'N', n, 0, 0 );				/* Return a NAK */
	    return( state );					/* Keep trying */

	default:
		return ( 'A' );					/* Some other packet, "abort" */
    }
}


/*  
 *  r d a t a   
 *  
 *  Receive Data
 */ 

char rdata()
{   
    int 	num;
    int		len;						/* Packet number, length */

    if ( numtry++ > MAXTRY )
	return('A'); 						/* "abort" if too many tries */

    switch( rpack( &len, &num, packet ) )			/* Get packet */
    {

	case 'D':						/* Got Data packet */

	    if ( num != n )					/* Right packet? */
	    {							/* No */
		if ( oldtry++ > MAXTRY )
		    return( 'A' );				/* If too many tries, abort */
		if ( num == ( ( n == 0 ) ? 63: n - 1 ) ) 	/* Else check packet number */
		{						/* Previous packet again? */
		    spack( 'Y', num, 6, packet ); 		/* Yes, re-ACK it */
		    numtry = 0;					/* Reset try counter */
		    return( state );				/* Don't write out data! */
		}
		else
			return( 'A' );				/* sorry, wrong number */
	    }

	    /* Got data with right packet number */

	    bufemp( packet, len );				/* Write the data to the file */

	    if ( kbhit() )
		spack( 'Y', n, 1, "X\0" );			/* Acknowledge with abort */
	    else
		spack( 'Y', n, 0, 0 );				/* Acknowledge the packet */

	    oldtry = numtry;					/* Reset the try counters */
	    numtry = 0;						/* ... */
	    n = ( n + 1 ) % 64;					/* Bump packet number, mod 64 */
	    return( 'D' );					/* Remain in data state */

	case 'F':						/* Got a File Header */

	    if ( oldtry++ > MAXTRY )
		return( 'A' );					/* If too many tries, "abort" */
	    if ( num == ( ( n == 0 ) ? 63: n - 1 ) ) 		/* Else check packet number */
	    {							/* It was the previous one */
		spack( 'Y', num, 0, 0 );			/* ACK it again */
		numtry = 0;					/* Reset try counter */
		return( state );				/* Stay in Data state */
	    }
	    else
		return( 'A' );					/* Not previous packet, "abort" */

	case 'Z':						/* End-Of-File */

	    fswrite( "Recv-EOF     ", 16, 32, White+BlueBG );
	    if ( num != n )
		return('A');					/* Must have right packet number */
	    spack( 'Y', n, 0 ,0 );				/* OK, ACK it. */
	    close( kfp );					/* Close the file */
	    kfp = NULL;
	    n = ( n + 1 ) % 64;					/* Bump packet number */
	    return( 'F' );					/* Go back to Receive File state */

	case 'E':						/* Error packet received */

	    fsfill( 17, 32, 1, 25, ' ', White+BlueBG );
	    fswrite( packet, 17, 32, White+BlueBG );
	    return( 'A' );					/* abort */

	case FALSE:						/* Didn't get packet */

	    spack( 'N', n, 0, 0 );				/* Return a NAK */
	    return( state );					/* Keep trying */

	default:

		return( 'A' );					/* Some other packet, "abort" */
    }
}



/*  
 *  s p a c k   
 *  
 *  Send a Packet   
 */ 

void spack( char type, int num, int len, char *data )
{
    int 		i;					/* Character loop counter */
    unsigned char 	chksum;					/* Checksum */
    char 		buffer[100];				/* Packet buffer */
    register char 	*bufp;					/* Buffer pointer */
    char 		*p;

    bufp = buffer;						/* Set up buffer pointer */
    p = buffer;

    for ( i = 1; i <= pad; i++ )
	SerialOut( padchar );

    *bufp++ = SOH;						/* Packet marker, ASCII 1 (SOH) */
    *bufp++ = tochar( len + 3 );				/* Send the character count */
    chksum  = tochar( len + 3 );				/* Initialize the checksum */
    *bufp++ = tochar( num );					/* Packet number */
    chksum += tochar( num );					/* Update checksum */
    *bufp++ = type;						/* Packet type */
    chksum += type;						/* Update checksum */

    for (  i = 0; i < len; i++ )				/* Loop for all data characters */
    {
	*bufp++ = data[i];					/* Get a character */
	chksum += data[i];					/* Update checksum */
    }
    chksum = ( ( ( chksum & 0300 ) >> 6 ) + chksum ) & 077; 	/* Compute final checksum */
    *bufp++ = tochar( chksum );					/* Put it in the packet */
    *bufp = eol;						/* Extra-packet line terminator */

    for ( i = 0; i < ( bufp - buffer + 1); i++ )
	SerialOut( *p++ );

}

/*  
 *  r p a c k   
 *  
 *  Read a Packet   
 */ 

int rpack(int *len,int *num,char *data)
{
    int i, done;						/* Data character number, loop exit */
    char t,							/* Current input character */
	type,							/* Packet type */
	rchksum;						/* Checksum received from other host */
    unsigned cchksum;						/* Our (computed) checksum */

	KEY_HIT = FALSE;

    if ( setjmp( kmenv ) )
		return FALSE;

    if ( ( timint > MAXTIM ) || ( timint < MINTIM ) )
		timint = MYTIME;

    alarm( timint );

    while ( t != SOH )						/* Wait for packet header */
    {
	t = char_waiting();					/* Get Character */
	if ( KEY_HIT )
		return( FALSE );
	if ( !image )
		t &= 0177;					/* Handle parity */
    }

    done = FALSE;						/* Got SOH, init loop */
    while ( !done )						/* Loop to get a packet */
    {
	t = char_waiting();					/* Get Character */
	if ( KEY_HIT )
		return( FALSE );
	if ( !image )
		t &= 0177;					/* Handle parity */
	if ( t == SOH )
		continue;					/* Resynchronize if SOH */
	cchksum = t;						/* Start the checksum */
	*len = unchar( t ) - 3;					/* Character count */
	t = char_waiting();					/* Get Character */
	if ( KEY_HIT )
		return( FALSE );
	if ( !image )
		t &= 0177;					/* Handle parity */
	if ( t == SOH )
		continue;					/* Resynchronize if SOH */
	cchksum = cchksum + t;					/* Update checksum */
	*num = unchar( t );					/* Packet number */
	t = char_waiting();					/* Get Character */
	if ( KEY_HIT )
		return( FALSE );
	if ( !image )
		t &= 0177;					/* Handle parity */
	if ( t == SOH )
		continue;					/* Resynchronize if SOH */
	cchksum = cchksum + t;					/* Update checksum */
	type = t;						/* Packet type */

	for ( i = 0; i < *len; i++ )				/* The data itself, if any */
	{							/* Loop for character count */
	    t = char_waiting();					/* Get Character */
		if ( KEY_HIT )
			return( FALSE );
	    if ( !image )
		t &= 0177;					/* Handle parity */
	    if ( t == SOH )
		break;						/* Resynch if SOH */
	    cchksum = cchksum + t;				/* Update checksum */
	    data[i] = t;					/* Put it in the data buffer */
	}
	if ( t == SOH )
		continue;					/* Resynchronize if SOH */
	data[*len] = 0;						/* Mark the end of the data */
	t = char_waiting();					/* Get last character (checksum) */
	if ( KEY_HIT )
		return( FALSE );
	rchksum = unchar( t );					/* Convert to numeric */
	t = char_waiting();					/* get EOL character and toss it */
	if ( KEY_HIT )
		return( FALSE );
	if ( !image )
		t &= 0177;					/* Handle parity */
	if ( t == SOH )
		continue;					/* Resynchronize if SOH */
	done = TRUE;						/* Got checksum, done */
    }   
    alarm( 0 );	 						/* Disable the timer interrupt */

    cchksum = ( ( ( cchksum & 0300 ) >> 6 ) + cchksum ) & 077; /* final checksum */

    if ( cchksum != rchksum )
	return( FALSE );

    return( type );						/* All OK, return packet type */
}


/*  Finish and Fininit added by Byron Copeland */

/*
 *  f i n i s h s w
 *
 */

int finishsw( char how )
{
	int	len;
	char 	fininit( char how ), sbreak();

	if ( !eol )
		eol='\r';
	state = 'G';						/* Send initiate is the start state */
	n = 0;							/* Initialize message number */
	numtry = 0;						/* Say no tries yet */
	while( TRUE )						/* Do this as long as necessary */
	{
		switch( state )		{

			case 'G':

				state = fininit(how);
				break; 				/* finish-Init */

			case 'C':

				rpack( &len, &n, packet );	/* Get last ACK */
				return( TRUE );		 	/* Complete */

			default:

				alarm( 0 );
				return( FALSE );		 /* Unknown, fail */
		}
	}
}


/*
 *  f i n i n i t
 *
 *  Send Finish or logout to remote server.
 */

char fininit( char how )
{
	int num, len;						/* Packet number, length */

	if ( numtry++ > MAXTRY )
		return( 'A' ); 					/* If too many tries, give up */

	flushinput();  						/* Flush pending input */

	if ( how == 'f' )
		spack( 'G', n, 1, "F\0" );			/* Send a FINISH packet */
	else
		spack( 'G', n, 1, "L\0" );			/* Send a LOGOUT packet */

	return( 'C' );						/* OK, switch state to C */
}


int bufill(char buffer[])
{
    int i;							/* Loop index */
								/* Char read from file */
    char t,t7;							/* 7-bit version of above */

    i = 0;							/* Init data buffer pointer */
    while(!eof(kfp))
    {
	bytein=read(kfp,&t,1);
	if(bytein == -1)
		return(-1);
	fbin+=1L;
	t7 = t & 0177;						/* Get low order 7 bits */
	if (t7 < SP || t7 == DEL || t7 == quote)
	{
		if(t == '\n' && !image) {			/* transmit binary */
			buffer[i++] = quote;			/* Quote the character */
			buffer[i++] = ctl('\r');
		}
		buffer[i++] = quote;
		if (t7 != quote)  {
			t=ctl(t);
			t7=ctl(t7);
		}
	}
	if (image)
	    buffer[i++] = t;					/* Deposit the character itself */
	else
	    buffer[i++] = t7;

	if (i >= spsiz-8) return(i);				/* Check length */
    }
    if (i==0) return(-1);					/* Wind up here only on EOF */
    return(i);							/* Handle partial buffer */
}


/*----------------------------------------------------------------------
 *	b u f e m p
 *
 *  Put data from an incoming packet into a file.
 *--------------------------------------------------------------------*/


void bufemp(char buffer[],int len)
{
    int i;				/* Counter */ 
    char t;				/* Character holder */

    for (i=0; i<len; i++)		/* Loop thru the data field */   
    {   
	t = buffer[i];			/* Get character */   
	if (t == MYQUOTE)		/* Control quote? */
	{				/* Yes */ 
	    t = buffer[++i];		/* Get the quoted character */   
	    if ((t & 0177) != MYQUOTE)	/* Low order bits match quote char? */  
		t = ctl(t);		/* No, uncontrollify it */
	}
	if (t==CR && !image)
		continue;

	bytein=write(kfp,&t,1);
    }
    fbin+=(unsigned long)len;
}


/*-----------------------------------------------------------------------
 *  s p a r
 *
 *  Fill the data array with my send-init parameters
 *  
 *---------------------------------------------------------------------*/

void spar(char data[])
{
    data[0] = tochar(MAXPACKSIZ);	/* Biggest packet I can receive */
    data[1] = tochar(MYTIME);		/* When I want to be timed out */
    data[2] = tochar(MYPAD);		/* How much padding I need */ 
    data[3] = ctl(MYPCHAR);		/* Padding character I want */ 
    data[4] = tochar(MYEOL);		/* End-Of-Line character I want */
    data[5] = MYQUOTE;			/* Control-Quote character I send */   
/*    data[6] = MYQBIN;	  */		/* Control-binary character I send */
    data[6] = (char)'N';   		/* Say no to 8 bit quoting */
    data[7] = (char)'1';		/* Single char checksum */
    data[8] = (char)' ';		/* Repeat char none */
    data[9] = (char)' ';		/* nothing special */
}   

/*-----------------------------------------------------------------------
 *  r p a r
 *
 *  Get the other host's send-init parameters
 *
 *---------------------------------------------------------------------*/

void rpar(char data[])
{
    spsiz = unchar(data[0]);			/* Maximum send packet size */
    timint = (unchar(data[1]) * LOADMULT);	/* When I should time out */ 
    pad = unchar(data[2]);			/* Number of pads to send */
    padchar = ctl(data[3]);			/* Padding character to send */
    eol = unchar(data[4]);			/* EOL character I must send */
    quote = data[5];				/* Incoming data quote character */
    qbin = data[6];				/* Incoming data binary character */
}   
    

/*-----------------------------------------------------------------------
 *  e r r o r
 *
 *  Print error message.
 *  
 *  send an error packet with the message.   
 *---------------------------------------------------------------------*/

/*VARARGS1*/
void serror(char *fmt, char *a1)
{
    char msg[80];   

    sprintf(msg,fmt,a1); /* Make it a string */
    spack('E',n,strlen(msg),msg);	/* Send the error packet */ 

    return; 
}   


void kmsigjmp( int sig )			/* Timer interrupt handler */
{
	if ( sig == SIGTERM )	{

		alarm( 0 );
		if ( signal( SIGTERM, kmsigjmp ) == SIG_ERR )
			fprintf(stderr,"kmsigjmp() - signal error\n");

		longjmp( kmenv, TRUE );	/* Tell rpack to give up */
	}
}
