
/*
		---------------------------------------
			    PowerTerm v.01
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/


#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <io.h>
#include <share.h>
#include <fcntl.h>
#include <dir.h>
#include <alloc.h>
#include <sys\types.h>
#include <sys\stat.h>

#include "pckeys.h"
#include "fsvlib.h"
#include "mouse.h"

#define  FALSE	0
#define  TRUE   (!FALSE)

char		**fkset;
extern char	*buff;
extern char	*InitBuf;
extern char	*TempBuf;
extern char 	*PTEnviron;

char 		*MacKeys[12]={" F1  "," F2  "," F3  "," F4  "," F5  "," F6  ",
				" F7  "," F8  "," F9  "," F10 "," F11 "," F12 "};

char		*FList[15];
char 		*MacFile;
char 		*MacName;
char 		*MacDesc;
char 		*mnamehold;
char 		*mdeschold;
char 		LastMacRead[9]="\0";

int		MFL;
int		MacChk;

unsigned	FLIdx;
unsigned	FLRecs;

long		FLPtr;

extern int 	MouseInstalled;
extern int	MouseRow;
extern int	MouseCol;

typedef struct MACROS  {
	char			*mname;		// 8 Bytes
	char			*mdesc;		// 60 Bytes
	char			*afkey[12];
	char			*cfkey[12];
} MACROS;

MACROS MacroKeys;



FILE	*MKF;

void EditMacroKeys( void );
void InitMacroKeys( void );
void ClearMacroDefs( void );
void SaveMacroKeys( char *MacF );
int ReadMacroFile( char *MacF );
void SaveNewMacroKeys( void );
void DisplayMacHdrSave( void );
void DisplayMacroKeys( unsigned int MKPage );
int ListMacroFiles( void );
void DisplayMacroNameList( void );


/*
 *	Function to allow display/edit of function key macros.
 *
*/

void EditMacroKeys( void )
{
	int 		MKEQuit = FALSE;
	int		event;
	int		ch;
	int		key;
	unsigned int 	MKIdx=0;
	unsigned int 	MKMaxI=11;
	unsigned int 	MKMin=6;
	unsigned int 	MKMax=17;
	unsigned int 	MKRow=6;
	unsigned int 	MKPage=0;
	unsigned int 	MKCol=9;
	unsigned int 	Col=3;
	int 		i;
	int		PIdx = 1;


	char		*funct1[6] = {"F1-Help",  "F2-List",
				      "F3-Clear", "F10-Save",
				      "PD-More", "Esc-Exit"};

	int		pos[6]={3, 14, 25, 37, 49, 61 };

	MacChk = FALSE;
	MakeWindow(1,1,24,80,LightCyan+BlueBG,LightCyan+BlueBG,
		NoShadow,Frame1);
	fswrite( "[", 1, 3, LightCyan+BlueBG );
	fswriteM( "", LightGreen+BlueBG );
	fswriteM( "]", LightCyan+BlueBG );

	fswrite( "", 18, 1, LightCyan+BlueBG );
	fswrite( "", 18, 80, LightCyan+BlueBG );
	fsfill( 18, 2, 1, 78, '', LightCyan+BlueBG );

	for ( i = 0; i < 6; i++ )	{
		MakeButton( funct1[i], 21, pos[i], Black+GreenBG, Black+BlueBG );
	}
	DisplayMacHdrSave();

	fswrite("KEY",5,3,Yellow+BlueBG);
	fswrite("Key Definition",5,15,LastAttr);
/*	sprintf(buff," More: %c%c ",24,25);
	fswrite(buff,23,64,Yellow+BlueBG);	*/
	DisplayMacroKeys( MKPage );
	fswrite(MacKeys[0],6,3,Yellow+CyanBG);
	if (MouseInstalled)
		Mshow();

	//	Loop until MKEQuit is true

	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch(ch)	{

					case ESCAPE:

						MKEQuit=TRUE;
						break;

					case CR:

						if (MouseInstalled)
							Mhide();
						setstrng(InitBuf,'',60);
						EditStringValue( fkset[MKIdx], 60,
							MKRow, MKCol, InitBuf,
							Cyan+BlueBG, White+CyanBG, White+BlueBG );

						MoveMenuBarDown(MacKeys,&MKIdx, &MKRow, &MKMin,
							&Col, &MKMaxI, LightCyan+BlueBG,
							Yellow+CyanBG );

						if (MouseInstalled)
							Mshow();
						break;


					case SPECIALKEY:

						if ( MouseInstalled )
							Mhide();

						key = getch();
						switch( key )  {

							case F1:

								GiveUserHelp( "MCK.HLP" );
								break;

							case F2:

								if ( ListMacroFiles() == 0 )	{
									MKPage = 0;
									MKIdx = 0;
									MKRow = MKMin;
									DisplayMacHdrSave();
									DisplayMacroKeys( MKPage );
								}
								break;

							case F10:

								SaveNewMacroKeys();
								DisplayMacHdrSave();
								break;

							case F3:

								ClearMacroDefs();
								MKPage=0;
								MKIdx=0;
								DisplayMacroKeys(MKPage);
								break;

							case HOME:

								break;

							case END:

								break;

							case DN:

								MoveMenuBarDown(MacKeys,&MKIdx, &MKRow, &MKMin,
									&Col, &MKMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								break;

							case UP:

								MoveMenuBarUp(MacKeys,
									&MKIdx, &MKRow, &MKMax,
									&Col, &MKMaxI, LightCyan+BlueBG,
									Yellow+CyanBG );
								break;

							case PGDN:

								if ( MKPage == 0 )
									MKPage = 1;
								else
									MKPage = 0;
								MKRow = MKMin;
								MKIdx ^= MKIdx;
								DisplayMacroKeys( MKPage );
								break;

							case PGUP:

								if ( MKPage == 1 )
									MKPage ^= MKPage;
								else
									MKPage = 1;
								MKRow = MKMin;
								MKIdx ^= MKIdx;
								DisplayMacroKeys(MKPage);
								break;

							default:

								Beep( 600 );
								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					default:

						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( ( MouseRow == 1 ) && ( MouseCol == 4 ) )	{
					MKEQuit = TRUE;
					break;
				}
				if ( MouseInstalled )
					Mhide();

				if (((MouseRow >= MKMin) && (MouseRow <= MKMax)) &&
					((MouseCol >= Col) && (MouseCol <= (Col+4))))	{
					MoveMenuBar(MacKeys, &MKIdx, &MKRow,
						MouseRow, &MKMin, &Col, &MKMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[0] ) &&
					( MouseCol <= ( pos[0] + 8 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 0;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[1] ) &&
					( MouseCol <= ( pos[1] + 8 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 1;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[2] ) &&
					( MouseCol <= ( pos[2] + 9 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 2;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[3] ) &&
					( MouseCol <= ( pos[3] + 9 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 3;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[4] ) &&
					( MouseCol <= ( pos[4] + 8 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 4;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[5] ) &&
					( MouseCol <= ( pos[5] + 9 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 5;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
				}

				if ( MouseInstalled )
					Mshow();
				break;

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();
				if (((MouseRow >= MKMin) && (MouseRow <= MKMax)) &&
					((MouseCol >= Col) && (MouseCol <= (Col+4))))	{
					MoveMenuBar(MacKeys, &MKIdx, &MKRow,
						MouseRow, &MKMin, &Col, &MKMaxI,
						LightCyan+BlueBG, Yellow+CyanBG );
					setstrng(InitBuf,'',60);
					EditStringValue( fkset[MKIdx], 60,
						MKRow, MKCol, InitBuf,
						Cyan+BlueBG, White+CyanBG, White+BlueBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[0] ) &&
					( MouseCol <= ( pos[0] + 8 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 0;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
					GiveUserHelp( "MCK.HLP" );
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[1] ) &&
					( MouseCol <= ( pos[1] + 8 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 1;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
					if (ListMacroFiles() == 0)	{
						MKPage ^= MKPage;
						MKIdx ^= MKIdx;
						MKRow = MKMin;
						DisplayMacHdrSave();
						DisplayMacroKeys(MKPage);
					}
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[2] ) &&
					( MouseCol <= ( pos[2] + 9 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 2;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
					ClearMacroDefs();
					MKPage ^= MKPage;
					MKIdx ^= MKIdx;
					DisplayMacroKeys( MKPage );
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[3] ) &&
					( MouseCol <= ( pos[3] + 9 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 3;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
					SaveNewMacroKeys();
					DisplayMacHdrSave();
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[4] ) &&
					( MouseCol <= ( pos[4] + 8 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 4;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
					if ( MKPage == 1 )
						MKPage ^= MKPage;
					else
						MKPage = 1;
					MKRow = MKMin;
					MKIdx ^= MKIdx;
					DisplayMacroKeys( MKPage );
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
				}
				else
				if ( ( MouseRow == 21 ) && ( MouseCol >= pos[5] ) &&
					( MouseCol <= ( pos[5] + 9 ) ) )	{
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), Black+GreenBG );
					PIdx = 5;
					fsattr( 21, pos[PIdx], 1, strlen( funct1[PIdx] ), White+GreenBG );
					MKEQuit = TRUE;
				}
				if ( MouseInstalled )
					Mshow();
				break;

			case MOUSE2BUTTON:

				MKEQuit = TRUE;
				break;

			default:
				break;
		}
	}	while(!MKEQuit);
	if (MouseInstalled)
		Mhide();
	CloseWindow();
}


void DisplayMacHdrSave(void)
{
	fsfill(2,16,1,8,' ',LightCyan+BlueBG);
	fswrite("Macro Name : ",2,3,LastAttr);
	fswriteM(MacroKeys.mname,Yellow+BlueBG);
	fsfill(3,16,1,40,' ',LightCyan+BlueBG);
	fswrite("Description: ",3,3,LastAttr);
	fswriteM(MacroKeys.mdesc,Yellow+BlueBG);
}


void DisplayMacroKeys(unsigned int MKPage)
{
	int	i;

	if (MouseInstalled)
		Mhide();
	switch(MKPage)	{
		case 0:
			fkset=MacroKeys.afkey;
			fswrite(" Alt ",1,60,Yellow+BlueBG);
			fswriteM("Function Keys ",LightCyan+BlueBG);
			break;
		case 1:
			fkset=MacroKeys.cfkey;
			fswrite(" Ctl ",1,60,Yellow+BlueBG);
			fswriteM("Function Keys ",LightCyan+BlueBG);
			break;
		default:
			break;
	}
	fsfill( 6, 9, 12, 60, ' ', LightCyan+BlueBG );
	for ( i = 0; i < 12; i++ )	{
		fswrite( MacKeys[i], i+6, 3, LightCyan+BlueBG );
		fswrite( fkset[i], i+6, 9, White+BlueBG);
	}
	fswrite(MacKeys[0],6,3,Yellow+CyanBG);
	if (MouseInstalled)
		Mshow();
}


int ListMacroFiles()
{
	int		i;
	unsigned int	FLPages = 0;
	unsigned int	FLMaxI;
	unsigned int	FLCurPage = 0;
	unsigned int	FLRow = 6;
	unsigned int	FLRowMin = 6;
	unsigned int 	FLRowMax;
	unsigned int 	FLCol = 9;
	int		LMFQuit = FALSE;
	int		rc;
	int		ch;
	int		key;
	int		bytesr;
	char		ext[5];
	char		filen[9];
	char		drv[3];
	char		dir[66];
	struct ffblk	fileinfo;

	if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
		sprintf( TempBuf, "%s\\%s", PTEnviron, 	"*.MAC" );
	else
		sprintf( TempBuf, "%s%s", PTEnviron, "*.MAC" );

	if ( findfirst( TempBuf, &fileinfo, FA_ARCH ) != 0 )	{

		//  No Macro Files to List!

		return( -1 );
	}

	for ( i = 0; i < 15; i++)
		FList[i] = NULL;
	MakeWindow( 5, 8, 12, 64, Blue+CyanBG, Blue+CyanBG, Shadow, Frame1 );
	fswrite( " Macro ", 5, 53, LastAttr );
	fswriteM( "Name ", Yellow+CyanBG );
	fswriteM( "List ", Blue+CyanBG );

	//	Allocate space for 15 names.

	for (i = 0; i < 15; i++ )	{
		if ( ( FList[i] = (char *) malloc( 9 * sizeof( char ) ) ) == NULL )	{
			fswrite( "Sorry, Out of memory!", 12, 20, White+CyanBG );
		}
	}

	//	Build a Macro Names File.

	if ( ( MFL = sopen( "MNAMES.$$$", O_BINARY | O_CREAT | O_RDWR,
		SH_DENYWR, S_IWRITE ) ) == -1 )  {
		CloseWindow();
		return( -1 );

	}
	setstrng( filen, '\0', 8 );
	fnsplit( fileinfo.ff_name, drv, dir, filen, ext );
	bytesr = write( MFL, filen, ( size_t ) sizeof( filen ) );
	while( findnext( &fileinfo ) == 0 )		{
		setstrng( filen, '\0', 8 );
		fnsplit( fileinfo.ff_name, drv, dir, filen, ext );
		bytesr = write( MFL, filen, ( size_t ) sizeof( filen ) );
		bytesr ^= bytesr;
	}
	lseek( MFL, 0L, SEEK_END );
	FLRecs = ( ( tell( MFL ) ) / ( size_t ) sizeof( filen ) );
	FLPages = ( FLRecs / 11 ) + 1;
	lseek( MFL, 0L, SEEK_SET );
	sprintf( buff, "%u", FLRecs );
	fswrite( buff, 5, 10, Yellow+CyanBG );	// Debug only.
	FLIdx ^= FLIdx;
	FLCurPage ^= FLCurPage;
	FLPtr = ( long )( ( ( FLCurPage * 10 ) + FLIdx ) *
		( size_t ) sizeof( filen ) );
	DisplayMacroNameList();
	FLMaxI = FLIdx - 1;
	FLRowMax = FLMaxI + FLRowMin;
	FLIdx ^= FLIdx;
	fsattr( 6, 9, 1, 62, LightCyan+BlackBG );
	if ( MouseInstalled )
		Mshow();
	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch( ch )	{

					case ESCAPE:

						LMFQuit = TRUE;
						rc = 1;
						break;

					case CR:

						if ( MouseInstalled )
							Mhide();
						if ( FLRecs > 0 )	{
							if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
								sprintf( TempBuf, "%s\\%s%s", PTEnviron, FList[FLIdx],
									".MAC" );
							else
								sprintf( TempBuf, "%s%s%s", PTEnviron, FList[FLIdx],".MAC" );
//							sprintf( TempBuf, "%s%s", FList[FLIdx], ".MAC" );
							rc = ReadMacroFile( TempBuf );
/*							if ( rc == 0 )
								strcpy( LastMacRead, FList[FLIdx] );  */
							LMFQuit = TRUE;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					case SPECIALKEY:

						key = toupper( getch() );
						if ( MouseInstalled )
							Mhide();
						switch( key )	{

							case DN:

								if ( FLRecs == 0 )
									break;
								fsattr( FLRow, FLCol, 1, 62, Blue+CyanBG );
								if ( FLIdx == FLMaxI )  {
									FLIdx ^= FLIdx;
									FLRow = FLRowMin;
								}
								else	{
									FLIdx += 1;
									FLRow += 1;
								}
								fsattr( FLRow, FLCol, 1, 62, LightCyan+BlackBG );
								break;

							case UP:

								if ( FLRecs == 0 )
									break;
								fsattr( FLRow, FLCol, 1, 62, Blue+CyanBG );
								if ( FLIdx == 0 )  {
									FLIdx = FLMaxI;
									FLRow = FLRowMax;
								}
								else	{
									FLIdx -= 1;
									FLRow -= 1;
								}
								fsattr( FLRow, FLCol, 1, 62, LightCyan+BlackBG );
								break;

							case PGDN:

								if ( FLPages < 2 )  {
									Beep( 250 );
									break;
								}
								if ( ( FLCurPage + 1 ) == FLPages )  {
									Beep(250);
									break;
								}
								FLCurPage += 1;
								FLIdx ^= FLIdx;
								FLPtr = ( long )( ( ( FLCurPage * 10 ) + FLIdx ) * (size_t) sizeof( filen ) );
								DisplayMacroNameList();
								FLMaxI = FLIdx - 1;
								FLRowMax = FLMaxI + FLRowMin;
								FLIdx ^= FLIdx;
								FLRow = FLRowMin;
								fsattr( FLRow, FLCol, 1, 62, LightCyan+BlackBG );
								break;

							case PGUP:

								if ( FLCurPage == 0 )  {
									Beep( 250 );
									break;
								}
								FLCurPage -= 1;
								FLIdx ^= FLIdx;
								FLPtr = ( long )( ( ( FLCurPage * 10 ) + FLIdx ) * ( size_t )sizeof( filen ) );
								DisplayMacroNameList();
								FLMaxI = FLIdx - 1;
								FLRowMax = FLMaxI + FLRowMin;
								FLIdx ^= FLIdx;
								FLRow = FLRowMin;
								fsattr( FLRow, FLCol, 1, 62, LightCyan+BlackBG );
								break;

							default:

								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= FLRowMin ) && ( MouseRow <= FLRowMax ) ) &&
					( ( MouseCol >= FLCol ) && ( MouseCol <= ( FLCol + 61 ) ) ) )	{
					if ( FLRecs == 0 )
						break;
					fsattr( FLRow, FLCol, 1, 62, Blue+CyanBG );
					FLIdx = ( MouseRow - FLRowMin );
					FLRow = MouseRow;
					fsattr( FLRow, FLCol, 1, 62, LightCyan+BlackBG );

/*					if ( FLRecs > 0 )	{
						sprintf( TempBuf, "%s%s", FList[FLIdx], ".MAC" );
						rc = ReadMacroFile( TempBuf );
						if ( rc == 0 )
							strcpy( LastMacRead, FList[FLIdx] );
						LMFQuit = TRUE;
					}	*/

				}
				if ( MouseInstalled )
					Mshow();
				break;

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();

				if ( ( ( MouseRow >= FLRowMin ) && ( MouseRow <= FLRowMax ) ) &&
					( ( MouseCol >= FLCol ) && ( MouseCol <= ( FLCol + 61 ) ) ) )	{
					if ( FLRecs == 0 )
						break;
					fsattr( FLRow, FLCol, 1, 62, Blue+CyanBG );
					FLIdx = ( MouseRow - FLRowMin );
					FLRow = MouseRow;
					fsattr( FLRow, FLCol, 1, 62, LightCyan+BlackBG );
					if ( FLRecs > 0 )	{
						if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
							sprintf( TempBuf, "%s\\%s%s", PTEnviron, FList[FLIdx],
								".MAC" );
						else
							sprintf( TempBuf, "%s%s%s", PTEnviron, FList[FLIdx],".MAC" );
//						sprintf( TempBuf, "%s%s", FList[FLIdx], ".MAC" );
						rc = ReadMacroFile( TempBuf );
/*						if ( rc == 0 )
							strcpy( LastMacRead, FList[FLIdx] );  */
						LMFQuit = TRUE;
					}
				}
				if ( MouseInstalled )
					Mshow();
				break;

			case MOUSE2BUTTON:

				LMFQuit = TRUE;
				rc = 1;
				break;

			default:

				break;
		}
	}	while( !LMFQuit );
	for ( i = 0; i < 15; i++ )	{
		if ( FList[i] )
			free( FList[i] );
	}
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	close( MFL );
	unlink( "MNAMES.$$$" );
	return( rc );
}


void DisplayMacroNameList( void )
{
	char		filen[9];
	int		i;
	int		bytesr;
	struct	ffblk	fileinfo;


	setstrng( filen, '\0', 8 );
	if ( FLRecs > 0 )	{
		fsfill( 6, 9, 10, 62, ' ', Blue+CyanBG);
		lseek( MFL, FLPtr, SEEK_SET );
		FLIdx ^= FLIdx;
		while( !eof( MFL ) )	{
			if ( ( bytesr = read( MFL, filen, ( size_t ) sizeof( filen ) ) ) == -1 )	{
				bytesr ^= bytesr;
				break;
			}
			strcpy( FList[FLIdx], filen );
			if ( ++FLIdx > 9 )
				break;
		}
		for ( i = 0; i < FLIdx; i++ )	{
			if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
				sprintf( buff, "%s\\%s%s", PTEnviron, FList[i],
					".MAC" );
			else
				sprintf( buff, "%s%s%s", PTEnviron, FList[i],".MAC" );

//			sprintf( buff, "%s%s", FList[i], ".MAC" );
			if ( findfirst( buff, &fileinfo, FA_ARCH) != 0 )
				continue;
//			if ( ( MKF = fopen( fileinfo.ff_name, "rb" ) ) == NULL )
			if ( ( MKF = fopen( buff, "rb" ) ) == NULL )
				continue;
			if ( ( fread( mnamehold,
				( size_t ) 9, 1, MKF ) ) != 1 )  {
				fprintf( stderr, "Error Reading Macro file.\n" );
				fclose( MKF );
				continue;
			}
			if ( ( fread( mdeschold,
				( size_t ) 41, 1, MKF ) ) != 1 )  {
				fprintf( stderr, "Error Reading Macro file.\n" );
				fclose( MKF );
				continue;
			}
			fclose( MKF );
			fswrite( mnamehold, ( i + 6 ), 10, Blue+CyanBG );
			fswrite( mdeschold, ( i + 6 ), 20, Blue+CyanBG );
		}
	}
}


void InitMacroKeys( void )
{
	int 	i;

	setstrng( MacroKeys.mname, '\0', 9 );
	setstrng( MacroKeys.mdesc, '\0', 40 );
	for ( i = 0; i < 12; i++ )	{
		setstrng( MacroKeys.afkey[i], '\0', 60 );
		setstrng( MacroKeys.cfkey[i], '\0', 60 );
	}
	strcpy( MacroKeys.mname, "Default" );
	strcpy( MacroKeys.mdesc, "Default Function Key Macro Definitions" );
	if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
		sprintf( MacFile, "%s\\%s", PTEnviron, "DEFAULT.MAC" );
	else
		sprintf( MacFile, "%s%s", PTEnviron, 	"DEFAULT.MAC" );

//	strcpy( MacFile,"Default.MAC" );
	strcpy( LastMacRead,"Default" );
}


void ClearMacroDefs( void )
{
	int 	i;

	for ( i = 0; i < 12; i++ )	{
		setstrng( MacroKeys.afkey[i], '\0', 60 );
		setstrng( MacroKeys.cfkey[i], '\0', 60 );
	}
}


void SaveMacroKeys( char *MacF )
{
	int 	i;

	if ( ( MKF = fopen( MacF, "wb" ) ) == NULL )
		return;
	if ( ( fwrite( MacroKeys.mname,
		( size_t ) 9, 1, MKF ) ) != 1 )  {
		fprintf( stderr, "Error Writing Macro file.\n" );
		fclose( MKF );
		return;
	}
	if ( ( fwrite( MacroKeys.mdesc,
		( size_t ) 41, 1, MKF ) ) != 1 )  {
		fprintf( stderr, "Error Writing Macro file.\n" );
		fclose( MKF );
		return;
	}
	for ( i = 0; i < 12; i++ )	{

		if ( ( fwrite( MacroKeys.afkey[i],
			( size_t ) 61, 1, MKF ) ) != 1 )  {
			fprintf( stderr, "Error Writing Macro file.\n" );
			fclose( MKF );
			return;
		}
		if ( ( fwrite( MacroKeys.cfkey[i],
			( size_t ) 61, 1, MKF ) ) != 1 )  {
			fprintf( stderr, "Error Writing Macro file.\n" );
			fclose( MKF );
			return;
		}
	}
	fclose( MKF );
}


int ReadMacroFile( char *MacF )
{
	int 	i;

	if ( ( MKF = fopen( MacF, "rb" ) ) == NULL )
		return( -1 );
	if ( ( fread( MacroKeys.mname,
		( size_t ) 9, 1, MKF ) ) != 1 )  {
		fprintf( stderr, "Error Reading Macro file.\n" );
		fclose( MKF );
		return( -1 );
	}
	if ( ( fread( MacroKeys.mdesc,
		( size_t ) 41, 1, MKF ) ) != 1 )  {
		fprintf( stderr, "Error Reading Macro file.\n" );
		fclose( MKF );
		return( -1 );
	}
	for ( i = 0; i < 12; i++ )	{

		if ( ( fread( MacroKeys.afkey[i],
			( size_t ) 61, 1, MKF ) ) != 1 )  {
			fprintf( stderr, "Error Reading Macro file.\n" );
			fclose( MKF );
			return( -1 );
		}
		if ( ( fread( MacroKeys.cfkey[i],
			( size_t ) 61, 1, MKF ) ) != 1 )  {
			fprintf( stderr, "Error Reading Macro file.\n" );
			fclose( MKF );
			return( -1 );
		}
	}
	fclose( MKF );
	return( 0 );
}


void SaveNewMacroKeys( void )
{
	int		SNMQuit = FALSE;
	int 		i;
	int		ch;
	int		key;
	unsigned int	SNMRow = 14;
	unsigned int 	SNMIdx = 1;
	unsigned int 	pos[3] = { 12, 34, 58 };
	char *funct[3] = {"   Edit   ","    OK    ","  Cancel  "};


	MakeWindow( 7, 8, 10, 64, Blue+LightGrayBG, Blue+LightGrayBG,
			Shadow, Frame1 );
	fswrite( "The Function Key Macro Definitions will be saved as:",
		8, 12, LastAttr );
	fswrite( "Name       : ", 10, 12, LastAttr );
	fswriteM( MacroKeys.mname, Yellow+LightGrayBG );
	fswrite( "Description: ", 11, 12, Blue+LightGrayBG );
	fswriteM( MacroKeys.mdesc, Yellow+LightGrayBG );
	strcpy( mnamehold, MacroKeys.mname );
	strcpy( mdeschold, MacroKeys.mdesc );

	for ( i = 0; i < 3; i++ )	{
		MakeButton( funct[i], SNMRow, pos[i], Black+GreenBG, Black+LightGrayBG );
	}
	fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG );
	if ( MouseInstalled )
		Mshow();
	do	{
		kbflush();
		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch( ch )	{

					case SPECIALKEY:

						if (MouseInstalled)
							Mhide();
						key = toupper( getch() );
						switch( key )	{

							case	LEFT:

								fsattr( SNMRow, pos[SNMIdx], 1, 10, Black+GreenBG);
								if ( SNMIdx == 0 )
									SNMIdx = 2;
								else
									SNMIdx -= 1;
								fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG);
								break;

							case	RIGHT:

								fsattr( SNMRow, pos[SNMIdx], 1, 10, Black+GreenBG );
								if ( SNMIdx == 2 )
									SNMIdx ^= SNMIdx;
								else
									SNMIdx += 1;
								fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG);
								break;

							default:

								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					case CR:

						if ( MouseInstalled )
							Mhide();
						switch( SNMIdx )	{

							case 0:

								setstrng( InitBuf, '', 8 );
								strcpy( mnamehold, MacroKeys.mname );
								strcpy( mdeschold, MacroKeys.mdesc );
								MacChk = TRUE;
								EditStringValue( mnamehold, 8,
									10, 25, InitBuf,
									Cyan+BlueBG, White+BlueBG, Yellow+LightGrayBG );
								MacChk = FALSE;
								setstrng( InitBuf, '', 40 );
								EditStringValue( mdeschold, 40,
									11, 25, InitBuf,
									Cyan+BlueBG, White+BlueBG, Yellow+LightGrayBG );
								break;

							case 1:

								strcpy( MacroKeys.mname, mnamehold );
								strcpy( MacroKeys.mdesc, mdeschold );
								SNMQuit = TRUE;
								break;

							case 2:

								SNMQuit = TRUE;
								break;

							default:

								break;
						}
						if ( MouseInstalled )
							Mshow();
						break;

					case	TAB:

						if ( MouseInstalled )
							Mhide();
						fsattr( SNMRow, pos[SNMIdx], 1, 10, Black+GreenBG );
						if ( SNMIdx == 2 )
							SNMIdx ^= SNMIdx;
						else
							SNMIdx += 1;
						fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG );
						if ( MouseInstalled )
							Mshow();
						break;

					default:
						Beep( 250 );
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();
				if ( ( MouseRow == SNMRow ) && ( ( MouseCol >= pos[0] ) &&
					( MouseCol <= pos[0] + 9 ) ) )	{
					fsattr( SNMRow, pos[SNMIdx], 1, 10, Black+GreenBG );
					SNMIdx = 0;
					fsattr( SNMRow, pos[SNMIdx],1, 10, White+GreenBG );
				}
				else
				if ( ( MouseRow == SNMRow ) && ( ( MouseCol >= pos[1] ) &&
					( MouseCol <= pos[1] + 9 ) ) )	{
					fsattr( SNMRow, pos[SNMIdx], 1, 10, Black+GreenBG );
					SNMIdx = 1;
					fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG );
				}
				else
				if ( ( MouseRow == SNMRow ) && ( ( MouseCol >= pos[2] ) &&
					( MouseCol <= pos[2] + 9 ) ) )	{
					fsattr( SNMRow, pos[SNMIdx],1, 10, Black+GreenBG );
					SNMIdx = 2;
					fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG );
				}
				else
					Beep( 100 );

				if ( MouseInstalled )
					Mshow();

				break;

			case DOUBLE1CLICK:

				if ( MouseInstalled )
					Mhide();

				if ( ( MouseRow == SNMRow )  && ( ( MouseCol >= pos[0] ) &&
					( MouseCol <= pos[0] + 9 ) ) )	{
					fsattr( SNMRow, pos[SNMIdx], 1, 10, Black+GreenBG );
					SNMIdx = 0;
					fsattr( SNMRow, pos[SNMIdx],1, 10, White+GreenBG );
				}
				else
				if ( ( MouseRow == SNMRow ) && ( ( MouseCol >= pos[1] ) &&
					( MouseCol <= pos[1] + 9 ) ) )	{
					fsattr( SNMRow, pos[SNMIdx], 1, 10, Black+GreenBG );
					SNMIdx = 1;
					fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG );
				}
				else
				if ( ( MouseRow == SNMRow ) && ( ( MouseCol >= pos[2] ) &&
					( MouseCol <= pos[2] + 9 ) ) )	{
					fsattr( SNMRow, pos[SNMIdx],1, 10, Black+GreenBG );
					SNMIdx = 2;
					fsattr( SNMRow, pos[SNMIdx], 1, 10, White+GreenBG );
				}
				else	{
					Beep( 100 );
					if ( MouseInstalled )
						Mshow();
					break;
				}
				switch( SNMIdx )	{

					case 0:

						setstrng( InitBuf, '', 8 );
						strcpy( mnamehold, MacroKeys.mname );
						strcpy( mdeschold, MacroKeys.mdesc );
						MacChk = TRUE;
						EditStringValue( mnamehold, 8,
							10, 25, InitBuf,
							Cyan+BlueBG, White+BlueBG, Yellow+LightGrayBG );
						MacChk = FALSE;
						setstrng( InitBuf, '', 40 );
						EditStringValue( mdeschold, 40,
							11, 25, InitBuf,
							Cyan+BlueBG, White+BlueBG, Yellow+LightGrayBG );
						break;

					case 1:
						strcpy( MacroKeys.mname, mnamehold );
						strcpy( MacroKeys.mdesc, mdeschold );
						SNMQuit = TRUE;
						break;

					case 2:

						SNMQuit = TRUE;
						break;

					default:

						break;
				}
				if ( MouseInstalled )
					Mshow();

				break;

			case MOUSE2BUTTON:

				SNMQuit = TRUE;
				break;

			default:
				break;

		}
	}	while ( !SNMQuit );

	if ( MouseInstalled )
		Mhide();
	CloseWindow();
	if ( PTEnviron[strlen( PTEnviron ) - 1] != '\\' )
		sprintf( MacFile, "%s\\%s%s", PTEnviron, MacroKeys.mname,
			".MAC" );
	else
		sprintf( MacFile, "%s%s%s", PTEnviron, MacroKeys.mname,
			".MAC" );

/*	sprintf( MacFile, "%s%s", LastMacRead, ".MAC" );  */

	if ( SNMIdx != 1 )
		return;

	// Open Macro File

	if ( ( MKF = fopen( MacFile, "wb" ) ) == NULL )
		return;
	if ( ( fwrite( MacroKeys.mname,
		( size_t ) 9, 1, MKF ) ) != 1 )  {
		fprintf( stderr, "Error Writing New Macro file.\n" );
		fclose( MKF );
		return;
	}
	if ( ( fwrite( MacroKeys.mdesc,
		( size_t ) 41, 1, MKF ) ) != 1 )  {
		fprintf( stderr, "Error Writing New Default file.\n" );
		fclose( MKF );
		return;
	}
	for ( i = 0; i < 12; i++ )	{

		if ( ( fwrite( MacroKeys.afkey[i],
			( size_t ) 61, 1, MKF ) ) != 1 )  {
			fprintf( stderr,"Error Writing New Macro file.\n" );
			fclose( MKF );
			return;
		}
		if ( ( fwrite( MacroKeys.cfkey[i],
			( size_t ) 61, 1, MKF ) ) != 1 )  {
			fprintf( stderr, "Error Writing New Macro file.\n" );
			fclose( MKF );
			return;
		}
	}
	fclose( MKF );
}


