
/*
		---------------------------------------
					PowerTerm v0.01
		PowerTerm (c) 1992-93  Byron D Copeland
				  All Rights Reserved.
		---------------------------------------

*/

#include "fsvlib.h"
#include "menhndlr.h"

/**********************************************************************/
/*  This function is a generic menu bar handling function used by all */
/* menus functions to move the menu bar down.  All values are passed  */
/* by reference except the color attributes.                          */
/*                                                                    */
/* M     = Pointer to Menu Array.                                     */
/* Idx   = Pointer to Menu Index Variable.                            */
/* Row   = Pointer to Menu Row Variable.                              */
/* RowMn = Pointer to Menu Minumum Line Variable.                     */
/* Col   = Pointer to Menu Column Variable.                           */
/* MaxI  = Pointer to Menu Maximum Index Variable.                    */
/* Attr1 = Reset Menu Bar Color.                                      */
/* Attr2 = Set Menu Bar Color.                                        */
/**********************************************************************/

void MoveMenuBarDown (M, Idx, Row, RowMn, Col, MaxI, Attr1, Attr2)
  char *M[];
  unsigned int *Idx, *Row, *RowMn, *Col, *MaxI, Attr1, Attr2;
{
  fswrite( M[( * Idx )], ( * Row ), ( * Col ), Attr1 );

  if ( ( * Idx ) == ( * MaxI ) ) {
    ( * Row ) = ( * RowMn );
    ( * Idx ) = 0;
  }
  else  {
    ( * Row )++;
    ( * Idx )++;
  }

  fswrite( M[( * Idx )], ( * Row ), ( * Col ), Attr2);
}

/**********************************************************************/
/*  This function is a generic menu bar handling function used by all */
/* menus functions to move the menu bar up.  All values are passed    */
/* by reference except the color attributes.                          */
/*                                                                    */
/* M     = Pointer to Menu Array.                                     */
/* Idx   = Pointer to Menu Index Variable.                            */
/* Row   = Pointer to Menu Row Variable.                              */
/* RowMx = Pointer to Menu Maximum Line Variable.                     */
/* Col   = Pointer to Menu Column Variable.                           */
/* MaxI  = Pointer to Menu Maximum Index Variable.                    */
/* Attr1 = Reset Menu Bar Color.                                      */
/* Attr2 = Set Menu Bar Color.                                        */
/**********************************************************************/

void MoveMenuBarUp (M, Idx, Row, RowMx, Col, MaxI, Attr1, Attr2)
  char *M[];
  unsigned int *Idx, *Row, *RowMx, *Col, *MaxI, Attr1, Attr2;
{
  fswrite( M[( * Idx )], ( * Row ), ( * Col ), Attr1 );
  if ( !( * Idx ) ) {
    ( * Row ) = ( * RowMx );
    ( * Idx ) = ( *MaxI );
  }
  else  {
    ( * Row )--;
    ( * Idx )--;
  }
  fswrite( M[( * Idx )], ( * Row ), ( * Col ), Attr2);
}

void MoveMenuBar (M, Idx, Row, RowTo, RowMn, Col, MaxI, Attr1, Attr2)
  char *M[];
  unsigned int *Idx, *Row;
  int RowTo;
  unsigned int *RowMn, *Col, *MaxI, Attr1, Attr2;
{
  fswrite( M[( * Idx )], ( * Row ), ( * Col ), Attr1);
  ( * Row ) = RowTo;
  ( * Idx ) = ( RowTo - ( * RowMn ) );
  fswrite( M[( * Idx )], ( * Row ), ( * Col ), Attr2);
}


/**********************************************************************/
/*  This function is a generic menu display bar handling function     */
/*  used by all menus functions to move the menu bar up.  All values  */
/*  are passed by reference except the color attributes.              */
/*                                                                    */
/* M     = Pointer to Menu Array.                                     */
/* MR    = Pointer to Max rows variable.                              */
/* RM    = Pointer to Minumum Row Variable.                           */
/* Idx   = Pointer to Menu Index Variable.                            */
/* Row   = Pointer to Menu Row Variable.                              */
/* Col   = Pointer to Menu Column Variable.                           */
/**********************************************************************/

void DisplayPullDownData (M, MR, RM, Col, Row, Idx)
  char *M[];
  unsigned int *MR, *RM, *Col, *Row, *Idx;
{
	unsigned int i;

	for ( i = 0; i < ( * MR ); i++ )  {
		fswrite( M[i], ( i + ( * RM ) ), ( * Col ), LightCyan+CyanBG );
	}
	fswrite( M[( * Idx )], ( * Row ), ( * Col ), White+BlackBG );
}

