/*
				---------------------------------------
							PowerTerm v0.01
				PowerTerm (c) 1992-93  Byron D Copeland
						  All Rights Reserved.
				---------------------------------------

*/


#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <setjmp.h>

#define  FALSE		0
#define  TRUE		( !FALSE )
#define  GOODBLK	100
#define  WAIT		101
#define	 DONE		102

#define  XOFF	0x13
#define  XON	0x11

int				asctmint;
static	int		XonHold = FALSE;
jmp_buf			ascenv;

static unsigned char	ascbuf[256];

extern char		*fileswork1;

//extern FILE	*xferfp;


void AsciiSend( void );
void AsciiReceive( void );
int  recvAsciiData( void );
static void ascsigjmp( int sig );			/* Timer interrupt handler */


/*-------------------------------------------------------------------*


 *-------------------------------------------------------------------*/

void AsciiSend()
{

	int		c;
	int		cc;
	int		i;
	FILE	*xferfp;

	flushinput();
	if ( ( xferfp = fopen( fileswork1, "wb" ) ) == NULL )	{
//		CloseWindow();
		return;
	}

	c = fgetc( xferfp );

	while ( !feof( xferfp ) ) 	{

		if ( c == '\t' )					// Expand tabs
			for ( i = 0; i < 4; i++ )
				SerialOut( ' ' );
		else
			SerialOut( (unsigned char)c );

		c = fgetc( xferfp );

	}

	fclose( xferfp );
}



void AsciiReceive()
{

	int 	ascDone;
	FILE	*xferfp;

	asctmint = 10;

	if ( ( xferfp = fopen( fileswork1, "wb" ) ) == NULL )	{
//		CloseWindow();
		return;
	}

	if ( signal( SIGTERM, ascsigjmp ) == SIG_ERR )	{
//		CloseWindow();
		fprintf(stderr,"ascsigjmp() - signal error\n");
		return;
	}

	setstrng( ascbuf, '\0', 255 );
	ascDone = FALSE;

	while ( !ascDone )	{

		switch( recvAsciiData() )	{

			case GOODBLK:

				fputs( ascbuf, xferfp );
				setstrng( ascbuf, '\0', 255 );
				break;

			case WAIT:

				break;

			case DONE:

				ascDone = TRUE;
				break;

			default:

				break;
		}

	}
	fclose( xferfp );
}



int recvAsciiData( void )
{

	int		c;
	int		ascData;
	int		rc;
	register unsigned char *aptr;

	aptr = ascbuf;

	if ( XonHold )
		return( WAIT );

	if ( setjmp( ascenv ) )
		return( DONE );

	alarm( asctmint );		// Set timer

	// Get a block

	ascData = FALSE;
	while ( !ascData )	{

		*aptr = ( unsigned char )char_waiting();
		if ( *aptr == XOFF )	{
			XonHold = TRUE;
		}
		else
		if ( *aptr == XON )	{
			XonHold = FALSE;
		}
		else
		if ( ( *aptr == '\n' ) && ( *( aptr - 1 ) == '\r' ) )	{
			*++aptr = '\0';
			alarm( 0 );
			rc = GOODBLK;
			ascData = TRUE;
		}
		else
			aptr++;
	}

	alarm( 0 );
	return( rc );
}



static void ascsigjmp( int sig )			/* Timer interrupt handler */
{
	if ( sig == SIGTERM )	{

		alarm( 0 );

		if ( signal( SIGTERM, ascsigjmp ) == SIG_ERR )
			fprintf( stderr, "ascsigjmp() - signal error\n" );

		longjmp( ascenv, TRUE );
	}
}