
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			  All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <dos.h>

#include "fsvlib.h"
#include "pckeys.h"
#include "mouse.h"
#include "bcstrs.h"

#define FALSE	0
#define TRUE	(!FALSE)

extern unsigned  	filestodo;
extern unsigned 	fileslefttodo;

extern char 		*fileswork1;
extern char 		*fileswork2;
extern char 		*TempBuf;
extern char 		*InitBuf;
extern char		*PTEnviron;
extern char		*buff;
extern char		*filestoxfer[20];

extern int		FnChk;
extern int		WINLOOK;
extern int		UPPERONLY;
extern int		MouseInstalled;
extern int		MouseRow;
extern int		MouseCol;

extern struct	PTS	{

	char	PTPaths[66];

} PTSetup[4];


void 		TransferFile( char *mode, char srflag );
int 		GetXferFileName( char srflag );
int 		GetYmodemFileNames( void );
void 		DisplayXferFileError( void );

/*-----------------------------------------------------------------------

  ----------------------------------------------------------------------*/

void TransferFile( char *mode, char srflag )
{
	int	TFDone;
	int	ch;
	char	*XferMsg = "Transfer Protocol Selection for %s File";

	TFDone = FALSE;

	MakeWindow( 5, 6, 13, 70, LightCyan+BlueBG, LightCyan+BlueBG,
		Shadow, Frame1 );
	fswrite( "", 7, 6, LightCyan+BlueBG );
	fsfill( 7, 7, 1, 68, '', LightCyan+BlueBG );
	fswriteM( "", LightCyan+BlueBG );
	fsfill( 6, 7, 1, 68,' ', LightCyan+CyanBG );
	sprintf( buff, XferMsg, mode);
	fswriteC( buff, 6, VidCols, Yellow+CyanBG );
	fswrite( "Esc-Exit", 17, 62, LightCyan+BlueBG );
	fswrite( "A", 8, 8, Yellow+BlueBG );
	fswriteM( ") Ascii", LightCyan+BlueBG );
	fswrite( "B", 10, 8, Yellow+BlueBG );
	fswriteM( ") Xmodem (Checksum)", LightCyan+BlueBG );
	fswrite( "C", 12, 8, Yellow+BlueBG );
	fswriteM( ") Xmodem (CRC)", LightCyan+BlueBG );
	fswrite( "D", 14, 8, Yellow+BlueBG );
	fswriteM( ") Xmodem-1K", LightCyan+BlueBG );
	fswrite( "E", 16, 8, Yellow+BlueBG );
	fswriteM( ") Ymodem", LightCyan+BlueBG );
	fswrite( "F", 8, 33, Yellow+BlueBG );
	fswriteM( ") Ymodem (Batch)", LightCyan+BlueBG );
	fswrite( "G", 10, 33, Yellow+BlueBG );
	fswriteM( ") Ymodem G (Batch)", LightCyan+BlueBG );
	fswrite( "Z", 12, 33, Yellow+BlueBG );
	fswriteM( ") Zmodem (Batch)", LightCyan+BlueBG );
	fswrite( "S", 14, 33, Yellow+BlueBG );
	fswriteM( ") SEAlink (+ overdrive)", LightCyan+BlueBG );
	fswrite( "J", 16, 33, Yellow+BlueBG );
	fswriteM( ") Jmodem", LightCyan+BlueBG );

	if ( MouseInstalled )
		Mshow();
	do	{
		kbflush();

		switch( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch() );
				switch( ch )	{

					case ESCAPE:

						if ( MouseInstalled )
							Mhide();
						CloseWindow();
						TFDone = TRUE;
						break;

					case 'A':

						if ( MouseInstalled )
							Mhide();

						CloseWindow();

						if ( !GetXferFileName( srflag ) )	{
							TFDone = TRUE;
							break;
						}
						if ( srflag == 'R' )

							AsciiReceive();
						else
							AsciiSend();

						TFDone = TRUE;

						break;

					case 'B':

						if ( MouseInstalled )
							Mhide();
						CloseWindow();
						if ( !GetXferFileName( srflag ) )	{
							TFDone = TRUE;
							break;
						}
						if ( srflag == 'R' )
							XmodemRecv( 0, TempBuf );	// Xmodem CheckSum
						else
							XmodemSend( 0, TempBuf );
						TFDone = TRUE;
						break;

					case 'C':

						if ( MouseInstalled )
							Mhide();
						CloseWindow();
						if ( !GetXferFileName( srflag) )	{
							TFDone = TRUE;
							break;
						}
						if ( srflag == 'R' )
							XmodemRecv( 1, TempBuf );	// Xmodem CRC
						else
							XmodemSend( 1, TempBuf );
						TFDone = TRUE;
						break;

					case 'D':

						if ( MouseInstalled )
							Mhide();
						CloseWindow();
						if ( !GetXferFileName( srflag ) )	{
							TFDone = TRUE;
							break;
						}
						if ( srflag == 'R' )
							XmodemRecv( 2, TempBuf );	// Xmodem 1-K CRC
						else
							XmodemSend( 2, TempBuf );
						TFDone = TRUE;
						break;

					case 'E':

						if ( MouseInstalled )
							Mhide();
						CloseWindow();
						if ( srflag == 'R' )
							YmodemRecv( 0 );
						else	{
							if ( !GetYmodemFileNames() )	{
								TFDone = TRUE;
								break;
							}
							YmodemSend( 0 );
						}
						TFDone = TRUE;
						break;

					case 'F':

						if ( MouseInstalled )
							Mhide();
						CloseWindow();
						if ( srflag == 'R' )
							YmodemRecv( 1, TempBuf );
						else	{
							if ( !GetYmodemFileNames() )	{
								TFDone = TRUE;
								break;
							}
							YmodemSend( 1 );
						}
						TFDone = TRUE;
						break;

					case 'G':

						if ( MouseInstalled )
							Mhide();
						CloseWindow();
						if ( srflag == 'R' )
							YmodemRecv( 2, TempBuf ); // Ymodem-G
						else	{
							if ( !GetYmodemFileNames() )	{
								TFDone = TRUE;
								break;
							}
							YmodemGSend( 2 );
						}
						TFDone = TRUE;
						break;

					case 'Z':

						if ( MouseInstalled )
							Mhide();

						CloseWindow();

						if ( srflag == 'R' )
							zmReceive();
						else	{
							if ( !GetYmodemFileNames() )	{
								TFDone = TRUE;
								break;
							}
							zmSend();
						}

						TFDone = TRUE;
						break;

					default:

						Beep( 100 );
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( MouseInstalled )
					Mhide();

				if ( MouseCol == 8 )	{
					if ( MouseRow == 10 )	{

						CloseWindow();
						if ( !GetXferFileName( srflag ) )	{
							TFDone = TRUE;
							break;
						}
						if ( srflag == 'R' )
							XmodemRecv( 0 );	// Xmodem CheckSum
						else
							XmodemSend( 0 );
						TFDone = TRUE;
						break;
					}
					else
					if ( MouseRow == 12 )	{
						CloseWindow();
						if ( !GetXferFileName( srflag) )	{
							TFDone = TRUE;
							break;
						}
						if ( srflag == 'R' )
							XmodemRecv( 1 );	// Xmodem CRC
						else
							XmodemSend( 1 );
						TFDone = TRUE;
						break;
					}
					else
					if ( MouseRow == 14 )	{
						CloseWindow();
						if ( !GetXferFileName( srflag ) )	{
							TFDone = TRUE;
							break;
						}
						if ( srflag == 'R' )
							XmodemRecv( 2 );	// Xmodem 1-K CRC
						else
							XmodemSend( 2 );
						TFDone = TRUE;
						break;
					}
					else
					if ( MouseRow == 16 )	{
						CloseWindow();
						if ( srflag == 'R' )
							YmodemRecv( 0 );
						else	{
							if ( !GetYmodemFileNames() )	{
								TFDone = TRUE;
								break;
							}
							YmodemSend( 0 );
						}
						TFDone = TRUE;
						break;
					}
				}
				else
				if ( MouseCol == 33 )	{
					if ( MouseRow == 8 )	{
						CloseWindow();
						if ( srflag == 'R' )
							YmodemRecv( 1 );
						else	{
							if ( !GetYmodemFileNames() )	{
								TFDone = TRUE;
								break;
							}
							YmodemSend( 1 );
						}
						TFDone = TRUE;
						break;
					}
					else
					if ( MouseRow == 10 )	{
						CloseWindow();
						if ( srflag == 'R' )
							YmodemRecv( 2 ); // Ymodem-G
						else	{
							if ( !GetYmodemFileNames() )	{
								TFDone = TRUE;
								break;
							}
							YmodemSend( 2 );
						}
						TFDone = TRUE;
						break;
					}
				}
				else
					Beep ( 100 );

				if ( MouseInstalled )
					Mshow();

				break;

			case DOUBLE1CLICK:

				break;

			case MOUSE2BUTTON:

				if ( MouseInstalled )
					Mhide();
				CloseWindow();
				TFDone = TRUE;
				break;

			default:

				break;

		}
	}	while( !TFDone );
}

/*-----------------------------------------------------------------------

  ----------------------------------------------------------------------*/

int GetXferFileName( char srflag )
{
	int	rc;
	int	Flag;

	struct	ffblk ffinfo;

	MakeWindow( 10, 4, 5, 74, LightCyan+BlueBG, LightCyan+BlueBG,
			Shadow, Frame1 );
	fswriteC( " Enter Filename or ENTER to Quit ", 10, VidCols, LightCyan+BlueBG );
	fswrite( "Filename: ", 12, 6, LightCyan+BlueBG );
	Flag = FALSE;
	rc = 1;
	do	{
		setstrng( InitBuf, '', 60 );
		setstrng( fileswork1, '\0', 60 );

		// Start with Dnld or Upld Directory Displayed

		if ( srflag == 'R' )
			strcpy( fileswork1, PTSetup[0].PTPaths );
		else
			strcpy( fileswork1, PTSetup[1].PTPaths );

		if ( !*fileswork1 )
			strcpy( fileswork1, PTEnviron );

		FnChk = TRUE;
		UPPERONLY = TRUE;
		EditStringValue( fileswork1, 60, 12, 16, InitBuf,
			Cyan+BlueBG, Yellow+CyanBG, Yellow+BlueBG );
		FnChk = FALSE;
		UPPERONLY = FALSE;
		if ( !*fileswork1 )	{
			rc = 0;
			break;
		}
		if ( srflag == 'R' )	{
			if ( !strcmp( fileswork1, PTSetup[0].PTPaths ) )	{
				rc = 0;
				break;
			}
		}
		else	{
			if ( !strcmp( fileswork1, PTSetup[1].PTPaths ) )	{
				rc = 0;
				break;
			}
		}
		if (srflag == 'R')	{
			Flag = TRUE;
			break;
		}
		else	{
			if ( findfirst( fileswork1, &ffinfo, FA_ARCH ) )	{
				DisplayXferFileError();
			}
			else	{
				Flag = TRUE;
				break;
			}
		}
	}	while( !Flag );

	CloseWindow();
	return( rc );
}

/*-----------------------------------------------------------------------

  ----------------------------------------------------------------------*/

int GetYmodemFileNames( void )
{
	char 		*p;
	int		ch;
	unsigned long	fcnt;
	unsigned long	allcnt;
	int		i;
	int		ffdone;
	char		Path[MAXPATH];
	char		drv[MAXDRIVE];
	char		dir[MAXDIR];
	char		fn[MAXFILE];
	char		ext[MAXEXT];
	unsigned int 	nfiles;
	struct	ffblk fileinfo;


	WINLOOK = TRUE;
	nfiles = 0;
	allcnt = 0;
	MakeWindow( 9, 7, 14, 65, LightCyan+CyanBG, LightCyan+CyanBG,
			Shadow, Frame1 );

	Boxit( 10, 8, 6, 63, LightCyan+CyanBG, Frame1 );
	sprintf( TempBuf, "Default drive:path %s", PTSetup[1].PTPaths );
	fswriteC( TempBuf, 11, VidCols, LastAttr );
	fswriteC( "Enter [drv:path] filename(s) below separated by a space.",
		12, 80, LastAttr );
	fswriteC("Wildcards are OK. (20,000 files max.)", 14,
		80, LastAttr );

	Boxit( 17, 8, 4, 63, LastAttr, Frame1 );
	setstrng( InitBuf, '', 60 );
	setstrng( fileswork1, '\0', 60 );

//	strcpy( fileswork1, PTSetup[1].PTPaths );

	filestodo = 0;
	fileslefttodo = 0;

	UPPERONLY = TRUE;
	EditStringValue( fileswork1, 60,
			18, 9, InitBuf, Blue+CyanBG,
			LightCyan+BlueBG, LightCyan+CyanBG );
	p = NULL;
	p = strtok( fileswork1, " ");
	while ( ( p ) && ( filestodo < 20 ) )  {
/*		if ( fcnt > 999L )
			break;*/
		p = lstrip( p );
		tstrip( p );
		strcpy( filestoxfer[filestodo], p );
		fcnt = 0L;
//		strcpy( Path, filestoxfer[filestodo] );
		fnsplit( filestoxfer[filestodo], drv, dir, fn, ext );
		if ( (!*drv ) && (!*dir) )
			sprintf( Path, "%s%s%s", PTSetup[1].PTPaths, fn, ext );
		else
			sprintf( Path, "%s%s%s%s", drv, dir, fn, ext );
		ffdone = findfirst( Path, &fileinfo, FA_ARCH );
		while( !ffdone )		{
			fcnt++;
			ffdone = findnext( &fileinfo );
		}
		if ( fcnt > 0 )	{
			strcpy( filestoxfer[filestodo], Path );
			filestodo++;
			allcnt += fcnt;
		}
//		filestodo++;
		p = strtok( 0, "@ " );
	}
	setstrng( InitBuf, '', 60 );
	setstrng( fileswork2, '\0', 60 );
	EditStringValue( fileswork2, 60,
			19, 9, InitBuf, Blue+CyanBG,
			LightCyan+BlueBG, LightCyan+CyanBG );
	p = NULL;
	p = strtok( fileswork2, " ");
	while ( ( p ) && ( nfiles < 20 ) )  {
/*		if ( fcnt > 999L )
			break;*/
		p = lstrip( p );
		tstrip( p );
		strcpy( filestoxfer[filestodo+nfiles], p );
		fcnt = 0L;
//		strcpy( Path, filestoxfer[filestodo+nfiles] );
		fnsplit( filestoxfer[filestodo+nfiles], drv, dir, fn, ext );
		if ( (!*drv ) && (!*dir) )
			sprintf( Path, "%s%s%s", PTSetup[1].PTPaths, fn, ext );
		else
			sprintf( Path, "%s%s%s%s", drv, dir, fn, ext );
		ffdone = findfirst( Path, &fileinfo, FA_ARCH );
		while( !ffdone )	{
			fcnt++;
			ffdone = findnext( &fileinfo );
		}
		if ( fcnt > 0 )	{
			strcpy( filestoxfer[filestodo+nfiles], Path );
			allcnt += fcnt;
			nfiles++;
		}
		p = strtok( 0, "@ " );
	}
	filestodo += nfiles;
	sprintf( TempBuf, "Transferring %lu files", allcnt );
	fswriteC( TempBuf, 21, VidCols, White+CyanBG );
	WINLOOK = FALSE;
	UPPERONLY = FALSE;
	if ( filestodo < 1 )  {
		fswriteC( "No Files Were Found...Press Any Key to Continue.",
		16, 80, White+CyanBG );
		ch = getch();
		CloseWindow();
		kbflush();
		return( 0 );
	}
	fswriteC( "Press ESC to CANCEL now, any other key to proceed.",
		16, 80, White+CyanBG );
	ch = toupper( getch() );
	if ( ch == ESCAPE )  {
		CloseWindow();
		return( 0 );
	}
	CloseWindow();
	return( 1 );
}

/*-----------------------------------------------------------------------

  ----------------------------------------------------------------------*/


void DisplayXferFileError( void )
{

	MakeWindow( 16, 18, 4, 45, Yellow+RedBG, Yellow+RedBG,
		Shadow, Frame1 );
	Beep( 250 );
	fswriteC( "File or Path is Invalid! ", 17, VidCols, Yellow+RedBG );
	fswriteC( "Press any key...", 18, VidCols, Yellow+RedBG );
	kbflush();
	while( !fast_kbhit() );
	kbflush();
	CloseWindow();
}

/*-----------------------------------------------------------------------

  ----------------------------------------------------------------------*/