/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			  All Rights Reserved.
		---------------------------------------

*/

// Zmodem File send & receive module.

#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <setjmp.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <time.h>


//#include "crcccitt.h"


#include "fsvlib.h"
#include "ptzmodem.h"
#include "bcstrs.h"

static unsigned int flcnt = 0;

/*-----------------------------------------------------------------------

 -----------------------------------------------------------------------*/


int     zmReceive( void )
{


	if ( signal( SIGTERM, zmsigjmp ) == SIG_ERR )   {
		fprintf(stderr,"zmsigjmp() - fatal signal error\n");
		return( ERROR );
	}
	DisplayXferWndw( "R e c e i v e", 0 );
	fswrite( "Zmodem (Batch)", 10, 22, Yellow+BlueBG );
	receiver_buffer_length = 16384;
	zmblknum = 0L;
	wake_up_sender_header_type = ZRINIT;
	zmtotalbytes = 0L;
	switch( zmWakeUpSender() )      {

		case 0:

		case ZCOMPL:            // Successful transfer

			fswrite( ym_msg6, 17, 22, Yellow+BlueBG+Blink );
			Ringing2();
			CloseWindow();
			return( OK );

		case ERROR:                     // Unsuccessful transfer

			fswrite( ym_msg7, 17, 22, Yellow+BlueBG+Blink );
			Ringing2();
			break;

		default:

			switch( zmReceiveFiles() )      {

				case OK:

					fswrite( ym_msg6, 17, 22, Yellow+BlueBG+Blink );
					Ringing2();
					CloseWindow();
					return( OK );

				case UCAN:

					if ( zmflfp )
						fclose( zmflfp );
					fswrite( ym_msg17, 17, 22, Yellow+BlueBG+Blink );
					Ringing2();
					CloseWindow();
					flushinput();
					return( OK );

				default:

					break;
			}

	}

	// Terminate transfer now!

	SerialString( CancelString );
	if ( zmflfp )
		fclose( zmflfp );
	delay( 1000 );
	CloseWindow();
	return( ERROR );
}



int zmReceiveFiles( void )
{

	int     return_status;

	for ( ; ; )     {

		switch( return_status = zmReceiveSingleFile() ) {

			case ZEOF:

//                      case ZABORT:
			case ZSKIP:

				switch( zmWakeUpSender() )      {

					case ZCOMPL:

						return( OK );

					default:

//                                              Ringing2();
						return( ERROR );

					case ZFILE:

						fswrite( zm_msg2, 17, 22, Yellow+BlueBG );
						break;

				}
				continue;

			default:

				return return_status;

			case ERROR:

				fswrite( ym_msg7, 17, 22, Yellow+BlueBG );
				Ringing2();
				return ( ERROR );
		}
	}
}




int zmWakeUpSender( void )
{

	int     c;
	int     n;
	int     try_again;

	for ( n = 0; n < 10; n++ )      {
		zmPackLongIntoHeader( 0L );
		transmitted_header[ ZF0 ] =
			CANFC32 | CANFDX | CANOVIO | CANBRK;
		zmSendHexHeader( 4,
			wake_up_sender_header_type, transmitted_header );
		fswrite( "                         ", 17, 22, Yellow+BlueBG );
		sprintf( TempBuf, "Sending %s\0", zFrameTypes[ wake_up_sender_header_type + 4 ] );
		fswrite( TempBuf, 17, 22, Yellow+BlueBG );
		if ( wake_up_sender_header_type == ZSKIP )
			wake_up_sender_header_type = ZRINIT;
		for ( try_again = 1; try_again; )       {
			switch( zmReadHeader( received_header ) )       {

				case ZRQINIT:
				case ZEOF:
				case TIMEOUT:
				default:

					try_again = 0;
					break;

				case ZFILE:

					wake_up_sender_header_type = ZRINIT;
					c = zmReadDataFrame( zmBuffer, zmblksize );
					if ( c == GOTCRCW )
						return( ZFILE );
					zmSendHexHeader( 4, ZNAK, transmitted_header );
					break;

				case ZSINIT:

					if ( zmReadDataFrame( attention_string, ZATTNLEN )
							== GOTCRCW )    {
						zmPackLongIntoHeader( 1L );
						zmSendHexHeader( 4, ZACK, transmitted_header );
					}
					else
						zmSendHexHeader( 4, ZNAK, transmitted_header );
					break;

				case ZCOMPL:

					break;

				case ZFIN:

					zmAckZFIN();
					return( ZCOMPL );

				case ZCAN:

					return( ERROR );
			}
		}
	}
	return( 0 );
}




int zmReceiveSingleFile( void )
{

	int             c;
	int             h;
	int             i;
	int             error_count;
	long            rxbytes;


	ClearXferWndw();
	sprintf( TempBuf, "%u", zmblksize );
	fswrite( TempBuf, 14, 22, Yellow+BlueBG );
	if ( zmOpenInputFile( zmBuffer ) == ERROR )     {
		fswrite( zm_msg1, 17, 22, Yellow+BlueBG );              // Open error; skip it
		return wake_up_sender_header_type = ZSKIP;
	}
	zmblknum = 0L;
	error_count = 0;
	rxbytes = 0L;
	time( &ztickstart );
	for ( ; ; )     {
		zmPackLongIntoHeader( rxbytes );
		zmSendHexHeader( 4, ZRPOS, transmitted_header );

nxthdr:

		if ( KEY_HIT )  {
			h = getch();
			KEY_HIT = FALSE;
			kbflush();
			if ( h == CAN ) {
				for ( i = 0; i < 8; i ++ )      {
					while( SerialOut( CAN ) == -1);
					delay( 250 );
				}
				for ( i = 0; i < 8; i ++ )  {
					while( SerialOut( BS ) == -1);
					delay( 250 );
				}
				return( UCAN );
			}
		}
		sprintf( TempBuf, "%d", error_count );
		fswrite( TempBuf, 15, 22, Yellow+BlueBG );
		sprintf( TempBuf, "%lu ", rxbytes );
		fswrite( TempBuf, 13, 62, Yellow+BlueBG );
		fswrite( zm_msg4, 17, 22, Yellow+BlueBG );
		switch( c = zmReadHeader( received_header ) )   {

			default:

				return( ERROR );

			case ZNAK:
			case TIMEOUT:

				if ( ++error_count >= 20 )      {
					return( ERROR );
				}

			case ZFILE:

				zmReadDataFrame( zmBuffer, zmblksize );
				continue;

			case ZEOF:

				if ( zmUnpackHeaderIntoLong( received_header ) !=
							rxbytes )
					goto nxthdr;
				fflush( zmflfp );

				// Set file date/time stamp

				if ( zmfdate )  {
					zmfdtinfo.ft_tsec = zmtime.ti_sec >> 1;
					zmfdtinfo.ft_min = zmtime.ti_min;
					zmfdtinfo.ft_hour = zmtime.ti_hour;
					zmfdtinfo.ft_day = zmdate.da_day;
					zmfdtinfo.ft_month = zmdate.da_mon;
					zmfdtinfo.ft_year = zmdate.da_year - 1980;
					setftime( fileno( zmflfp ), &zmfdtinfo );
				}
				if ( fclose( zmflfp ) != 0 )    {
					wake_up_sender_header_type = ZFERR;
					return( ERROR );
				}
				return( c );

			case ERROR:

				if ( ++error_count >= 20 )      {
					return( ERROR );
				}
				zmSendAttentionString();
				continue;

			case ZSKIP:

				fclose( zmflfp );

				// file skipped by sender

				fswrite( zm_msg1, 17, 22, Yellow+BlueBG );
				return( c );

			case ZDATA:

				if ( zmUnpackHeaderIntoLong( received_header ) !=
						rxbytes )       {
					if ( ++error_count >=20 )

						// too many errors

						return( ERROR );
					zmSendAttentionString();
					continue;
				}
moredata:
				if ( KEY_HIT )  {
					h = getch();
					KEY_HIT = FALSE;
					kbflush();
					if ( h == CAN ) {
						for ( i = 0; i < 8; i ++ )      {
							while( SerialOut( CAN ) == -1 );
							delay( 250 );
						}
						for ( i = 0; i < 8; i ++ )      {
							while(SerialOut( BS ) == -1);
							delay( 250 );
						}

//                                              SerialString( CancelString );

						return( UCAN );

					}
				}

				switch( c = zmReadDataFrame( zmBuffer, zmblksize ) )    {

					case ZCAN:

						// sender cancelled

						fswrite( ym_msg18, 17, 22, Yellow+BlueBG+Blink );
						return( ERROR );

					case ERROR:

						if ( ++error_count >= 20 )      {

							// too many errors

							return( ERROR );

						}
						zmSendAttentionString();
						continue;

					case TIMEOUT:

						if ( ++error_count >= 20 )      {

							// timeout

							return( ERROR );

						}
						fswrite( zm_msg3, 17, 22, Yellow+BlueBG );
						continue;

					case GOTCRCW:

						error_count = 0;
						fwrite( zmBuffer, 1, Rxcount, zmflfp );
						rxbytes += Rxcount;
						zmPackLongIntoHeader( rxbytes );
						zmSendHexHeader( 4, ZACK, transmitted_header );
						zmSendChar( XON );
						DisplayZMThruPut( &rxbytes );
						if ( file_length > 0L )
							XferUpdateProgressBar( &file_length, &rxbytes );
						sprintf( TempBuf, "%lu", ++zmblknum );
						fswrite( TempBuf, 13, 22, Yellow+BlueBG );
						goto nxthdr;

					case GOTCRCQ:

						error_count = 0;
						fwrite( zmBuffer, 1, Rxcount, zmflfp );
						rxbytes += Rxcount;
						zmPackLongIntoHeader( rxbytes );
						zmSendHexHeader( 4, ZACK, transmitted_header );
						DisplayZMThruPut( &rxbytes);
						if ( file_length > 0L )
							XferUpdateProgressBar( &file_length, &rxbytes );
						sprintf( TempBuf, "%lu", ++zmblknum );
						fswrite( TempBuf, 13, 22, Yellow+BlueBG );
						goto moredata;

					case GOTCRCG:

						error_count = 0;
						fwrite( zmBuffer, 1, Rxcount, zmflfp );
						rxbytes += Rxcount;
						DisplayZMThruPut( &rxbytes);
						if ( file_length > 0L )
							XferUpdateProgressBar( &file_length, &rxbytes );
						sprintf( TempBuf, "%lu", ++zmblknum );
						fswrite( TempBuf, 13, 22, Yellow+BlueBG );
						goto moredata;

					case GOTCRCE:

						error_count = 0;
						fwrite( zmBuffer, 1, Rxcount, zmflfp );
						rxbytes += Rxcount;
						DisplayZMThruPut( &rxbytes );
						if ( file_length > 0L )
							XferUpdateProgressBar( &file_length, &rxbytes );
						sprintf( TempBuf, "%lu", ++zmblknum );
						fswrite( TempBuf, 13, 22, Yellow+BlueBG );
						goto nxthdr;
				}
		}
	}
}



/*-----------------------------------------------------------------------

	Entry point for Zmodem Send file(s)

 -----------------------------------------------------------------------*/


int zmSend( void )
{

	int             i;
	int             ffdone;
	int             zwccntr;
	char            drv[MAXDRIVE];
	char            dir[MAXDIR];
	char            zfname[MAXFILE];
	char            zfext[MAXEXT];

	struct  ffblk   fileinfo;

	if ( signal( SIGTERM, zmsigjmp ) == SIG_ERR )   {
		fprintf(stderr,"zmsigjmp() - fatal signal error\n");
		return( ERROR );
	}

	DisplayXferWndw( "S e n d", 1 );
	fswrite( "Zmodem (Batch)", 10, 22, Yellow+BlueBG );

	// Allocate room for wildcard names.

/*      for ( i = 0; i < 50; i++ )      {
		if ( ( WCNames[i] = ( char * )malloc( 16 * sizeof( char ) ) ) == NULL ) {
			return( ERROR );
		}
	}*/
	zmPackLongIntoHeader( 0L );
	zmSendHexHeader( 4, ZRQINIT, transmitted_header );
	zmGetRinitHeader();
	byte_count = -1;

	zwccntr = 0;
	flcnt = 0;

	while( fileslefttodo < filestodo )      {
		if ( zwccntr == 0 )     {
/*                      for ( i = 0; i < 50; i++ )
				setstrng( WCNames[i], '\0', 13 );*/
			for ( i = 0; i < flcnt; i++ )   {
				if (WCNames[i])
					free(WCNames[i]);
			}
			flcnt = 0;
			strcpy( zmPath, filestoxfer[fileslefttodo++] );
			fnsplit( zmPath, drv, dir, zfname, zfext );
			ffdone = findfirst( zmPath, &fileinfo, FA_ARCH );
			while( !ffdone )        {
				if  ( zwccntr > 999 )
					break;
				if (( WCNames[zwccntr] = (char *)malloc(13*sizeof(char))) == NULL )     {
					break;
				}
				strcpy( WCNames[zwccntr], fileinfo.ff_name );
				ffdone = findnext( &fileinfo );
				zwccntr++;
				flcnt++;
			}
		}
		if ( zwccntr == 0 )
			break;
		sprintf( zmPath, "%s%s%s\0", drv, dir, WCNames[--zwccntr] );
		if ( zmSendSingleFile( zmPath ) == ERROR )      {
			for ( i = 0; i < flcnt; i++ )
				if ( WCNames[i] )
					free( WCNames[i] );
			CloseWindow();
			return( ERROR );
		}
//              fclose( zmflfp );
	}
	zmSendZFIN();
	for ( i = 0; i < flcnt; i++ )
		if ( WCNames[i] )
			free( WCNames[i] );
	CloseWindow();
	return( OK );
}


int zmSendSingleFile( char *zPath )
{

	int             c;
	int             i;
	int             length;
	register unsigned long  crc32val;
	unsigned long   zmfdateout;
	long            lastcrcq;

	char            drv[MAXDRIVE];
	char            dir[MAXDIR];
	char            zfname[MAXFILE];
	char            zfext[MAXEXT];
	char            ZMFileDate[16];
	struct          ffblk fileinfo;
	FILE            *dbfp;

	lastcrcq = -1;
//      crc32val = 0xFFFFFFFFL;
//      zmblknum = 0L;
//      zmtotalbytes = 0L;
	fnsplit( zPath, drv, dir, zfname, zfext );
	if ( (zmflfp = fopen( zPath, "rb" ) ) == NULL ) {

		// Error

		return( OK );

	}
	file_at_eof = 0;
	fseek( zmflfp, 0L, SEEK_END );
	file_length = ftell( zmflfp );
	fseek( zmflfp, 0L, SEEK_SET );
	setstrng( zmBuffer, '\0', 1024 );
	getftime( fileno( zmflfp ), &zmfdtinfo );
	zmtime.ti_sec  = zmfdtinfo.ft_tsec << 1;
	zmtime.ti_min  = zmfdtinfo.ft_min;
	zmtime.ti_hour = zmfdtinfo.ft_hour;
	zmdate.da_day  = zmfdtinfo.ft_day;
	zmdate.da_mon  = zmfdtinfo.ft_month;
	zmdate.da_year = zmfdtinfo.ft_year + 1980;
	sprintf( ZMFileDate, "%02d-%02d-%02d", zmdate.da_mon,
					   zmdate.da_day,
					   zmdate.da_year - 1900 );
	zmfdateout = ( unsigned long )dostounix( &zmdate, &zmtime );
	length = sprintf( zmBuffer, "%s%s%c%lu %lo %o", zfname, zfext, 0,
				(unsigned long)file_length, zmfdateout, 0x1ff );

	fswrite( zPath, 9, 22, Yellow+BlueBG );
	fswrite( ZMFileDate, 11, 62, Yellow+BlueBG );
//      findfirst( zPath, &fileinfo, FA_ARCH );
	sprintf( TempBuf, "%lu", (unsigned long)file_length );
	fswrite( TempBuf, 10, 62, Yellow+BlueBG );

	fswrite( "                         ", 17, 22, Yellow+BlueBG );
	sprintf( TempBuf, "Sending %s\0", zFrameTypes[4+ZFILE] );
	fswrite( TempBuf, 17, 22, Yellow+BlueBG );

/*      dbfp = fopen( "Zmodem.dbg", "wb" );
	for ( i = 0; i < 1024; i++ )    {
		fputc( zmBuffer[i], dbfp );
	}
	fclose( dbfp );*/

	for ( ; ; )     {
		zmPackLongIntoHeader( 0L );
		zmSendBinaryHeader( 4, ZFILE, transmitted_header );
		zmSendDataFrame( zmBuffer, length, ZCRCW );
again:
		c = zmReadHeader( received_header );
		switch( c )     {

			case ZRINIT:

//                              while( ( c = zmReadChar( 5L ) ) > 0 )
//                                      if ( c == ZPAD )
						goto again;

//                      default:

//                              continue;

			case ZCAN:
			case ZABORT:
			case TIMEOUT:
			case ZFIN:

				return( ERROR );

			case ZCRC:

				if ( received_file_position != lastcrcq )       {
					crc32val = 0xFFFFFFFFL;
					lastcrcq = received_file_position;
					fseek( zmflfp, 0L, SEEK_SET );
					while( ( ( c = getc( zmflfp ) ) != EOF ) &&
						--lastcrcq )
						crc32val = Crc32( c, crc32val );
					crc32val = ~crc32val;
					fseek( zmflfp, 0L, SEEK_SET );
					lastcrcq = received_file_position;
				}
				zmPackLongIntoHeader( crc32val );
				zmSendBinaryHeader( 4, ZCRC, transmitted_header );
				goto again;

			case ZSKIP:

				fclose( zmflfp );
				return( OK );

			case ZRPOS:

				if ( fseek( zmflfp, received_file_position, SEEK_SET ) )
					return( ERROR );
				last_sync_position = ( byte_count =
					  transmitted_file_position =
					  last_reported_position =
					  received_file_position ) -1;
				return( zmSendFileContents() );

			case ERROR:
			default:
				continue;
		}
	}
}


int zmSendFileContents( void )
{

	int             c;
	int             e;
	size_t          n;
	int             junkcount;
	int             newcnt;
	long            txbytes;

	junkcount = 0;
	txbytes = 0L;
	zmblknum = 1L;
	time( &ztickstart );

start_read:

	newcnt = receiver_buffer_length;
	zmPackLongIntoHeader( transmitted_file_position );
	fswrite( "                                    ", 17, 22, Yellow+BlueBG );
	fswrite( ym_msg3, 17, 22, Yellow+BlueBG );
	zmSendBinaryHeader( 4, ZDATA, transmitted_header );
	sprintf( buff, "%u    \0", zmblksize );
	fswrite( buff, 14, 22, Yellow+BlueBG );
	sprintf( buff, "%lu   \0", (unsigned long) txbytes);
	fswrite( buff, 13, 62, Yellow+BlueBG );


	do      {
//              zmblknum += 1L;
		sprintf( buff, "%lu    \0", zmblknum );
		fswrite( buff, 13, 22, Yellow+BlueBG );
		n = fread( (void *)zmBuffer, (size_t)1, (size_t)1024, zmflfp );
		if ( n < 1024 )
//                      file_at_eof = 1;
//              if ( file_at_eof )
			e = ZCRCW;
		else
		if ( junkcount > 3 )
			e = ZCRCW;
		else
		if ( byte_count == last_sync_position )
			e = ZCRCW;
		else
		if ( receiver_buffer_length && ( newcnt -= n ) <= 0 )
			e = ZCRCW;
		else
			e = ZCRCG;
		zmSendDataFrame( zmBuffer, n, e );
		byte_count = transmitted_file_position += n;
		txbytes = transmitted_file_position + n;
		DisplayZMThruPut( &txbytes );
		if ( file_length > 0L )
			XferUpdateProgressBar( &file_length, &txbytes );
		if ( e == ZCRCW )
			goto waitack;
		while( RxSpaceUsed() )  {
			switch( zmReadChar( 5L ) )      {

				case CAN:
				case ZPAD:

					c = zmSyncWithReceiver( 1 );
					if ( c == ZACK )
						break;
					zmSendDataFrame( zmBuffer, 0, ZCRCE );
					goto gotack;

				case XOFF:
				case XOFF | 0x80:

					zmReadChar( 10L );

				default:

					junkcount++;
			}
		}
		zmblknum += 1L;
//      } while( !file_at_eof );
	} while( n == 1024 );

	for ( ; ; )     {
		zmPackLongIntoHeader( transmitted_file_position );
		fswrite( "                         ", 17, 22, Yellow+BlueBG );
		sprintf( TempBuf, "Sending %s\0", zFrameTypes[4+ZEOF] );
		fswrite( TempBuf, 17, 22, Yellow+BlueBG );
		zmSendBinaryHeader( 4, ZEOF, transmitted_header );
		switch( zmSyncWithReceiver( 0 ) )       {

			case ZACK:

				fclose( zmflfp );
				return( OK );
//                              continue;

			case ZRPOS:
//                              fswrite( "                         ", 17, 22, Yellow+BlueBG );
				fswrite( ym_msg6, 17, 22, Yellow+BlueBG );
				goto start_read;

			case ZRINIT:

//                              fclose( zmflfp );
				return( OK );

			case ZSKIP:

				fclose( zmflfp );
				return( c );

			default:

				fclose( zmflfp );
				return( ERROR );
		}
	}

waitack:

	junkcount = 0;
	c = zmSyncWithReceiver( 0 );

gotack:

	switch( c )     {

		default:
		case ZCAN:

			fclose( zmflfp );
			return( ERROR );

		case ZSKIP:

			fclose( zmflfp );
			return( c );

		case ZACK:

			break;

		case ZRPOS:

			fswrite( ym_msg6, 17, 22, Yellow+BlueBG );
			break;

		case ZRINIT:

//                      fclose( zmflfp );
			return( OK );

	}

	while( RxSpaceUsed() )  {

		switch( zmReadChar( 5L ) )      {

			case CAN:
			case ZPAD:

				c = zmSyncWithReceiver( 1 );
				goto gotack;

			case XOFF:
			case XOFF | 0x80:

				zmReadChar( 10L );
		}
	}
	goto start_read;
}




void zmSendBinaryHeader( int length, int type, char *header )
{

	int             i;
	register unsigned long  crc32val;
	register unsigned short crc16val;

	crc32val = 0xFFFFFFFFL;
	crc16val = 0;
	zmSendChar( ZPAD );
	zmSendChar( ZDLE );
	if ( receiver_wants_crc32 )     {
		zmSendChar( ZBIN32 );
		zmSendEncodedChar( type );
		crc32val = Crc32( type, crc32val );     // update crc
		for ( i = 0; i < length; i ++ ) {
			crc32val = Crc32( 0xff & header[ i ], crc32val );
			zmSendEncodedChar( header[ i ] );
		}
		crc32val = ~crc32val;
		for ( i = 0; i < 4; i++ )       {
			zmSendEncodedChar( (int) crc32val );
			crc32val >>= 8;
		}
	}
	else    {
		zmSendChar( ZBIN );
		zmSendEncodedChar( type );
		crc16val = Crc16( crc16val, type );
		for ( i = 0; i < length; i ++ ) {
			zmSendEncodedChar( header[ i ] );
			crc16val = Crc16( crc16val, header[ i ] & 0xff );
		}
		crc16val = Crc16( crc16val, 0 );
		crc16val = Crc16( crc16val, 0 );
		zmSendEncodedChar( crc16val >> 8 );
		zmSendEncodedChar( crc16val );
	}
}




void zmSendHexHeader( int len, int type, char *header )
{

	int                             n;
	register unsigned short         crc16val;


	crc16val = 0;

	// display status

//      fprintf( stderr,"zmSendHexHeader: %d %s %lx\n", len,

//                      zFrameTypes[ type + 4 ], zmUnpackHeaderIntoLong( header ) );
	fswrite( "                         ", 17, 22, Yellow+BlueBG );
	sprintf( TempBuf, "Sending %s\0", zFrameTypes[4+type] );
	fswrite( TempBuf, 17, 22, Yellow+BlueBG );

	zmSendChar( ZPAD );
	zmSendChar( ZPAD );
	zmSendChar( ZDLE );
	zmSendChar( ZHEX );
	zmSendHexEncodedChar( type );
	crc16val = Crc16( crc16val, type );
	for ( n = 0; n < len; n++ )     {
		zmSendHexEncodedChar( header[ n ] );
		crc16val = Crc16( crc16val, header[ n ] & 0xff );
	}
	crc16val = Crc16( crc16val, 0 );
	crc16val = Crc16( crc16val, 0 );
	zmSendHexEncodedChar( crc16val >> 8 );
	zmSendHexEncodedChar( crc16val );
	zmSendChar( CR );
	zmSendChar( LF | 0x80 );
	if ( type != ZFIN && type != ZACK )
		zmSendChar( XON );
}



int zmReadHeader( char * header )
{

	int             c;
	int             n;
	int             cancount;

	n = 1400;
	n += ( speed > 19200L ) ? 19200 : (int)speed;

startover:

	cancount = 0;

again:

	switch( c = zmReadChar( 10L ) ) {

		case TIMEOUT:

			goto finished;

		case CAN:

gotcan:

			if ( ++cancount >= 5 )  {
				c = ZCAN;
				goto finished;
			}
			switch( c = zmReadChar( 10L ) )         {

				case TIMEOUT:

					goto again;

				case ZCRCW:

					switch( zmReadChar( 10L ) )     {

						case TIMEOUT:

							c = ERROR;
							goto finished;

						default:

							goto agn2;

					}

				default:

					break;

				case CAN:

					if ( ++cancount >= 5 )  {
						c = ZCAN;
						goto finished;
					}
					goto again;
			}
		default:

agn2:
			if ( --n == 0 ) {
				c = GARBAGE_COUNT;
				goto finished;
			}
			goto startover;

		case ZPAD | 0x80: // this is what we want
		case ZPAD:

			break;
	}
	cancount = 0;
splat:
	switch( c = zmReadUnencodedByte() )     {

		case ZPAD:

			goto splat;

		case TIMEOUT:

			goto finished;

		default:

			goto agn2;

		case ZDLE:      // This is what we want

			break;
	}
	c = zmReadUnencodedByte();
	switch( c )     {

		case ZBIN32:

			current_frame_uses_crc32 = 1;
			c = zmReadBinaryHeaderCRC32( header );
			break;

		case TIMEOUT:

			goto finished;

		case ZBIN:

			current_frame_uses_crc32 = 0;
			c = zmReadBinaryHeaderCRC16( header );
			break;

		case ZHEX:

			current_frame_uses_crc32 = 0;
			c = zmReadHexHeaderCRC16( header );
			break;

		case CAN:

			goto gotcan;

		default:

			goto agn2;

	}
	received_file_position = header[ ZP3 ] & 0xff;
	received_file_position <<= 8;
	received_file_position += header[ ZP2 ] & 0xff;
	received_file_position <<= 8;
	received_file_position += header[ ZP1 ] & 0xff;
	received_file_position <<= 8;
	received_file_position += header[ ZP0 ] & 0xff;

finished:

	switch( c )     {

		case GOTCAN:

			c = ZCAN;

		case ZNAK:
		case ZCAN:
		case ERROR:
		case TIMEOUT:
		case GARBAGE_COUNT:

			sprintf( TempBuf, "zmReadHeader: Got %s", zFrameTypes[c + 4] );
			fswrite( TempBuf, 17, 22, Yellow+BlueBG );

		default:

			if ( c >= -4 && c <= 22 )       {

				// debugging frame type, file pos

				sprintf( TempBuf, "zmReadHeader1: %s %lx",
					zFrameTypes[c+4], received_file_position );
				fswrite(TempBuf, 17, 22, Yellow+BlueBG );
			}
			else    {

				// debugging file pos

				sprintf( TempBuf, "zmReadHeader2: %d %lx", c,
					received_file_position );
				fswrite(TempBuf, 17, 22, Yellow+BlueBG );
			}
	}
	return( c );
}





int zmReadBinaryHeaderCRC16( char *header )
{

	int             c;
	int             i;
	register unsigned short         crc16val = 0;
	int             header_type;


	if ( ( c = zmReadEncodedByte() ) & ~0xff )
		return( c );
	header_type = c;
	crc16val = Crc16( crc16val, c );
	for ( i = 0; i < 4; i++ )       {
		if ( ( c = zmReadEncodedByte() ) & ~0xff )
			return( c );
		crc16val = Crc16( crc16val, c );
		header[ i ] = ( char ) c;
	}
	if ( ( c = zmReadEncodedByte() ) & ~0xff )
		return( c );
	crc16val = Crc16( crc16val, c );
	if ( ( c = zmReadEncodedByte() ) & ~0xff )
		return( c );
	crc16val = Crc16( crc16val, c );
	if ( crc16val & 0xFFFF )        {

		// Bad CRC

//              fprintf( stderr, "zmReadBinaryHeaderCRC16: Bad CRC\n" );

		return( ERROR );

	}
	return( header_type );
}


int zmReadBinaryHeaderCRC32( char *header )
{

	int                     c;
	int                     i;
	register unsigned long  crc32val;
	int                     header_type;


	crc32val = 0xFFFFFFFFL;
	if ( ( c = zmReadEncodedByte() ) & ~0xff )
		return( c );
	header_type = c;
	crc32val = Crc32( c, crc32val );
	for ( i = 0; i < 4; i++ )       {
		if ( ( c = zmReadEncodedByte() ) & ~0xff )
			return( c );
		crc32val = Crc32( c, crc32val );
		header[ i ] = (char) c;
	}
	for ( i = 0; i < 4; i++ )       {
		if ( ( c = zmReadEncodedByte() ) & ~0xff )
			return( c );
		crc32val = Crc32( c, crc32val );
	}
	if ( crc32val != 0xDEBB20E3L )  {

		// CRC error

//              fprintf( stderr, "zmReadBinaryHeaderCRC32: Bad CRC\n" );

		return( ERROR );

	}
	return( header_type );
}


int zmReadHexHeaderCRC16( char *header )
{

	int             c;
	int             i;
	int             header_type;
	unsigned short  crc16val;


	crc16val = 0;
	if ( ( c = zmReadHexByte() ) < 0 )
		return( c );
	header_type = c;
	crc16val = Crc16( crc16val, c );
	for ( i = 0; i < 4; i++ )       {
		if ( ( c = zmReadHexByte() ) < 0 )
			return( c );
		crc16val = Crc16( crc16val, c );
		header[ i ] = (char) c;
	}
	if ( ( c = zmReadHexByte() ) < 0 )
		return( c );
	crc16val = Crc16( crc16val, c );
	if ( ( c = zmReadHexByte() ) < 0 )
		return( c );
	crc16val = Crc16( crc16val, c );
	if ( crc16val & 0xFFFF )        {

		// Bad crc

//              fprintf( stderr, "zmReadHexHeaderCRC16: Bad CRC\n" );
		return( ERROR );
	}
	switch( c = zmReadChar( 5L ) )  {

		case CR:
		case CR | 0x80:

			zmReadChar( 3L );

	}
	return( header_type );
}


int zmReadDataFrame( char *buffer, int length )
{
	if ( current_frame_uses_crc32 )
		return( zmReadDataFrameCRC32( buffer, length ) );
	else
		return( zmReadDataFrameCRC16( buffer, length ) );
}


int zmReadDataFrameCRC32( char *buffer, int length )
{

	int                     c;
	int                     d;
	register unsigned long  crc32val;
	char                    *end;


	crc32val = 0xFFFFFFFFL;
	Rxcount = 0;
	end = buffer + length;
	while ( buffer <= end ) {
		if ( ( c = zmReadEncodedByte() ) & ~0xff )      {

crcfoo:

			switch( c )     {

				case GOTCRCE:
				case GOTCRCG:
				case GOTCRCQ:
				case GOTCRCW:

					d = c;
					c &= 0xff;
					crc32val = Crc32( c, crc32val );
					if ( ( c = zmReadEncodedByte() ) & ~0xff )
						goto crcfoo;
					crc32val = Crc32( c, crc32val );
					if ( ( c = zmReadEncodedByte() ) & ~0xff )
						goto crcfoo;
					crc32val = Crc32( c, crc32val );
					if ( ( c = zmReadEncodedByte() ) & ~0xff )
						goto crcfoo;
					crc32val = Crc32( c, crc32val );
					if ( ( c = zmReadEncodedByte() ) & ~0xff )
						goto crcfoo;
					crc32val = Crc32( c, crc32val );
					if ( crc32val != 0xDEBB20E3L )  {

						// CRC error

						return( ERROR );

					}
					Rxcount = (int) ( length - ( end - buffer ) );

					// display error in frame

//                                      fprintf( stderr, "zmReadDataFrameCRC32: %d %s \n",
//                                                      Rxcount, Zendnames[ d - GOTCRCE & 3 ] );
					zmtotalbytes += Rxcount;
					return( d );

				case GOTCAN:

					// Display Sender Cancelled

					return( ZCAN );

				case TIMEOUT:

					// display timeout error

//                                      fprintf( stderr, "zmReadDataFrameCRC32: TIMEOUT \n" );
					return( c );

				default:

					// error: garbled data subpacket

//                                      fprintf( stderr, "zmReadDataFrameCRC32: Garbled data subpacket \n" );
					return( c );
			}
		}
		*buffer++ = (char) c;
		crc32val = Crc32( c, crc32val );
	}

	// display error: subpacket too long

//      fprintf( stderr,"zmReadDataFrameCRC32: Data subpacket too long\n" );

	return( ERROR );

}


int zmReadDataFrameCRC16( char *buffer, int length )
{

	int                     c;
	int                     d;
	register unsigned short crc16val;
	char                    *end;


	crc16val = 0;
	Rxcount = 0;
	end = buffer + length;
	while ( buffer <= end ) {
		if ( ( c = zmReadEncodedByte() ) & ~0xff )      {

crcfoo:

			switch( c )     {

				case GOTCRCE:
				case GOTCRCG:
				case GOTCRCQ:
				case GOTCRCW:

					crc16val = Crc16( crc16val, ( d = c ) & 0xff );
					if ( ( c = zmReadEncodedByte() ) & ~0xff )
						goto crcfoo;
					crc16val = Crc16( crc16val, c );
					if ( ( c = zmReadEncodedByte() ) & ~0xff )
						goto crcfoo;
					crc16val = Crc16( crc16val, c );
					if ( crc16val & 0xFFFF )        {

						// crc error

						return( ERROR );

					}
					Rxcount = (int) ( length - ( end - buffer ) );

					// display error dataframe

//                                      fprintf( stderr, "zmReadDataFrameCRC16: %d %s \n",
//                                                      Rxcount, Zendnames[ d - GOTCRCE & 3 ] );
					zmtotalbytes += Rxcount;
					return( d );

				case GOTCAN:

					// display sender aborted

//                                      fprintf( stderr, "zmReadDataFrameCRC16: Sender Cancelled \n" );
					return( ZCAN );

				case TIMEOUT:

					// display timeout error

//                                      fprintf( stderr, "zmReadDataFrameCRC16: TIMEOUT \n" );
					return( c );

				default:

					// display garbled data

//                                      fprintf( stderr, "zmReadDataFrameCRC16: Garbled data subpacket \n" );
					return( c );
			}
		}
		*buffer++ = (char) c;
		crc16val = Crc16( crc16val, c );
	}

	// display error subpacket too long

//      fprintf( stderr, "zmReadDataFrameCRC16: Data subpacket too long \n" );
	return( ERROR );
}


void zmSendAttentionString( void )
{

	int             i;
	int             c;
	long    timer;
	char    *s;

	s = attention_string;
	while ( *s ) {
		switch ( *s ) {

			case 0xde:

				sleep( 1 );
				s++;
				continue;

			case 0xdd:

				zmSendBrk();
				s++;
				continue;

			default:

				zmSendChar( *s );
				s++;
		}
	}
}


void zmAckZFIN( void )
{

	int             n;

	// Status "AckZFIN"

	zmPackLongIntoHeader( 0L );
	for ( n = 0; n < 4; n++ )       {
		flushinput();
		zmSendHexHeader( 4, ZFIN, transmitted_header );
		switch( zmReadChar( 10L ) )     {

			case 'O':

				zmReadChar( 5L );

				// ststus display "AckZFIN Complete"

//                              fprintf( stderr, "zmAckZFIN: AckZFIN complete \n" );
				return;

			case TIMEOUT:
			default:

				break;
		}
	}
}



int zmOpenInputFile( char *data )
{

	char    *fstr;

	int             nfields;


	if ( *PTSetup[0].PTPaths )      {
		if ( PTSetup[0].PTPaths[strlen( PTSetup[0].PTPaths ) - 1] == '\\' )
			sprintf( zmPath, "%s%s", PTSetup[0].PTPaths, data );
		else
			sprintf( zmPath, "%s\\%s", PTSetup[0].PTPaths, data );
	}
	else    {
		strcpy( zmPath, data );
	}
	nfields = sscanf( data + strlen( data ) + 1, "%ld %lo", &file_length,
						&zmfdate );
	if ( nfields < 1 )
		file_length = -1L;
	if ( nfields < 2 )
		zmfdate = 0L;

	// Display File size

	if ( file_length > 0L ) {
		sprintf( TempBuf, "%lu", (unsigned long)file_length );
		fswrite( TempBuf, 10, 62, Yellow+BlueBG );
	}
	else
		fswrite( "n/a", 10, 62, Yellow+BlueBG );

	// Display file date

	if ( zmfdate )  {
		unixtodos( ( long ) zmfdate, &zmdate, &zmtime );
		sprintf( zmFileDate, "%02d-%02d-%02d \0", zmdate.da_mon,
			 zmdate.da_day,
			 zmdate.da_year - 1900 );
		fswrite( zmFileDate, 11, 62, Yellow+BlueBG );
	}
	else
		fswrite( "n/a", 11, 62, Yellow+BlueBG );
	if ( ( zmflfp = fopen( zmPath, "wb" ) ) == NULL )
		return( ERROR );
	fstr = stupr( zmPath );
	fswrite( fstr, 9, 22, Yellow+BlueBG );
//        setvbuf( zmflfp, NULL, _IOFBF, 1024*8 );
	return( OK );
}


void zmPackLongIntoHeader( long header_data )
{

	transmitted_header[ ZP0 ] = (char) header_data;
	transmitted_header[ ZP1 ] = (char) header_data >> 8;
	transmitted_header[ ZP2 ] = (char) header_data >> 16;
	transmitted_header[ ZP3 ] = (char) header_data >> 24;
}



long zmUnpackHeaderIntoLong( char *header )
{

	long            l;

	l = header[ ZP3 ] & 0xff;
	l = ( l << 8 ) | ( header[ ZP2 ] & 0xff );
	l = ( l << 8 ) | ( header[ ZP1 ] & 0xff );
	l = ( l << 8 ) | ( header[ ZP0 ] & 0xff );
	return( l );
}


void zmSendHexEncodedChar( int c )
{

	static char *digits = "0123456789abcdef";

	zmSendChar( digits[ ( c & 0xF0 ) >> 4 ] );
	zmSendChar( digits[ c & 0xF ] );
}


void zmSendEncodedChar( int c )
{

	if ( c & 0x60 )
		zmSendChar( last_char_sent = c );
	else    {
		switch( c &= 0xff )     {

			case CR:
			case CR | 0x80:

				if ( ( last_char_sent & 0x7f ) != '@' ) {
					zmSendChar( last_char_sent = c );
					break;
				}

			case ZDLE:
			case DLE:
			case XON:
			case XOFF:
			case DLE | 0x80:
			case XON | 0x80:
			case XOFF | 0x80:

				zmSendChar( ZDLE );
				c ^= 0x40;
				zmSendChar( last_char_sent = c );
				break;

			default:

				zmSendChar( last_char_sent = c );
		}
	}
}


// Read a byte, taking into account escape sequences, and checking
// for 5*CAN abort sequence.


int zmReadEncodedByte( void )
{
	int             c;

	for ( ; ; )     {
		c = zmReadChar( 10L );
		if ( c == ZDLE )
			break;
		switch( c )     {

			case XON:
			case XON | 0x80:
			case XOFF:
			case XOFF | 0x80:
				break;

			default:

				return( c );
		}
	}
	for ( ; ; )     {
		if ( ( c = zmReadChar( 10L ) ) < 0 )
			return( c );
		if ( c == CAN && ( c = zmReadChar( 10L ) ) < 0 )
			return( c );
		if ( c == CAN && ( c = zmReadChar( 10L ) ) < 0 )
			return( c );
		if ( c == CAN && ( c = zmReadChar( 10L ) ) < 0 )
			return( c );
		switch( c )     {

			case CAN:

				return( GOTCAN );

			case ZCRCE:
			case ZCRCG:
			case ZCRCQ:
			case ZCRCW:

				return( c | GOTFLAG );

			case ZRUB0:

				return( 0x7f );

			case ZRUB1:

				return( 0xff );

			case XOFF:
			case XOFF | 0x80:
			case XON:
			case XON | 0x80:

				break;

			default:

				if ( ( c & 0x60 ) == 0x40 )
					return( c ^ 0x40 );
				else
					return( ERROR );
		}
	}
}


int zmReadUnencodedByte( void )
{

	int             c;


	for ( ; ; )     {
		if ( ( c = zmReadChar( 10L ) ) < 0 )
			return( c );
		switch( c &= 0x7f )     {
			case XON:
			case XOFF:

				continue;

			default:

				return( c );
		}
	}
}


int zmReadHexByte( void )
{

	int             c;
	int             n;


	if ( ( c = zmReadUnencodedByte() ) < 0 )
		return( c );
	n = c - '0';
	if ( n > 9 )
		n -= ( 'a' - ':' );
	if ( n & ~0xF )
		return( ERROR );
	if ( ( c = zmReadUnencodedByte() ) < 0 )
		return( c );
	c -= '0';
	if ( c > 9 )
		c -= ( 'a' - ':' );
	if ( c & ~0xF )
		return( ERROR );
	c += ( n << 4 );
	return( c );
}



int zmGetRinitHeader( void )
{
	int             i;

	for ( i = 0; i < 10; i++ )      {
		switch( zmReadHeader( received_header ) )       {

			case ZCHALLENGE:

				zmPackLongIntoHeader( received_file_position );
				zmSendHexHeader( 4, ZACK, transmitted_header );
				continue;

			case ZCOMMAND:

				zmPackLongIntoHeader( 0L );
				zmSendHexHeader( 4, ZRQINIT, transmitted_header );
				continue;

			case ZRINIT:

				receiver_wants_crc32 = received_header[ ZF0 ] & CANFC32;
				receiver_buffer_length =
						( received_header[ ZP0 ] & 0xff ) +
						( ( received_header[ ZP1 ] & 0xff ) << 8 );
				return( OK );

			case ZCAN:
			case TIMEOUT:

				return( ERROR );

			case ZRQINIT:

				if ( received_header[ ZF0 ] == ZCOMMAND )
					continue;

			default:

				zmSendHexHeader( 4, ZNAK, transmitted_header );
				continue;
		}
	}
	return( ERROR );
}

// This routine sends a data subpacket, which is used here to send
// file names and file data.


void zmSendDataFrame( char *buffer, int length, int frameend )
{
	int             i;
	register unsigned long  crc32val;
	register unsigned short crc16val;


	crc32val = 0xFFFFFFFFL;
	crc16val = 0;

	// Display status

	if ( receiver_wants_crc32 )     {
		for ( i = 0; i < length; i++ )  {
			zmSendEncodedChar( buffer[ i ] );
			crc32val = Crc32( buffer[ i ] & 0xff, crc32val );
		}
		zmSendChar( ZDLE );
		zmSendChar( frameend );
		crc32val = Crc32( frameend, crc32val );
		crc32val = ~crc32val;
		for ( i = 0; i < 4; i++ )       {
			zmSendEncodedChar( (int) crc32val );
			crc32val >>= 8;
		}
	}
	else    {
		for ( i = 0; i < length; i++ )  {
			zmSendEncodedChar( buffer[ i ] );
			crc16val = Crc16( crc16val, buffer[ i ] & 0xff );
		}
		zmSendChar( ZDLE );
		zmSendChar( frameend );
		crc16val = Crc16( crc16val, frameend );
		crc16val = Crc16( crc16val, 0 );
		crc16val = Crc16( crc16val, 0 );
		zmSendEncodedChar( crc16val >> 8 );
		zmSendEncodedChar( crc16val );
	}
	if ( frameend == ZCRCW )
		zmSendChar( XON );
}


// The sender sends a ZFIN frame just before exiting


void zmSendZFIN( void )
{

	for ( ; ; )     {
		zmPackLongIntoHeader( 0L );
		zmSendHexHeader( 4, ZFIN, transmitted_header );
		switch( zmReadHeader( received_header ) )       {

			case ZFIN:

				zmSendChar( 'O' );
				zmSendChar( 'O' );

			case ZCAN:
			case TIMEOUT:

				return;
		}
	}
}


int zmSyncWithReceiver( int flag )
{

	int             c;


	for ( ; ; )     {
		c = zmReadHeader( received_header );
		switch( c )     {

			case ZCAN:

			case ZABORT:
			case ZFIN:
			case TIMEOUT:

				return( ERROR );

			case ZRPOS:

				if ( fseek( zmflfp, received_file_position, SEEK_SET ) )
					return( ERROR );
				file_at_eof = 0;
				byte_count = last_reported_position =
					transmitted_file_position =
					received_file_position;
				last_sync_position = received_file_position;
				return( c );

			case ZACK:

				last_reported_position = received_file_position;
				if ( flag || transmitted_file_position ==
						received_file_position )
					return( ZACK );
				continue;

			case ZRINIT:
			case ZSKIP:

				fclose( zmflfp );
				return( c );

			case ERROR:
			default:

				zmSendBinaryHeader( 4, ZNAK, transmitted_header );
				continue;
		}
	}
}



int zmReadChar( long timeout )
{
	int             c;

	if ( setjmp( zmenv ) )
		return( TIMEOUT );
	alarm( (unsigned int)timeout );
	c = char_waiting();
	alarm( 0 );

//      return( c < 0 ? TIMEOUT : c );
	return( c );
}


void zmSendChar( int c )
{
	while ( SerialOut( c ) == -1 );
}



void zmSendBrk( void )
{
	SendCommBreak();
}



void DisplayZMThruPut( long *xbytes)
{
	double          zmsecs;
	double          zmrate;
	double          eff;

	sprintf( buff, "%lu   \0", ( *xbytes ));
	fswrite( buff, 13, 62, Yellow+BlueBG );
	time( &zticknow );
	zmsecs = difftime(zticknow, ztickstart);
	if ( zmsecs < 1.0 )
		zmsecs = 1.0;
	zmrate = (double)( *xbytes ) / zmsecs;
	sprintf( buff, "%u     \0", (unsigned int)zmrate );
	fswrite( buff, 14, 62, Yellow+BlueBG );

/*      if ( actualbaud )       {                       // prevent divide by zero!
		eff = ( ymrate / ( double )( ( double )actualbaud / ( double )10.0 ) ) * ( double )100.0;
		sprintf( buff, "%5.1f\0", eff );
		fswrite( buff, 15, 62, Yellow+BlueBG );
	}
	else    */
	fswrite( "n/a", 15, 62, Yellow+BlueBG );
}





static void zmsigjmp( int sig )                 /* Timer interrupt handler */
{
	if ( sig == SIGTERM )   {

		alarm( 0 );
		if ( signal( SIGTERM, zmsigjmp ) == SIG_ERR )
			fprintf( stderr, "zmsigjmp() - signal error\n" );

		longjmp( zmenv, TRUE );
	}
}

