
/*

	sinstall.c		--- Install a serial number in PT.EXE

*/


#include <stdio.h>


void main( int argc, char *argv[] );
void Usage( void );

void main( int argc, char *argv[] )
{

	long			seek_pos = 0x2F5FE;		// Update if recompiled PT.EXE

	int				i;

	FILE			*fp;

	if ( argc < 2 )	{

		printf( "Invalid number of arguments.\n" );

		Usage();

		exit( 1 );
	}

	if ( strlen( argv[ 1 ] ) < 12 )	{

		printf( "Illegal argument length.\n" );

		Usage();

		exit( 2 );
	}
	if ( ( fp = fopen( "PT.EXE", "r+b" ) ) == NULL )	{

		printf( "Cant open input file\n" );

		exit( 3 );
	}

	printf( "Installing Program Serial Number.\n" );

	fseek( fp, 0L, SEEK_SET );

	fseek( fp, seek_pos, SEEK_SET );

	for ( i = 0; i < 12; i ++ )

		fputc( argv[ 1 ][ i ], fp );

	fclose( fp );

	printf( "Program Serial Number Installed OK.\n" );

	exit( 0 );
}



void Usage( void )
{

	printf( "\nUsage: sinstall {serial_number}\n\n" );

	printf( "Example: \n" );

	printf( "       sinstall 000000371849\n\n" );
}




