
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include "userhelp.h"
#include "pckeys.h"
#include "mouse.h"
#include "fsvlib.h"

extern unsigned int MouseRow;
extern unsigned int MouseCol;


/**********************************************************************/

void GiveUserHelp( char *HlpTag )
{
	int		i;
	int		ch;
	int		key;
	int		bytesin;
	int		HEXIT = FALSE;
	char 	HelpIdx[]={"IPCHELP.IDX"};
	char 	HelpTxt[]={"IPCHELP.TXT"};

	CurrentHPage = 1;
//	MakeWindow (3, 4, 20, 73, Blue+LightGrayBG, Blue+LightGrayBG, NoShadow,Frame2);
	ExplodeWindow (3, 4, 20, 75, Blue+LightGrayBG, Blue+LightGrayBG, NoShadow,Frame2);
	fswrite("[", 3, 6, Blue+LightGrayBG );
	fswriteM("", Blue+LightGrayBG );
	fswriteM( "]", Blue+LightGrayBG );
//	fswrite ("Help", 3, 6, LastAttr);
	fswrite ("Esc-Exit", 22, 6, LastAttr);
	if (!HLPOPEN)  {
		if ((HIdx = fopen (HelpIdx, "rb")) == NULL)  {
			fswriteC (HLPERR3, 11, 80, LastAttr);
			Beep (500);
			HLPOPEN=FALSE;
			delay (3000);
			CloseWindow ();
			return;
		}
		if ((HTxt = fopen (HelpTxt, "rb")) == NULL)  {
			fswriteC (HLPERR3, 11, 80, LastAttr);
			Beep (500);
			HLPOPEN=FALSE;
			delay (3000);
			CloseWindow ();
			return;
		}
		HLPOPEN=TRUE;
	}
	if (( fseek(HIdx, 0L, SEEK_SET)) != 0 )  {
		fswriteC (HLPERR1, 11, 80, LastAttr);
	}
	if (( fseek(HTxt, 0L, SEEK_SET)) != 0 )  {
		fswriteC (HLPERR2, 11, 80, LastAttr);
	}
	do	{
		bytesin = fread (&HIdxRec, sizeof (struct HlpIndx), 1, HIdx);
		if (feof (HIdx))
			return;
	} 	while (strcmp (HIdxRec.HTag, HlpTag) !=0);

	if ((fseek (HTxt, (HIdxRec.HRecPos*sizeof(struct HlpText)),
		SEEK_SET)) != 0)  {
		fswriteC (HLPERR2, 11, 80, LastAttr);
		return;
	}
	HelpTotLines=HIdxRec.HNumRecs;

/*  Compute number of help pages for this topic.  */

	if ( HelpTotLines > 15 )  {
		HelpPages = ( ( HelpTotLines / 15 ) + 1 );
	}
	else  {
		HelpPages = 1;
	}
	HRecsRead=0;
	if ( ( CurrentHPage * HelpMaxLines ) > HelpTotLines )  {
		HRecsToGo = ( HelpTotLines - ( ( CurrentHPage - 1 ) * HelpMaxLines ) );
	}
	else  {
		HRecsToGo=HelpMaxLines;
	}
	for ( i = 0; i < HRecsToGo; i++ )  {
		bytesin = fread( &HlpTxtRec, sizeof( struct HlpText ), 1, HTxt );
		fswrite ( HlpTxtRec.HTxtLine, ( 5 + i ), 6, LastAttr );
		HRecsRead += 1;
	}
	ShowPageAndSelection ();
	if ( ( HelpPos = ftell ( HTxt ) ) == -1L )  {
		fswriteC( HLPERR4, 11, 80, LastAttr );
		Beep( 500 );
		delay( 3000 );
		CloseWindow();
		return;
	}
	if ( MouseInstalled )
		Mshow();
	do 	{
		kbflush();
		switch ( WaitForEvent() )	{

			case CHAR_EVENT:

				ch = toupper( getch () );
				switch( ch )	{

					case ESCAPE:

						HEXIT = TRUE;
						break;

					case SPECIALKEY:

						key = getch();
						switch( key )	{

							case PGUP:

								if ( MouseInstalled )
									Mhide();
								PageHelpUp();
								if ( MouseInstalled )
									Mshow();
								break;

							case PGDN:

								if ( MouseInstalled )
									Mhide();
								PageHelpDown();
								if ( MouseInstalled )
									Mshow();
								break;

							default:

								Beep(500);
								break;
						}
						break;

					default:

						Beep(500);
						break;
				}
				break;

			case MOUSE1BUTTON:

				if ( ( MouseRow == 3 ) && ( MouseCol == 7 ) )
					HEXIT = TRUE;

				break;

/*			case MOUSE2BUTTON:
				HEXIT = TRUE;
				break;*/

			default:

				break;
		}
	} 	while( !HEXIT );

	if ( MouseInstalled )
		Mhide();
	CloseWindow ();
	return;
}

/*********************************************************************/

void PageHelpDown ()
{
	int	i;
	int     bytesin;

	if ( HelpPages == 1 )
		return;
	if ( CurrentHPage == HelpPages )
		return;
	fsfill (4, 5, 18, 71, ' ', Blue+LightGrayBG);
	CurrentHPage = (CurrentHPage + 1);
	if ((CurrentHPage*HelpMaxLines) > HelpTotLines)
		HRecsToGo=(HelpTotLines - ((CurrentHPage - 1) * HelpMaxLines));
	else
		HRecsToGo=HelpMaxLines;
	HRecsRead=0;
	for ( i = 0; i < HRecsToGo; i++ )  {
		bytesin = fread (&HlpTxtRec, sizeof(struct HlpText), 1, HTxt);
		fswrite (HlpTxtRec.HTxtLine, (5+i), 6, LastAttr);
		HRecsRead += 1;
	}
	if ((HelpPos = ftell (HTxt)) == -1L)  {
		fswriteC (HLPERR4, 11, 80, LastAttr);
		Beep (500);
		delay (3000);
		CloseWindow ();
		return;
	}
	ShowPageAndSelection ();
}

/**********************************************************************/

void PageHelpUp ()
{
	int	i;
	int	bytesin;

	if (HelpPages==1)
		return;
	if (CurrentHPage==1)
		return;
	fsfill (4, 5, 18, 71, ' ', Blue+LightGrayBG);
	CurrentHPage = (CurrentHPage - 1);
	HelpPos=HelpPos - ((HelpMaxLines+HRecsRead) * sizeof(struct HlpText));
	if ((fseek (HTxt, HelpPos, SEEK_SET)) != 0)  {
		fswriteC (HLPERR2, 11, 80, LastAttr);
		Beep (500);
		delay (3000);
		CloseWindow ();
		return;
	}
	HRecsRead=0;
	for ( i = 0; i < HelpMaxLines; i++ )  {
		bytesin = fread (&HlpTxtRec, sizeof (struct HlpText), 1, HTxt);
		fswrite (HlpTxtRec.HTxtLine, (5+i), 6, LastAttr);
		HRecsRead += 1;
	}
	if ((HelpPos=ftell (HTxt)) == -1L)  {
		fswriteC (HLPERR4, 11, 80, LastAttr);
		Beep (500);
		delay (3000);
		CloseWindow ();
		return;
	}
	ShowPageAndSelection ();
}

/**********************************************************************/

void ShowPageAndSelection ()
{
	itoa( CurrentHPage, TempNum, 10 );
	strcpy( buff, "Page " );
	strcat( buff, TempNum );
	fswrite( buff, 3, 65, LastAttr );
	if ( HelpPages == 1 )
		fswrite( "", 22, 65, LastAttr );
	else
	if ( CurrentHPage == 1 )
		fswrite( "PgDn", 22, 65, LastAttr );
	else
	if ( CurrentHPage == HelpPages )
		fswrite( "PgUp", 22, 65, LastAttr );
	else
		fswrite( "PgDn/PgUp", 22, 65, LastAttr );
}

