
/*
		---------------------------------------
					PowerTerm v0.01
		PowerTerm (c) 1992-93  Byron D Copeland
				  All Rights Reserved.
		---------------------------------------

*/


#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include "fsvlib.h"
#include "pckeys.h"
#include "vip7801.h"

#define 	mTTY 	  0x00
#define 	mVT52 	  0x01
#define 	mVT102 	  0x02
#define 	mANSI 	  0x03
#define		mAVATAR   0x04
#define		mTEK4107C 0x05
#define		mVIP7801  0x06

#define 	FALSE 	0
#define 	TRUE   	(!FALSE)

#define 	Vip7801Id     	"\033[y7801 HP  \003\0"              // Mode Ident String
#define 	Vip7801Id2     	"7801 HP  \003\0"              // Mode Ident String

extern char 	CURRPT[10];                // Response to ESC[?6n
extern char 	*buff;
extern int      VTc, VTr, VTa, VTwt, VTwb;
extern int      PrtFlag, fc;

extern int	NUMLOCK;

/*
	VIPMODE -	0 = CHAR
			1 = FORMS
			2 = TEXT
			3 = GRAPH
			4 = LOCAL
*/

extern int		INSMODE;
extern int		ECHOON;
extern int		ROLL;
extern int		VIPLOCAL;
extern int		VIPHIDE;
extern int		AUTOLF;
extern unsigned int	EmuMode;
extern unsigned int	OLDVMODE;

static int		TFlag = 0;
static int		TFlag1 = 0;
static int		TFp[10];
static int		SVTc = 0;
static int		SVTr = 0;
static int		SVTwt = 1;
static int		SVTwb = 24;
static unsigned int   	SVTa;
static unsigned char 	vipgchars[11] = { 218, 191, 192, 217, 194, 180,
					 195, 193, 196, 179, 197 };

static int 	       	lc, rw, cl, savch;

/*-----------------------------------------------------------------------
  The following is the VIP attribute reference table.  This table is
  set up during form display.

  Legend:

  Bit Positions:

	0 - 7  -	Attribute
	8 - 16 - 	Field Length

  Attribute Settings:

		0x00	// None
		0x01	// Alpha only
		0x02	// Blink
		0x03	// Digits Only
		0x04	// Entry Required
		0x05	// Fill Required
		0x06	// Hide
		0x07	// Inverse
		0x08	// Justify Right
		0x09	// Low Intenesity
		0x0A	// Modified Transmit
		0x0B	// Numeric Only
		0x0C	// Omit Print
		0x0D	// Protected Field
		0x0E	// Underline
		0x0F	// Restore Attribute
		0x10	// Do not EVER use
		0x11	// Transmit Always
		0x12	// Unprotected

	Example:

		VipAttrTab[ 1, 1 ] = 0x010A;

		The above assignment will assign row 1, column 1
		with a ALPHA ONLY field of 10 bytes long.

 -----------------------------------------------------------------------*/


static unsigned int VNONE  	= 0x0000;
static unsigned int VALPHA 	= 0x0100;
static unsigned int VBLINK 	= 0x0200;
static unsigned int VDIGIT 	= 0x0300;
static unsigned int VENTRY 	= 0x0400;
static unsigned int VFILL 		= 0x0500;
static unsigned int VHIDE 		= 0x0600;
static unsigned int VINVERSE 	= 0x0700;
static unsigned int VRIGHT 	= 0x0800;
static unsigned int VLOW 		= 0x0900;
static unsigned int VMODT 		= 0x0a00;
static unsigned int VNUMO	 	= 0x0b00;
static unsigned int VOMIT 		= 0x0c00;
static unsigned int VPROT	 	= 0x0d00;
static unsigned int VUNDERL 	= 0x0e00;
static unsigned int VRES 		= 0x0f00;
static unsigned int VNOT 		= 0x1000;
static unsigned int VTRANSA 	= 0x1100;
static unsigned int VUNPROT 	= 0x1200;


static unsigned int		VipAttrTab[24][80];
static int				VipAttrCnt[25];
static int		VipAPtr = 0;
static enum		VIPMODES { CHARMODE, FORMSMODE, TEXTMODE, GRAPHMODE };
static enum		VIPMODES VIPMODE = CHARMODE;

int			VIP_STS_LINE_IN_USE;		// Status line in use
int			VIP_TRR = FALSE;		// Transmit on RETURN
int			VIP_KBLOCKD = FALSE; 		// Keyboard locked flag
int			VIP_SP_SUPRES = FALSE;		// Space supress flag

/*-----------------------------------------------------------------------

  VIP78XX Messages that are displayed on the status line 25

 -----------------------------------------------------------------------*/

static char		*VipMsg00 =  {"                    \0"};
static char     *VipMsg01 =  {"READY               \0"};
static char		*VipMsg02 =  {"KEYBOARD LOCKED     \0"};
static char		*VipMsg03 =  {"LOCAL\0"};
static char     *VipMsg04 =  {"AUTO-LF\0"};
static char		*VipEmsg01 = {"ALPHA FIELD\0"};
static char		*VipEmsg02 = {"ALPHA/DIGIT FIELD\0"};
static char		*VipEmsg03 = {"ALPHA/NUMERIC FIELD\0"};
static char		*VipEmsg04 = {"ATTRIBUTE OVERFLOW\0"};
static char		*VipEmsg05 = {"BUFFER OVERFLOW\0"};
static char		*VipEmsg06 = {"COMMUNICATIONS ERROR\0"};
static char		*VipEmsg07 = {"DATA OVERFLOW\0"};
static char		*VipEmsg08 = {"DIGIT FIELD\0"};
static char		*VipEmsg09 = {"ENTRY REQUIRED\0"};
static char		*VipEmsg10 = {"FILL REQUIRED\0"};
static char		*VipEmsg11 = {"INVALID COMMAND\0"};
static char		*VipEmsg12 = {"NUMERIC FIELD\0"};
static char		*VipEmsg13 = {"PRINT ABORTED\0"};
static char		*VipEmsg14 = {"PRINTER BUFFER OVERFLOW\0"};
static char		*VipEmsg15 = {"PRINTER BUSY\0"};
static char		*VipEmsg16 = {"PRINTER BUSY/FAULT\0"};
static char		*VipEmsg17 = {"PRINTER FAULT\0"};
static char		*VipEmsg18 = {"PRINTER INVALID COMMAND\0"};
static char		*VipEmsg19 = {"PRINTER INVALID DEVICE\0"};


void ProcessVip7801( int c );
void VIP7801SKeys( int k );
void Vip7801Tab( void );
void DisplayVipStatus( void );

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void ProcessVip7801( int c )
{
  static int 		i;

  c &= 0x00ff;
  switch( TFlag )  {

	case 0:                            // Is TFlag = 0?

		if ( c == ESCAPE )  {
			for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
				TFp[TFlag1] = 0;
			TFlag = 1;
			TFlag1 = 0;
			return;
		}
		switch( c )  {

			case 0:
			case 0x7f:

				break;

			case 1:
			case 2:
			case 3:
			case 4:
/*				ScreenCharOut( c );	*/
				break;

			case 5:

				SerialString( Vip7801Id2 );
				break;

			case 6:
				ScreenCharOut( c );
				break;

			case 7:

				Beep( 500 );
				break;

			case 8:

				if ( VTc > 1 )  {
					VTc--;
				}
				break;

			case 9:                                              // HT ^I

				for ( i = 0; i < 8; i++ )  {
					VTc++;
				}
				break;

			case 10:

				if ( ++VTr > VTwb )  {
					VTr--;
					ScrollWindowUp( 1 );
				}
				break;

			case 11:

				ScreenCharOut( c );
				break;

			case 12:                                  // Form Feed

				EraseScreen( VTwt, 1, VTwb, 80 );
				VTc = 1;
				VTr = 1;
				break;

			case 13:

				VTc = 1;
				if ( AUTOLF )  {
					if ( ++VTr > VTwb )  {
						VTr--;
						ScrollWindowUp( 1 );
					}
				}
				break;

			case 14:
			case 15:
			case 16:
			case 17:
			case 18:
			case 19:
			case 20:
			case 21:
			case 22:
			case 23:
			case 24:
			case 26:
			case 27:

				for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
					TFp[TFlag1] = 0;
				TFlag = 1;
				TFlag1 = 0;
				return;

			case 28:
			case 29:
			case 30:
			case 31:

				ScreenCharOut( '^' );
				ScreenCharOut( c );
				break;

			default:

				if ( VIPHIDE )
					ScreenCharOut( ' ' );
				else
					ScreenCharOut( c );
				break;
		}
		break;

	case 1:                            // Is TFlag = 1?

		switch( c )  {

			case 27:
				return;

			case '[':

				TFlag = 2;
				TFlag1 = 0;
				return;

			case 'A':                       // Cursor Up

				if ( --VTr < VTwt )  {
					VTr = VTwb;
/*					ScrollWindowDown( 1 );  */
				}
				break;

			case 'B':			// Cursor Down

				if (++VTr > VTwb)  {
					VTr = VTwt;
/*					ScrollWindowUp( 1 );  */

				}
				break;

			case 'C':			// Cursor Forward

				if ( VTc < 80 )
					VTc++;
				else
				if ( ++VTr > VTwb )  {
					VTr = VTwt;
					VTc = 1;
				}
				else  {
					VTc = 1;
				}
				break;

			case 'D':			// Cursor Backward

				if ( VTc > 1 )
					VTc--;
				else
				if ( --VTr < VTwt )  {
					VTr = VTwb;
					VTc = 80;
				}
				else  {
					VTc = 80;
				}
				break;

			case 'F':     			// Graphics Reset

/*				if (VIPMODE != GRAPHMODE)
					break;
				else
					VIPMODE = CHARMODE;  */
				break;

			case 'G':			// Graphics Set

				VIPMODE = GRAPHMODE;
				TFlag = 10;
				return;

			case 'H':			// Cursor Home

				VTc = 1;
				VTr = 1;
				break;

			case 'I':			// Transmit Next Block

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			case 'J':			// Erase End of Page

				EraseScreen( VTr, VTc, VTwb, 80 );
				break;

			case 'K':			// Erase end of Field

				EraseScreen( VTr, VTc, VTr, 80 );
				break;

			case 'M':			// Set Transmission Pointer

				break;

			case 'O':			// Status Line Lock
							// Leave Msg on status line
				if ( VTr >= 25 )	// Ignore if cursor not on stsus line
					break;
				if ( SVTc != 0 )
					VTc = SVTc;
				if ( SVTr != 0 )
					VTr = SVTr;
				VTwt = 1;
				VTwb = 24;
				break;

			case 'X':			// Right Justify Fill
			case 'Y':			// Reset Modify Indicators
			case 'Z':			// Test Results Display

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case '`':			// Clear Screen

				VTwt = 1;
				VTwb = 24;
				EraseScreen( VTwt, 1, 25, 80);
				VTr = VTwt;
				VTc = 1;
				TFlag = 0;
				if ( VIPMODE == FORMSMODE )
					VIPMODE = TEXTMODE;
				else
					VIPMODE = CHARMODE;
				for ( i = 0; i < 24; i++ )	{
					VipAttrCnt[i] = 0;
					for ( VipAPtr = 0; VipAPtr < 80; VipAPtr++ )
						VipAttrTab[i][VipAPtr] = 0;
				}
				VipAPtr = 0;

				VIP_STS_LINE_IN_USE = FALSE;
				break;

			case 'a':     			// Auxillary Port Connect
			case 'b':			// Auxillary Port Disconnect

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'c':			// Reset to initial state

				VTa = 0x02;
				VIPMODE = CHARMODE;
				ECHOON = FALSE;
				ROLL = TRUE;
				VTc = 1;
				VTr = 1;
				VTwt = 1;
				VTwb = 24;
				fsfill( 25, 1, 1, 80, ' ', VTa );
				for ( i = 0; i < 24; i++ )	{
					VipAttrCnt[i] = 0;
					for ( VipAPtr = 0; VipAPtr < 80; VipAPtr++ )
						VipAttrTab[i][VipAPtr] = 0;
				}
				VIP_STS_LINE_IN_USE = FALSE;
				break;

			case 'd':			// Auxillary Port Parallel

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'e':			// Reset

				VIPHIDE = FALSE;
				if ( SVTc != 0 )
					VTc = SVTc;
				if ( SVTr != 0 )
					VTr = SVTr;
				VTwt = 1;
				VTwb = 24;
				fsfill( 25, 1, 1, 80, ' ', VTa );
				VIP_STS_LINE_IN_USE = FALSE;
				break;

			case 'f':			// Cursor Position Binary

				TFlag = 3;
				return;

			case 'i':			// Transmit Data

				ScreenCharOut( ESCAPE );
				ScreenCharOut( c );
				break;

			case 'k':			// Character Mode

				VIPMODE = CHARMODE;
				break;

			case 'l':			// Non Echo-Plex

				ECHOON = TRUE;
				break;

			case 'm':			// Echo-Plex

				ECHOON = FALSE;
				break;

			case 'n':			// Cursor Request Binary

				sprintf( CURRPT, "\033f%c%c\0", ( VTc + 31 ), ( VTr + 31 ) );
				SerialString( CURRPT );
				break;

			case 'p':			// Tab Set

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'q':			// Roll Mode Reset

				ROLL = FALSE;
				break;

			case 'r':			// Roll Mode Set

				ROLL = TRUE;
				break;

			case 's':     			// Attribute Function Code follows

				TFlag = 4;
				return;

			case 't':			// Transmit All

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'v':			// Status Line Reset

				if ( SVTc != 0 )
					VTc = SVTc;
				if ( SVTr != 0 )
					VTr = SVTr;
				VTwt = 1;
				VTwb = 24;
				fsfill( 25, 1, 1, 80, ' ', VTa );
				VIP_STS_LINE_IN_USE = FALSE;
				break;

			case 'w':			// Status Line Set

				SVTc = VTc;
				SVTr = VTr;
				SVTwb = VTwb;
				SVTwt = VTwt;
				VTr = 25;
				VTc = 1;
				VTwt = 25;
				VTwb = 25;
				VIP_STS_LINE_IN_USE = TRUE;
				EraseScreen( VTr, VTc, VTr, 80 );
				break;

			case 'z':			// Firmware Version Display
							// We shouldn't need this
				break;

			default:

				ScreenCharOut( ESCAPE );
				ScreenCharOut( c );
				break;
		}
		TFlag = 0;
		break;

	case 2:                     // Is TFlag = 2?

		switch( c )  {

			case 'A':			// Transmit on Return Reset

				VIP_TRR = FALSE;
				break;

			case 'B':			// Transmit on Return Set

				VIP_TRR = TRUE;
				break;

			case 'E':			// Reset Block Mode
			case 'F':			// Set Block Xmit

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'H':			// Data Space Home

				VTr = 1;
				VTc = 1;
				break;

			case 'I':			// Insert Mode
			case 'J':			// Insert Mode Reset

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			case 'L':               	// Insert Line

				ScrollWindowDown( 1 );
				break;

			case 'M':			// Delete Line

				ScrollWindowUp( 1 );
				break;

			case 'N':			// Tab Initialize

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			case 'P':			// Delete Character

				ScreenCharOut( ' ' );
				break;

			case 'Q':			// Delete Attribute

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			case 'R':			// Cursor Request Decimal

				sprintf( CURRPT, "\033[%d%df", VTc, VTr );
				SerialString( CURRPT );
				break;

			case 'S':			// Block Transmit Automatic
			case 'T':			// Block Xmit on Command
			case 'U':			// Process Before Verify
			case 'V':			// Verify Before Process

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			case 'W':			// Keyboard Unlock

				VIP_KBLOCKD = FALSE;
				break;

			case 'X':			// Keyboard Lock

				VIP_KBLOCKD = TRUE;
				break;

			case 'Z':			// Cursor BackTab

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			case 'd':			// Space Suppress Reset

				VIP_SP_SUPRES = FALSE;
				break;

			case 'e':			// Space Suppress Set

				VIP_SP_SUPRES = TRUE;
				break;

			case 'f':			// Cursor Position Decimal
			case 'g':			// Tab Clear

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			case 'h':			// Forms Mode

				VIPMODE = FORMSMODE;
				break;

			case 'i':			// Restricted Operation Reset
			case 'j':			// Restricted Operation Set

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'l':			// Text Mode

				VIPMODE = TEXTMODE;
				break;

			case 'p':			// Vip Poll Sequence

/*				switch( TFp[0] )  {

					case 8:

						SerialString( Vip7801Id );
						break;

					default:

						break;
				}	*/
				break;

			case 's':			// Scroll Commands for
							// 72 Line Scroll Option Only
				switch(TFp[0])  {

					case 0:			// Scroll Up
					case 1:			// Scroll Down
					case 2:			// Next Segment
					case 3:			// Previous Segment

						ScreenCharOut( '^' );
						ScreenCharOut( '[' );
						ScreenCharOut( '[' );
						ScreenCharOut( c );
						break;

					default:

						ScreenCharOut( '^' );
						ScreenCharOut( '[' );
						ScreenCharOut( '[' );
						ScreenCharOut( c );
						break;
				}
				break;

			case 'x':				// NOP

				break;

			case 'y':				// Delayed ENQ

				SerialString( Vip7801Id );
				break;

			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':

				TFp[TFlag1] *= 10;
				TFp[TFlag1] += ( c - '0' );
				return;

			default:

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;
		}
		TFlag = 0;
		break;

	case 3:                          // Is TFlag = 3? - Cursor Pos Binary
		cl = ( c - 31 );
		TFlag = 5;
		return;

	case 4:			// Attribute Change

		if ( VipAttrCnt[( VTr - 1 )] > 15 )    	{
			fswrite( VipEmsg04, 1, 25, LightGreen+BlackBG );
			Beep( 500 );
			break;
		}

		switch( c )  {

			case 'A':	// Alpha only

				break;

			case 'B':	// Blink

				VTa = ( VTa | 0x80 );
				break;

			case 'D':	// Digits Only
			case 'E':	// Entry Required
			case 'F':	// Fill Required

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'H':	// Hide

				VipAttrTab[VTr][VTc] |= VHIDE;
				VipAttrCnt[( VTr - 1 )] += 1;
				fsattr( VTr, VTc, VTr, ( 80 - VTc ), 0x00 );
				VIPHIDE = TRUE;
				break;

			case 'I':	// Inverse
			case 'J':	// Justify Right

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case 'L':	// Low Intenesity

				VTa = 0x02;
				break;

			case 'M':	// Modified Transmit
			case 'N':	// Numeric Only
			case 'O':	// Omit Print
			case 'P':	// Protected Field

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;

			case '_':	// Underline

				VTa = 0x20;	// Do a reverse video
				break;

			case 'R':	// Restore Attribute

				VIPHIDE = FALSE;
				VTa = 0x02;
				break;

			case 'S':	// Do not EVER use
			case 'T':	// Transmit Always
			case 'U':	// Unprotected

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );
				break;

			default:	// Hopefully it didn't come to this

				ScreenCharOut( '^' );
				ScreenCharOut( '[' );
				ScreenCharOut( '[' );
				ScreenCharOut( c );

				break;
		}
		TFlag = 0;
		break;

	case 5:				// Last part of CPB

		VTc = cl;
		VTr = ( c - 31 );
		TFlag = 0;
		break;

	case 10:				// Line Graphics Mode

		SVTa = VTa;
		switch( c )  {

			case 27:

				TFlag = 11;
				return;

			case 13:

				VTc = 1;
				break;

			/* Normal Intensity Graphics */

			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':

				if ( ( VTc == 1 ) || ( VTc == 81 ) )	{
					Beep( 500 );
					break;
				}
				VTa = 0x0a;
				ScreenCharOut( vipgchars[( c - 65 )] );
				break;

				/* Low Intensity Graphics */

			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '[':

				if ( ( VTc == 1 ) || ( VTc == 81 ) )	{
					Beep( 500 );
					break;
				}
				VTa = 0x02;
				ScreenCharOut( vipgchars[( c - 81 )] );
				break;

				/* Blink-Normal Intensity Graphics */

			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':

				if ( ( VTc == 1 ) || ( VTc == 81 ) )	{
					Beep( 500 );
					break;
				}
				VTa = 0x8a;
				ScreenCharOut( vipgchars[( c - 97 )] );
				break;

				/* Blink-Low Intensity Graphics */

			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':
			case '{':

				if ( ( VTc == 1 ) || ( VTc == 81 ) )	{
					Beep( 500 );
					break;
				}
				VTa = 0x82;
				ScreenCharOut( vipgchars[( c - 113 )] );
				break;

			case ' ':

				ScreenCharOut( c );
				break;

			default:

				Beep( 500 );
				break;
		}
		VTa = SVTa;
		break;

	case 11:

		switch( c )  {
			case 'F':		// Reset Graphics Mode
				VIPMODE = CHARMODE;
				TFlag = 0;
				break;
			default:
				TFlag = 10;
				return;
		}

		break;
  }
}



/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void VIP7801SKeys( int k )
{
	k &= 0x00ff;
	switch( k )  {

		case F1:  SerialString( vipF01 ); break;
		case F2:  SerialString( vipF02 ); break;
		case F3:  SerialString( vipF03 ); break;
		case F4:  SerialString( vipF04 ); break;
		case F5:  SerialString( vipF05 ); break;
		case F6:  SerialString( vipF06 ); break;
		case F7:  SerialString( vipF07 ); break;
		case F8:  SerialString( vipF08 ); break;
		case F9:  SerialString( vipF09 ); break;
		case F10: SerialString( vipF10 ); break;
		case F11: SerialString( vipF11 ); break;
		case F12: SerialString( vipF12 ); break;
		case UP: SerialString( vipUP ); break;
		case DN: SerialString( vipDN ); break;
		case LEFT: SerialString( vipLEFT ); break;
		case RIGHT: SerialString( vipRIGHT ); break;
		case END: SerialString( vipEEOF ); break;
		case DELETE: SerialString( vipDEL ); break;
		case HOME: SerialString( vipHOME ); break;
		case INS:
			if (INSMODE)  {
				SerialString( vipINSR );
				fswrite( "   ", 25, 68, VTa);
				INSMODE = FALSE;
			}
			else  {
				SerialString( vipINS );
				fswrite( "INS", 25, 68, VTa );
				INSMODE = TRUE;
			}
			break;
		case STAB: SerialString(vipFBTAB); break;
		case CTLLEFT: SerialString(vipWBTAB); break;
		case CTLRIGHT: SerialString(vipWTAB); break;
		case CTLDEL: SerialString(vipWDEL); break;
		case F13: SerialString(vipFS01); break;
		case F14: SerialString(vipFS02); break;
		case F15: SerialString(vipFS03); break;
		case F16: SerialString(vipFS04); break;
		case F17: SerialString(vipFS05); break;
		case F18: SerialString(vipFS06); break;
		case F19: SerialString(vipFS07); break;
		case F20: SerialString(vipFS08); break;
		case F21: SerialString(vipFS09); break;
		case F22: SerialString(vipFS10); break;
		case F23: SerialString(vipFS11); break;
		case F24: SerialString(vipFS12); break;
		default: break;
	}
  return;
}


void Vip7801Tab( void )
{
	  SerialString( vipFTAB );
}

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void DisplayVipStatus( void )
{
	if ( !VIP_STS_LINE_IN_USE )		{
		if ( VIPLOCAL )	{
			fswrite( VipMsg03, 25, 1, LightGreen+BlackBG );
		}
		else	{
			if ( !VIP_KBLOCKD )
				fswrite( VipMsg01, 25, 1, Green+BlackBG );
			else
				fswrite( VipMsg02, 25, 1, LightGreen+BlackBG );
		}
		if ( AUTOLF )
			fswrite( VipMsg04, 25, 55, LightGreen+BlackBG );
		else
			fswrite( "       ", 25, 55, LightGreen+BlackBG );
		if ( VTc == 81 )  {
			sprintf( buff, "%03d", VTr );
			fswrite( buff, 25, 74, Green+BlackBG );
			sprintf( buff, "%03d", VTc );
			fswrite( buff, 25, 78, LightGreen+BlackBG );
		}
		else  {
			sprintf( buff, "%03d %03d", VTr, VTc );
			fswrite( buff, 25, 74, Green+BlackBG );
		}
		switch( VIPMODE )  {

			case CHARMODE:
				fswrite( "CHAR ", 25, 30, Green+BlackBG );
				break;

			case FORMSMODE:

				fswrite( "FORM ", 25, 30, Green+BlackBG );
				break;

			case TEXTMODE:

				fswrite( "TEXT ", 25, 30, Green+BlackBG );
				break;

			case GRAPHMODE:

				fswrite( "GRAPH", 25, 30, Green+BlackBG );
				break;

			default:

				fswrite( "!GOOD", 25, 30, Green+BlackBG );
				break;

		}
		if ( !ECHOON )
			fswrite( "ECHO", 25, 37, Green+BlackBG );
		else
			fswrite( "    ", 25, 37, Green+BlackBG );

		if ( ROLL )
			fswrite( "ROLL", 25, 43, Green+BlackBG );
		else
			fswrite( "    ", 25, 43, Green+BlackBG );
	}
	return;
}