
/*
		---------------------------------------
			    PowerTerm v1.0
		PowerTerm (c) 1992-93  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <conio.h>

#define 	ESC 	0x1B
#define 	mTTY 	  0x00
#define 	mVT52 	  0x01
#define 	mVT102 	  0x02
#define 	mANSI 	  0x03
#define		mAVATAR   0x04
#define		mTEK4107C 0x05

#define 	FALSE 	0
#define 	TRUE   	(!FALSE)

#define vt52Id     	"\033/Z\0"              // VT52 Mode Ident String
#define vt102Id    	"\033[?6c\0"            // VT102 Mode Ident String
#define hth19      	"\033/K\0"              // Heath-19 Mode Ident String

extern char 		CURRPT[10];                // Response to ESC[?6n
extern char 		vt102SU[10];
extern char 		*buff;
extern int            	VideoSeg;
extern int            	VTc, VTr, VTa, VTwt, VTwb;
extern int            	PrtFlag, fc;

extern int		NUMLOCK, LFON;
extern unsigned int	EmuMode;

extern union REGS 	xr;

void ProcessVT102( int c );

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void ProcessVT102( int c )
{
	static int		TFlag = 0;
	static int		TFlag1 = 0;
	static int		TFp[10];
	static int 		i;
	static int		j;
	static unsigned int 	atr;
	static int 	       	lc, rw, cl, savch;
	static int		SVTc, SVTr, SVTa;

	c &= 0x00ff;

  switch( TFlag )  {

	case 0:                            // Is TFlag = 0?

		if ( c == ESC )  {
			for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
				TFp[TFlag1] = 0;
			TFlag = 1;
			TFlag1 = 0;
			return;
		}
		switch( c )  {

			case 0:

				ScreenCharOut(' ');
				break;

			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:

				ScreenCharOut( c );
				break;

			case 7:

				Beep( 300 );
				break;

			case 8:

				if ( VTc > 1 )  {
					VTc--;
				}
				break;

			case 9:                                              // HT ^I

				for ( j = 0; j < 8; j++)  {
					VTc++;
				}
				break;

			case 10:

				if ( ++VTr > VTwb )  {
					VTr--;
					ScrollWindowUp( 1 );
				}
				break;

			case 11:

				ScreenCharOut( c );
				break;

			case 12:                                  // Form Feed

				EraseScreen( VTwt, 1, VTwb, 80 );
				VTc = 1;
				VTr = VTwt;
				if ( ++VTr > VTwb )  {
					VTr--;
					ScrollWindowUp( 1 );
				}
				break;

			case 13:

				VTc = 1;
				if ( LFON )	{
					if (++VTr > VTwb)  {
						VTr--;
						ScrollWindowUp( 1 );
					}
				}
				break;

			case 14:	// Select G1 Character Set
			case 15:	// Select G0 Character Set

				break;

			case 16:
			case 17:
			case 18:
			case 19:
			case 20:
			case 21:
			case 22:
			case 23:

				ScreenCharOut( '^' );
				ScreenCharOut( c );
				break;

			case 24:
			case 26:

				TFlag = 0;	// Cancel sequence
				break;

			case 25:

				ScreenCharOut( '^' );
				ScreenCharOut( c );
				break;

			case 27:

				for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
					TFp[TFlag1] = 0;
				TFlag = 1;
				TFlag1 = 0;
				return;

			case 28:
			case 29:
			case 30:
			case 31:
			default:
				ScreenCharOut(c);
				break;
	}
	break;

    case 1:                            // Is TFlag = 1?

	switch( c )  {

		case 24:		// Cancel Sequence
		case 26:

			TFlag = 0;
			break;

		case 27:
			return;

		case '^':

			TFlag = 6;
			return;

		case '[':

			TFlag=2;
			TFlag1=0;
			return;

		case '(':
		case ')':

			TFlag = 3;
			return;

		case 0x12:

			TFlag=0;
			break;

		case 'E':

			VTc = 1;
			if ( ++VTr > VTwb )  {
				VTr = VTwb;
				ScrollWindowUp( 1 );
			}
			break;

		case 'D':

			if ( ++VTr > VTwb )  {
				VTr = VTwb;
				ScrollWindowUp( 1 );
			}
			break;

		case 'H':			// Set Tab

			break;

		case 'M':

			if (--VTr < VTwt)  {
				VTr=VTwt;
				ScrollWindowDown(1);
			}
			break;

		case 'Z':

			SerialString(vt102Id);
			break;

		case 'c':
		case '{':			// Keyboard Enable
		case '}':			// Keyboard Disable

			break;

		case '=':

			ToggleNumLock(1);
			SerialString(vt102SU);
			break;

		case '>':

			ToggleNumLock( 0 );
			break;

		case '<':			// Enter ANSI Mode

			EmuMode = mANSI;
			break;

		case '7':

			SVTr=VTr;
			SVTc=VTc;
			SVTa=VTa;
			break;

		case '8':

			VTr=SVTr;
			VTc=SVTc;
			VTa=SVTa;
			break;

		case '#':
			TFlag=4;
			return;

		default:

			ScreenCharOut( ESC );
			ScreenCharOut( c );
			break;
	}
	TFlag=0;
	break;

    case 2:                     // Is TFlag = 2?

	switch(c)  {

		case '@':		// Ansi insert n spaces

			break;

		case 24:		// Cancel Sequence
		case 26:

			TFlag = 0;
			break;

		case 'A':

			if ( TFp[0] == 0 ) TFp[0] = 1;
			while( TFp[0]-- > 0 )
				if ( VTr > VTwt )  VTr--;
			break;

		case 'B':

			if ( TFp[0] == 0 ) TFp[0] = 1;
			while( TFp[0]-- > 0 )
				if ( VTr < VTwb )  VTr++;
			break;

		case 'C':

			if ( TFp[0] == 0 ) TFp[0] = 1;
			while( TFp[0]-- > 0 )
				if ( VTc < 80)  VTc++;
			break;

		case 'D':

			if ( TFp[0] == 0 ) TFp[0] = 1;
			while( TFp[0]-- > 0 )
				if ( VTc > 1 )  VTc--;
			break;

		case 'f':
		case 'H':

			if ( TFp[0] == 0 )  TFp[0] = 1;
			if ( TFp[1] == 0 )  TFp[1] = 1;
			VTr = TFp[0];
			VTc = TFp[1];
			if ( VTr >= 25 )
				VTr = 24;
			break;

		case 'J':

			switch(TFp[0])  {
				case 0: EraseScreen(VTr,VTc,VTwb,80); break;
				case 1: EraseScreen(VTwt,1,VTr,VTc); break;
				case 2:
					EraseScreen(VTwt,1,VTwb,80);
					VTr=VTwt;
					VTc=1;
					break;
			}
			break;

		case 'K':

			switch(TFp[0])  {
				case 0: EraseScreen(VTr,VTc,VTr,80); break;
				case 1: EraseScreen(VTr,1,VTr,VTc); break;
				case 2: EraseScreen(VTr,1,VTr,80); break;
			}
			break;

		case 'L':

			ScrollWindowDown( 1 );
			break;

		case 'M':

			if ( TFp[0] == 0 )
				TFp[0] = 1;
			while( TFp[0]-- > 0 )	{
/*				EraseScreen( VTr, 1, VTr, 80 );	*/
				ScrollWindowUp( 1 );
			}
			break;

		case 'P':

			break;

		case 'R':

			break;

		case 'c':		// Device Attributes

			SerialString( "\033[?6c\0" );
			break;

		case 'g':		// Tabs Clear 0 or 3

			break;

		case 'h':		// Insert Mode On (4) NewLine (20)
		case 'l':		// Insert Mode Off (4) New Line (20)

			break;

		case 'i':

			switch( TFp[0] ) {

				  /* p1=0  print whole screen */

				case 0:

					break;

				  /* p1=4  exit transparent printer */

				case 4:

					PrtFlag = 0;
					break;

				  /* p1=5  enter transparent printer */

				case 5:

					PrtFlag = 2;
					break;
			}
			break;

		case 'm':

			i = 0;
			do  {
				switch(TFp[i]) {
					case 0: VTa=0x07;
						break;    // Reset to Normal
					case 1: VTa |= 8;
						break;    // High Colors On
					case 4: VTa=0x70;
						break;    // Set Reverse Video
					case 7: VTa=0x70;
						break;    // Set Reverse Video
					case 5: VTa |= 0x80;
						break;  // Set Blink Bit On
					case 3:         // 3 & 6 Not
							// Supported
					case 6:
						break;
					default:
						if(TFp[i] >= 40 && TFp[i] <=47)
							VTa=VTa & 0x87 | ((TFp[i] & 7) << 4);
						else
						if(TFp[i] >= 30 && TFp[i] <= 37)
							VTa=VTa & 0xf8 | (TFp[i] & 7);
						break;
				}
			} while (++i <= TFlag1);
			break;
		case 'n':
		case 'q':
			break;
		case 'r':
			if (TFp[0]==0) TFp[0]=1;
			if (TFp[1]==0) TFp[1]=24;
			if (TFp[1]<=TFp[0])
				break;
			VTwt=TFp[0];
			VTwb=TFp[1];
			break;

		case 'x':
		case 'y':

			break;

		case '?':

			TFlag = 5;
			return;

		case ';': ++TFlag1; return;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			TFp[TFlag1] *= 10;
			TFp[TFlag1] += (c-'0');
			return;
	}
	TFlag=0;
	break;

    case 3:                          // Is TFlag = 3?

	TFlag = 0;
	break;

    case 4:

	TFlag = 0;
	break;

    case 5:

	switch(c)  {

		case 'h':		// Enter Tek mode

			if ( ( TFp[0] == 3 ) && ( TFp[1] == 8 ) )	{

				// Start Tek Graphics

				TFlag = 0;
			}
			break;

		case 'l':		// Exit Tek mode

			if ( ( TFp[0] == 3 ) && ( TFp[1] == 8 ) )	{

				// End Tek Graphics

				TFlag = 0;
			}
			break;

		case 'i':

			switch( TFp[0] )	{

				    /* p1=1  print cursor line */

				case 1:

					break;

				    /* p1=4  exit printer echo */

				case 4:

					PrtFlag = 0;
					break;

				    /* p1=5  enter printer echo */

				case 5:

					PrtFlag = 1;
					break;
			}
			break;

		case ';':

			++TFlag1;
			return;

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			TFp[TFlag1] *= 10;
			TFp[TFlag1] += (c-'0');
			return;
	}
	TFlag = 0;
	break;

    case 6:

	TFlag = 0;
	break;
  }
}

