
//
//		---------------------------------------
//						PowerTerm v0.4
//		PowerTerm (c) 1996  Byron D Copeland
//					All Rights Reserved.
//		---------------------------------------
//

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include "prototyp.h"

#define 	ESC 		   0x1B
#define 	mTTY 	  		0x00
#define 	mVT52 		0x01
#define 	mVT102 		0x02
#define 	mANSI 		0x03
#define	mAVATAR   	0x04
#define	mTEK4107C 	0x05

#define 	FALSE 		0
#define 	TRUE   		(!FALSE)
#define vt102Id    	"\033[?6c\0"            // VT102 Mode Ident String
#define hth19      	"\033/K\0"              // Heath-19 Mode Ident String

extern char 			CURRPT[10];                // Response to ESC[?6n

extern char 			*buff;
extern int           VTc, VTr, VTa, VTwt, VTwb;
extern int           PrtFlag, fc;

extern int				NUMLOCK;
extern int				LFON;
extern unsigned int	EmuMode;

unsigned char	 		vt52Id[4]="\033/Z\0";
static int				TFlag = 0;
static int				TFlag1 = 0;
static int				TFp[10];
static int				SVTr;
static int				SVTc;
static int				SVTa;

void ProcessVT52( int c );

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void ProcessVT52( int c )
{
	int 					i;
	int						j;
	unsigned int 		atr;

	c &= 0x00ff;
	switch( TFlag )  {

		case 0:                            // Is TFlag = 0?

			if ( c == ESC )  {
				for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
					TFp[TFlag1] = 0;
				TFlag = 1;
				TFlag1 = 0;
				return;
			}
			switch( c )  {
				case 0:														// NULL

//					ScreenCharOut( ' ' );
					break;

				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:

					ScreenCharOut( c );
					break;

				case 7:

					Beep( 300 );
					break;

				case 8:

					if ( VTc > 1 )  {
						VTc--;
						gotoxy( VTc,VTr );
					}
					break;

				case 9:                                              // HT ^I

					for ( j = 0; j < 7; j++ )
						VTc++;
					gotoxy( VTc, VTr );
					break;

				case 10:

					if ( ++VTr > VTwb )  {
						VTr--;
						ScrollWindowUp( 1 );
					}
					gotoxy( VTc, VTr );
					break;

				case 11:

					ScreenCharOut( c );
					break;

				case 12:                                  // Form Feed

					EraseScreen( VTwt, 1, VTwb, 80 );
					VTc = 1;
					VTr = 1;
					gotoxy( VTc, VTr );
//					if (++VTr > VTwb)  {
//						VTr--;
//						ScrollWindowUp(1);
//					}
//					gotoxy(VTc,VTr);
					break;

				case 13:

					VTc = 1;
					if ( LFON )	{
						if ( ++VTr > VTwb )  {
							VTr--;
							ScrollWindowUp( 1 );
						}
					}
					break;

				case 14:
				case 15:
				case 16:
				case 17:
				case 18:
				case 19:
				case 20:
				case 21:
				case 22:
				case 23:
				case 24:
				case 26:
				case 27:

					for ( TFlag1 = 0; TFlag1 < 10; TFlag1++ )
						TFp[TFlag1] = 0;
					TFlag = 1;
					TFlag1 = 0;
					return;

				case 28:
				case 29:
				case 30:
				case 31:
				default:

					ScreenCharOut( c );
					break;
			}
			break;

		case 1:                            // Is TFlag = 1?

			switch( c )  {

				case 0x12:
					TFlag = 0;
					break;

				case 'A':

					if ( --VTr < VTwt )  {
						VTr = VTwt;
						ScrollWindowDown(1);
					}
					gotoxy( VTc, VTr );
					break;

				case 'B':

					if ( ++VTr > VTwb )  {
						VTr = VTwb;
						ScrollWindowUp(1);
					}
					gotoxy( VTc, VTr );
					break;

				case 'C':

					if( VTc < 80 )  {
						VTc++;
						gotoxy( VTc, VTr );
					}
					break;

				case 'D':

					if ( VTc > 1 )  {
						VTc--;
						gotoxy( VTc, VTr );
					}
					break;

				case 'H':

					VTc = 1;
					gotoxy( VTc, VTr );
					break;

				case 'M':

					if ( --VTr < VTwt )  {
						VTr = VTwt;
						ScrollWindowDown( 1 );
					}
					break;

				case 'Z':

					SerialString( vt52Id );
					break;

				case 'c':
				case '=':
				case '>':
					break;

				case '7':

					SVTr = VTr;
					SVTc = VTc;
					SVTa = VTa;
					break;

				case '8':

					VTr = SVTr;
					VTc = SVTc;
					VTa = SVTa;
					break;

				case '#':

					TFlag = 4;
					return;

				default:

					ScreenCharOut( ESC );
					ScreenCharOut( c );
					break;
			}
			TFlag = 0;
			break;

		case 2:                     // Is TFlag = 2?

			switch( c )  {

				case '@':

					break;

				case 'A':

					if ( TFp[0] == 0 )
						TFp[0] = 1;
						while( TFp[0]-- > 0 )
							if ( VTr > VTwt)
								VTr--;
					break;

				case 'B':

					if ( TFp[0] == 0 )
						TFp[0] = 1;
						while( TFp[0]-- > 0 )
						if ( VTr < VTwb )
							VTr++;
					break;

				case 'C':

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					while( TFp[0]-- > 0 )
						if ( VTc < 80 )
							VTc++;
					break;

				case 'D':

					if ( TFp[0] == 0 )
						TFp[0]=1;
					while( TFp[0]-- > 0 )
						if ( VTc > 1 )
							VTc--;
					break;

				case 'f':
				case 'H':

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					if ( TFp[1] == 0 )
						TFp[1] = 1;
					VTr = TFp[0];
					VTc = TFp[1];
					gotoxy( VTc, VTr );
					break;

				case 'J':

					switch( TFp[0] )  {

						case 0:

							EraseScreen( VTr, VTc, VTwb, 80 );
							break;

						case 1:

							EraseScreen( VTr, 1, VTr, VTc );
							break;

						case 2:

							EraseScreen( VTwt, 1, VTwb, 80 );
							break;
					}
					break;

				case 'K':

					switch( TFp[0] )  {

						case 0:

							EraseScreen( VTr, VTc, VTr, 80 );
							break;
						case 1:

							EraseScreen( VTr, 1, VTr, VTc );
							break;

						case 2:
							EraseScreen( VTr, 1, VTr, 80 );
							break;
					}
					break;

				case 'L':

					ScrollWindowDown( 1 );
					break;

				case 'M':
				case 'P':
				case 'R':
				case 'c':
				case 'g':
				case 'h':
				case 'l':
					break;

				case 'i':

					switch( TFp[0] ) {
				  /* p1=0  print whole screen */

						case 0:
							break;

				  /* p1=4  exit transparent printer */
						case 4:

							PrtFlag = 0;
							break;

				  /* p1=5  enter transparent printer */
						case 5:
							PrtFlag = 2;
							break;
					}
					break;

				case 'm':

					i = 0;
					do  {
						switch( TFp[i] ) {

							case 0:

								VTa = 0x07;
								break;    // Reset to Normal

							case 1:

								VTa |= 8;
								break;    // High Colors On

							case 4:

								VTa=0x70;
								break;    // Set Reverse Video

							case 7:

								VTa=0x70;
								break;    // Set Reverse Video

							case 5:

								VTa |= 0x80;
								break;  // Set Blink Bit On

							case 3:         // 3 & 6 Not Supported
							case 6:
								break;

							default:

								if( TFp[i] >= 40 && TFp[i] <=47 )  {
									atr = TFp[i] - 40;
									switch( atr )  {

										case 1:
											atr = 4;
											break;

										case 3:
											atr = 6;
										break;

										case 4:
											atr = 1;
											break;

										case 6:
											atr = 3;
											break;
									}
									VTa = ( VTa & 0x87 ) | ( atr << 4 );
									// VTa=VTa & 0x87 | ((TFp[i] & 7) << 4);  */
								}
								else
								if( TFp[i] >= 30 && TFp[i] <= 37 )  {
									atr = TFp[i] - 30;
									switch( atr )  {

										case 1:
											atr = 4;
											break;

										case 3:
											atr = 6;
											break;

										case 4:
											atr = 1;
											break;

										case 6:
											atr = 3;
											break;
									}
									VTa = ( VTa & 0xf8 ) | atr;
									// VTa=VTa & 0xf8 | (TFp[i] & 7); */
								}
								break;
						}
					} while ( ++i <= TFlag1 );
					break;

				case 'n':
				case 'q':
				case 'r':

					if ( TFp[0] == 0 )
						TFp[0] = 1;
					if ( TFp[1] ==0 )
						TFp[1] = 24;
					if ( TFp[1] <= TFp[0] )
						break;
					VTwt = TFp[0];
					VTwb = TFp[1];
					break;

				case 'x':
				case 'y':
					break;

				case '?':

					TFlag=5;
					return;

				case ';':

					++TFlag1;
					return;

				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':

					TFp[TFlag1] *= 10;
					TFp[TFlag1] += ( c - '0' );
					return;
			}
			TFlag=0;
			break;

		case 3:                          // Is TFlag = 3?
			TFlag = 0;
			break;

		case 4:
			TFlag = 0;
			break;

		case 5:

			switch( c )  {

				case 'h':

					TFlag = 0;
					break;

				case 'l':

					TFlag = 0;
					break;

				case 'i':

					switch( TFp[0] ) {
					 /* p1=1  print cursor line */

						case 1:

							break;
					 /* p1=4  exit printer echo */
						case 4:

							PrtFlag = 0;
							break;

					 /* p1=5  enter printer echo */
						case 5:

							PrtFlag = 1;
							break;
					}
					break;

				case ';':

					++TFlag1;
					return;

				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':

					TFp[TFlag1] *= 10;
					TFp[TFlag1] += ( c - '0' );
					return;
			}
			TFlag = 0;
			break;
	}
}

